-- Lootster
--
-- Created by Mackenz, Server: Dragonblight
--
-- Acknowledgements to the following people from whom I snaffled code or provided translations:
--
-- Sardonic, LootHog
-- CodeMoose, DepositBox
-- Morok (sargeras), French Translation

-- Constants
LOOTSTER_DATA_LINES		= 17;
LOOTSTER_ROLL_LINES		= 13;

LOOTSTER_VERSION		= "1.2.7"

LOOTSTER_FRAME_HEIGHT	= 16;

LOOTSTER_ENUM_MODE		= { USEDKP=1, USENORM=2 };

LOOTSTER_ENUM_DKP		= { BYDKP=1, BYTIER=2, BYMODIFIED=3 };
LOOTSTER_ENUM_NORM		= { BY1001000=1, BYNEEDGREED=2 };

LOOTSTER_ENUM_NBG		= { NEED=1, GREED=2 };

LOOTSTER_TIER_UNKNOWN	= "99999";

LOOTSTER_CTRACMD_MSG	= "MS ";

-- Bootstrap Saved Variables
Lootster_Options	= {};

Lootster_Options_Default =
{
	Active			= false;
	Passive			= false;
	MiniMap			= true;
	MiniMapPos		= 270;
	Suppress		= false;
	AckRoll			= true;
	AckNoCall		= true;
	AckNoRoll		= true;
	Counter			= true;
	CounterSec		= 5;
	AutoSnoop		= true;
	DebugMsgs		= false;
	EchoRestrict	= true;
	EchoToChat		= true;
	EchoToCTRA		= true;
	EchoByClick		= true;
	EchoByGroupLoot	= true;
	RollMode		= LOOTSTER_ENUM_MODE.USENORM;
	DKPType			= LOOTSTER_ENUM_DKP.BYTIER;
	DKPPrior		= false;
	DKPCaps			= true;
	DKPHi			= 50;
	DKPLo			= 50;
	NormType		= LOOTSTER_ENUM_NORM.BYNEEDGREED;
	CorKRoll		= false;
	CorKOpen		= false;
	CorKClose		= false;
	Sound			= true;
	Updated1900		= false;
};

Lootster_Rules		= {};

Lootster_Rules_Default =
{
	RulesDKP	= "";
	RulesNorm	= "";
};

Lootster_Adjust		= {};

Lootster_Players	= {};

Lootster_Restrict	= {};


-- Global Variables
local	Lootster_AddMessageCB						= nil;		-- Add message callback function

local	Lootster_ChatFrame_OnEventCB				= nil;		-- ChatFrame_OnEvent callback function
local	Lootster_ChatFrame_OnHyperlinkShowCB		= nil;		-- ChatFrame_OnHyperlinkShow callback function
local	Lootster_LootFrameItem_OnClickCB			= nil;		-- LootFrameItem_OnClick callback function
local	Lootster_GroupLootFrame_OnShowCB			= nil;		-- GroupLootFrame_OnShow callback function
local	Lootster_GroupLootFrame_OnEventCB			= nil;		-- GroupLootFrame_OnEvent callback function
local	Lootster_ContainerFrameItemButton_OnClickCB	= nil;		-- ContainerFrameItemButton_OnClick callback function

local   Lootster_Language							= nil;		-- Default language

local   Lootster_Self								= nil;		-- Self
local   Lootster_SelfClass							= nil;		-- Self class
local   Lootster_SelfClassType						= nil;		-- Self class type

local	Lootster_SelfRoll							= 100;		-- Self roll maximum

local	Lootster_Roster								= {};		-- Current roster
local	Lootster_RosterRoll							= {};		-- Current roll roster

local	Lootster_HasDKP								= false;	-- Has DKP enabled flag

local   Lootster_DKP								= {};		-- Current DKP data
local   Lootster_DKPSort							= {};		-- Current DKP data sort
local   Lootster_DKPSortCol							= "Player";	-- Current DKP data sort column (none)
local   Lootster_DKPSortOrd							= true;		-- Current DKP data sort order

local	Lootster_MainALT							= {};		-- Main to Alt Look-aside Table
local	Lootster_ALTMain							= {};		-- Alt to Main Look-aside Table

local	Lootster_ParkSort							= {};		-- Park player sort

local   Lootster_Rolls								= {};		-- Current rolls
local   Lootster_RollsSort							= {};		-- Current rolls sort
local   Lootster_RollsSortCol						= "Roll";	-- Current rolls sort column
local   Lootster_RollsSortOrd						= true;		-- Current rolls sort order

local   Lootster_Tiers								= {};		-- Current tiers
local   Lootster_TiersSort							= {};		-- Current tiers sort
local   Lootster_TiersPrompt						= "";		-- Current tiers prompt

local	Lootster_RollCount							= 0;		-- Roll count
local	Lootster_PlayerCount						= 0;		-- Player count
local	Lootster_RestrictedCount					= 0;		-- Restricted class count

local	Lootster_ItemID								= nil;		-- Item ID
local	Lootster_ItemSlot							= nil;		-- Item slot
local	Lootster_ItemLink							= nil;		-- Item link
local	Lootster_ItemText							= "";		-- Item text
local	Lootster_ItemCount							= 1;		-- Item count to roll on
local	Lootster_ItemPrompt							= "";		-- Item prompt text (with appropriate item count)

local   Lootster_NBG								= nil;		-- Need before Greed
local   Lootster_NBG_ClassPlease					= "";		-- Need before Greed class please text
local   Lootster_NBG_ClassIgnore					= "";		-- Need before Greed class ignore text

local	Lootster_Tied								= false;	-- Tied roll
local	Lootster_TiedRolls							= {};		-- Tied rolls
local	Lootster_TiedRollsSort						= {};		-- Tied rolls sort
local	Lootster_TiedItemCount						= 0;		-- Tied item count to roll on

local	Lootster_ClassIgnore						= "UNKNOWN";-- Class roll ignore

local	Lootster_ClassLower							= {};		-- Class lower/invariant lookup
local	Lootster_ClassPlural						= {};		-- Class plural/invariant lookup
local	Lootster_ClassSingular						= {};		-- Class singular/invariant lookup

local	Lootster_ClassRestricted					= false;	-- Class is restricted
local	Lootster_ClassRestrictedLock				= false;	-- Class is restricted locked

local	Lootster_ClassRestrictions					= {};		-- Class roll restrictions
local	Lootster_ClassRestrictionsMaskOrig			= 0;		-- Class roll restrictions mask (original)
local	Lootster_ClassRestrictionsMaskCurr			= 0;		-- Class roll restrictions mask (current)

local	Lootster_CountdownCount						= 0;		-- Roll clear counter

local	Lootster_ToWhisperQueue						= {};		-- To Whisper message queue

local	Lootster_ViewDKP							= false;	-- Data view - will be toggled to true initially

local	Lootster_AdjustIx							= nil;		-- Adjustment index being managed
local	Lootster_AdjustName							= nil;		-- Adjustment name being managed
local	Lootster_AdjustMain							= nil;		-- Adjustment main being managed

local	Lootster_AdjustSort							= {};		-- Adjustment sort

local	Lootster_AssignGroups						= {}		-- Assign loot groups
local	Lootster_AssignPlayers						= {}		-- Assign loot players

local	Lootster_DKPHiSave							= nil;		-- DKP cap hi save
local	Lootster_DKPLoSave							= nil;		-- DKP cap lo save

-- Load Handler
function Lootster_OnLoad()
	local   faction, key, classRec, ix, frame;

	-- hook events
	this:RegisterEvent("VARIABLES_LOADED")
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("RAID_ROSTER_UPDATE");
	this:RegisterEvent("PARTY_LEADER_CHANGED");	
	this:RegisterEvent("PARTY_MEMBERS_CHANGED");
	this:RegisterEvent("UNIT_NAME_UPDATE");
	this:RegisterEvent("LOOT_OPENED");
	this:RegisterEvent("LOOT_CLOSED");

	-- hook command handler
	SLASH_LOOTSTER1 = "/lootster";
	SLASH_LOOTSTER2 = "/ls";

	SlashCmdList["LOOTSTER"] = Lootster_OnCommand;

	-- hook chat frame message handler
	Lootster_AddMessageCB = ChatFrame1.AddMessage;

	ChatFrame1.AddMessage = Lootster_AddMessage;

	-- hook chat frame event and hyperlink handler
	Lootster_ChatFrame_OnEventCB = ChatFrame_OnEvent;

	ChatFrame_OnEvent = Lootster_ChatFrame_OnEvent;

	Lootster_ChatFrame_OnHyperlinkShowCB = ChatFrame_OnHyperlinkShow;

	ChatFrame_OnHyperlinkShow = Lootster_ChatFrame_OnHyperlinkShow;

	-- hook loot frame item click handler
	Lootster_LootFrameItem_OnClickCB = LootFrameItem_OnClick;

	LootFrameItem_OnClick = Lootster_LootFrameItem_OnClick;

	-- hook group loot frame show and event handlers
	Lootster_GroupLootFrame_OnShowCB = GroupLootFrame_OnShow;

	GroupLootFrame_OnShow = Lootster_GroupLootFrame_OnShow;
	
	Lootster_GroupLootFrame_OnEventCB = GroupLootFrame_OnEvent;

	GroupLootFrame_OnEvent = Lootster_GroupLootFrame_OnEvent;

	-- hook container frame item button click handler
	Lootster_ContainerFrameItemButton_OnClickCB = ContainerFrameItemButton_OnClick;

	ContainerFrameItemButton_OnClick = Lootster_ContainerFrameItemButton_OnClick;

	-- get default language
 	Lootster_Language = GetDefaultLanguage("player");

	-- get player name and class
	Lootster_Self = UnitName("player");
	Lootster_SelfClass, Lootster_SelfClassType = UnitClass("player");

	-- generate the class plural and singluar class name to invariant lookups
	for key, classRec in pairs(LOOTSTER_CLASS) do
		-- add the lower to invariant
		Lootster_ClassLower[string.lower(classRec.Singular)] = key;

		-- add the plural to invariant
		Lootster_ClassPlural[classRec.Plural] = key;

		-- add the singular to invariant
		Lootster_ClassSingular[classRec.Singular] = key;
	end

	-- make the popups closable using Escape key
	table.insert(UISpecialFrames, "Lootster_RollFrameAssignLootFrame");
	table.insert(UISpecialFrames, "Lootster_DataFrameRaidAttendFrame");
	table.insert(UISpecialFrames, "Lootster_DataFrameDKPAdjustsFrame");
	table.insert(UISpecialFrames, "Lootster_DataFrameAdjustDKPFrame");

	-- create a dialog for adjustment deletion
	StaticPopupDialogs["LOOTSTER_PROMPT_ADJDELETE"] =
	{
		text		= TEXT(LOOTSTER_PROMPT_ADJDELETE),
		button1		= TEXT(YES),
		button2		= TEXT(CANCEL),
		OnAccept	= function()
						  Lootster_Data_DeleteAdjust_OnAccept();
					  end,
		OnCancel	= function()
						  Lootster_Data_DeleteAdjust_OnCancel();
					  end,
		timeout		= 0,
		exclusive	= 1
	};

	-- create a dialog for all adjustment deletion
	StaticPopupDialogs["LOOTSTER_PROMPT_ADJDELETEALL"] =
	{
		text		= TEXT(LOOTSTER_PROMPT_ADJDELETEALL),
		button1		= TEXT(YES),
		button2		= TEXT(CANCEL),
		OnAccept	= function()
						  Lootster_Data_DeleteAdjustAll_OnClick();
					  end,
		timeout		= 0,
		exclusive	= 1
	};
end

-- Event handler
function Lootster_OnEvent()
	if		(event == "VARIABLES_LOADED") then
		Lootster_Initialised();
	elseif	(event == "PLAYER_ENTERING_WORLD") then
		Lootster_PLAYER_Enter();
	elseif	(event == "RAID_ROSTER_UPDATE") then
		Lootster_PARTY_Roster();
	elseif	(event == "PARTY_LEADER_CHANGED") then
		Lootster_PARTY_Leader();
	elseif	(event == "PARTY_MEMBERS_CHANGED") then
		Lootster_PARTY_Roster();
	elseif	(event == "UNIT_NAME_UPDATE") then
		Lootster_PARTY_Roster();
	elseif	(event == "LOOT_OPENED") then
		Lootster_LOOT_Opened();
	elseif	(event == "LOOT_CLOSED") then
		Lootster_LOOT_Closed();
	elseif	(event == "LOOT_SLOT_CLEARED") then
		Lootster_LOOT_Slot_Cleared(arg1);
	end
end

-- Timer Update handler
function Lootster_OnUpdate(elapsed)
	-- handle only if counting down
	if (elapsed ~= nil) then
		-- is the countdown timer active?
		if (Lootster_CountdownCount > 0) then
			-- update elapsed time
			this.timeSinceLastUpdate = this.timeSinceLastUpdate + elapsed;

			-- see if we passed a second since last update
			if (this.timeSinceLastUpdate >= 1) then
				-- decrement counter
				Lootster_CountdownCount = Lootster_CountdownCount - 1;

				-- punch out tic if it has not expired
				if (Lootster_CountdownCount > 0) then
					Lootster_SendBroadcast(string.format(LOOTSTER_MSG_COUNTDOWNTIC, Lootster_CountdownCount));
				end

				-- reset last update time
				this.timeSinceLastUpdate = 0;
			end
		end
	end
end

-- Command handler
function Lootster_OnCommand(cmd)
	-- only command is nothing at all - toggle display
	if (cmd == "") then
		Lootster_Toggle();
	else
		-- process this as a player inquiry from ourselves
		Lootster_PlayerInquiry(Lootster_Self, cmd);
	end
end

-- Initialisation handler
function Lootster_Initialised()
	local	key, value;

	-- echo current version
	Lootster_SendPrivate(Lootster_Self, string.format(LOOTSTER_MSG_LOAD, LOOTSTER_VERSION), true);

	-- initialise session
	for key, value in Lootster_Options_Default do
		if (Lootster_Options[key] == nil) then
			Lootster_Options[key] = value
		end
	end

	for key, value in Lootster_Rules_Default do
		if (Lootster_Rules[key] == nil) then
			Lootster_Rules[key] = value
		end
	end

	-- transfer old DKP used toggle to new selection style
	if (Lootster_Options.DKPUsed ~= nil) then
		-- update roll mode
		if (Lootster_Options.DKPUsed == true) then
			-- DKP mode
			Lootster_Options.RollMode = LOOTSTER_ENUM_MODE.USEDKP;
		else
			-- Normal mode
			Lootster_Options.RollMode = LOOTSTER_ENUM_MODE.USENORM;
		end

		-- set default DKP type (old style)
		Lootster_Options.DKPType = LOOTSTER_ENUM_DKP.BYMODIFIED;

		-- set default Normal mode
		Lootster_Options.NormType = LOOTSTER_ENUM_NORM.BYNEEDGREED;

		-- erase old DKP used toggle
		Lootster_Options.DKPUsed = nil;
	end

	-- transfer old rules to new rules if necessary
	if (Lootster_Rules.Rules ~= nil) then
		-- update DKP rules
		Lootster_Rules.RulesDKP = Lootster_Rules.Rules;

		-- update normal rules
		Lootster_Rules.RulesNorm = Lootster_Rules.Rules;

		-- erase old rules
		Lootster_Rules.Rules = nil;
	end

	-- transfer old 100 rules to new Norm rules as necessary (name change)
	if (Lootster_Rules.Rules100 ~= nil) then
		-- update normal rules
		Lootster_Rules.RulesNorm = Lootster_Rules.Rules100;

		-- erase old 100 rules
		Lootster_Rules.Rules100 = nil;
	end

	-- ensure loot rules have a trailing break
	Lootster_Rules.RulesDKP = Lootster_AppendTrailingLineBreak(Lootster_Rules.RulesDKP);
	Lootster_Rules.RulesNorm = Lootster_AppendTrailingLineBreak(Lootster_Rules.RulesNorm);

	-- Version 1800 -> 1900 update
	--
	-- Version 1900 causes the Suppress Rolls in Chat Log to work.  Modified initial load of Lootster
	-- to flip this flag OFF to reduce surprises
	if ((Lootster_Options.Updated1900 == nil) or (Lootster_Options.Updated1900 == false)) then
		-- flip suppression off
		Lootster_Options.Suppress = false;

		-- and mark as having done so
		Lootster_Options.Updated1900 = true;
	end

	-- has DKP check
	Lootster_HasDKP = (Lootster_DateDKP ~= nil) and (Lootster_MainDKP ~= nil) and (Lootster_AltsDKP ~= nil) or
					  (Lootster_ParkDKP ~= nil) and (Lootster_MobsDKP ~= nil) and (Lootster_ItemDKP ~= nil) or
					  (Lootster_TierDKP ~= nil);

	-- if DKP is disabled, make sure we correct current states
	if (not Lootster_HasDKP) then
		-- switch off DKP
		Lootster_Options.RollMode = LOOTSTER_ENUM_MODE.USENORM;

		-- spoof empty tables so we process as normal
		Lootster_DateDKP = "";
		Lootster_MainDKP = {};
		Lootster_AltsDKP = {};
		Lootster_ParkDKP = {};
		Lootster_MobsDKP = {};
		Lootster_ItemDKP = {};
		Lootster_TierDKP = {};
	else
		-- show DKP date widgets
		Lootster_OptionsFrameVersionFrameDKPDateLabel:Show();
		Lootster_OptionsFrameVersionFrameDKPDate:Show();

		-- enable roll mode widget
		Lootster_OptionsFrameRollModeButton:Enable();
	end

	-- accumulate current adjustments
	Lootster_AdjustLoad();

	-- disable the countdown button
	Lootster_RollFrameCountdown:Disable();

	-- initialise roll tab
	Lootster_RollFrameActive:SetChecked(Lootster_Options.Active);
	Lootster_RollFramePassive:SetChecked(Lootster_Options.Passive);

	-- disable/enable passive rolling checkbox
	if (Lootster_Options.Active == true) then
		Lootster_RollFramePassive:Disable();
	else
		Lootster_RollFramePassive:Enable();
	end

	-- initialise data view
	Lootster_Data_View_OnClick();

	-- initialise data adjust DKP frame
	Lootster_Data_AdjustDKP_OnHide();

	-- initialise options tab
	Lootster_OptionsFrameMiniMapButton:SetChecked(Lootster_Options.MiniMap);

	Lootster_OptionsFrameMiniMapSlider:SetValue(Lootster_Options.MiniMapPos);
	Lootster_OptionsFrameMiniMapSliderText:SetText(Lootster_Options.MiniMapPos);

	Lootster_OptionsFrameVersionFrameVersion:SetText(LOOTSTER_VERSION);
	Lootster_OptionsFrameVersionFrameDKPDate:SetText(Lootster_DateDKP);

	Lootster_OptionsFrameSuppress:SetChecked(Lootster_Options.Suppress);

	Lootster_OptionsFrameAckRoll:SetChecked(Lootster_Options.AckRoll);

	Lootster_OptionsFrameAckNoCall:SetChecked(Lootster_Options.AckNoCall);

	Lootster_OptionsFrameAckNoRoll:SetChecked(Lootster_Options.AckNoRoll);

	Lootster_OptionsFrameCounter:SetChecked(Lootster_Options.Counter);

	Lootster_OptionsFrameSeconds:SetNumber(Lootster_Options.CounterSec);

	Lootster_OptionsFrameEchoRestrict:SetChecked(Lootster_Options.EchoRestrict);
	Lootster_OptionsFrameEchoToChat:SetChecked(Lootster_Options.EchoToChat);
	Lootster_OptionsFrameEchoToCTRA:SetChecked(Lootster_Options.EchoToCTRA);
	Lootster_OptionsFrameEchoByClick:SetChecked(Lootster_Options.EchoByClick);
	Lootster_OptionsFrameEchoByGroupLoot:SetChecked(Lootster_Options.EchoByGroupLoot);

	Lootster_OptionsFrameAutoSnoop:SetChecked(Lootster_Options.AutoSnoop);

	Lootster_OptionsFrameDebugMsgs:SetChecked(Lootster_Options.DebugMsgs);

	Lootster_OptionsFrameDKPPriority:SetChecked(Lootster_Options.DKPPrior);

	Lootster_OptionsFrameDKPCaps:SetChecked(Lootster_Options.DKPCaps);

	Lootster_OptionsFrameDKPHi:SetNumber(Lootster_Options.DKPHi);
	Lootster_OptionsFrameDKPLo:SetNumber(Lootster_Options.DKPLo);

	Lootster_OptionsFrameDKPHiRO:SetText(Lootster_Options.DKPHi);
	Lootster_OptionsFrameDKPLoRO:SetText(Lootster_Options.DKPLo);

	Lootster_OptionsFrameNormCorKRoll:SetChecked(Lootster_Options.CorKRoll);
	Lootster_OptionsFrameNormCorKOpen:SetChecked(Lootster_Options.CorKOpen);
	Lootster_OptionsFrameNormCorKClose:SetChecked(Lootster_Options.CorKClose);

	-- setup location of main frame
	Lootster_CheckLocation();

	-- update echo UI
	Lootster_CheckEchoUse();

	-- check tabs and update mode UI
	Lootster_CheckModeUse();

	-- and show/hide the MiniMap button and hide/show the title
	if (Lootster_Options.MiniMap == true) then
		Lootster_MiniMapButtonFrame:Show();

		Lootster_Title:Hide();
	else
		Lootster_MiniMapButtonFrame:Hide();

		Lootster_Title:Show();
	end

	-- reflect the position
	Lootster_MiniMapButton_UpdatePosition();

	-- and hide the UI
	Lootster_RollFrame:Hide();
	Lootster_DataFrame:Hide();
	Lootster_RuleFrame:Hide();
	Lootster_OptionsFrame:Hide();
	Lootster_TabsFrame:Hide();

	-- force a roster update
	Lootster_PARTY_Roster();

	-- clear rolls to force UI update
	Lootster_Roll_ClearRolls_OnClick();
end

-- Add Message handler
function Lootster_AddMessage(self, msg, ...)
	-- snarf /randoms
	if (msg == nil) or (not Lootster_Options.Suppress) or (not string.find(msg, LOOTSTER_ROLL_PATTERN)) then
		-- not a roll, so pass to callback
		Lootster_AddMessageCB(self, msg, unpack(arg))
	end
end

-- LootFrameItem Click handle
function Lootster_LootFrameItem_OnClick(button)
	-- see if they are echoing restrictions or linking the loot
	if		(IsShiftKeyDown() and IsControlKeyDown() and (button == "RightButton") and (Lootster_Options.EchoRestrict == true) and (Lootster_Options.EchoByClick == true)) then
		-- display restrictions of the hyperlink if this is a loot item
		if (LootSlotIsItem(this.slot)) then
			Lootster_Class_Display_OnClick(GetLootSlotLink(this.slot));
			return;
		end
	elseif	(IsShiftKeyDown() and (button == "LeftButton")) then
		-- snarf the hyperlink if this is a loot item
		if (LootSlotIsItem(this.slot)) then
			Lootster_SetHyperlink(GetLootSlotLink(this.slot), this.slot);
		end
	end

	-- and pass to base class
	Lootster_LootFrameItem_OnClickCB(button);

	-- update the UI
	Lootster_UpdateUI();
end

-- GroupLootFrame Show handler
function Lootster_GroupLootFrame_OnShow()
	local	lootFrame, classIcon, classFrame;
	local	restrictions;

	-- first, pass to the callback function
	Lootster_GroupLootFrame_OnShowCB();

	-- retrieve the echo loot frame
	lootFrame = getglobal("Lootster_EchoLootFrame"..this:GetID());

	-- are we to allow class restrictions to be echoed?
	if ((Lootster_Options.EchoRestrict == true) and (Lootster_Options.EchoByGroupLoot == true)) then
		-- get the item details for the roll link
		_, _, _, _, restrictions = Lootster_GetItemDetails(GetLootRollItemLink(this.rollID));

		-- see if we have class restrictions
		if (table.getn(restrictions) > 0) then
			local	class, count, ix;
			local	classes = {};
			local	icon;

			-- build an alphabetical list of restricted classes
			for ix, flag in ipairs(LOOTSTER_CLASS_SORT) do
				-- this class restricted?
				if ((LOOTSTER_CLASS_SORT[ix] ~= Lootster_ClassIgnore) and (restrictions[LOOTSTER_CLASS_SORT[ix]] == true)) then
					table.insert(classes, LOOTSTER_CLASS_SORT[ix]);
				end
			end

			-- now show the respective class icons
			count = table.getn(classes);

			for ix=1, count, 1 do
				-- get this class icon
				classIcon = getglobal("Lootster_EchoLootFrame"..this:GetID().."ClassFrame"..ix.."Icon");

				-- hammer in the class texture
				classIcon:SetTexture("Interface\\AddOns\\Lootster\\Images\\Class-"..classes[ix]);

				-- get this class frame
				classFrame = getglobal("Lootster_EchoLootFrame"..this:GetID().."ClassFrame"..ix);

				-- update the class frame's class
				classFrame.Class = LOOTSTER_CLASS[classes[ix]].Plural;

				-- and show
				classFrame:Show();
			end

			-- now hide the remaining class icon slots
			for ix=(count + 1), (table.getn(LOOTSTER_CLASS) - 1), 1 do
				-- get this class frame
				classFrame = getglobal("Lootster_EchoLootFrame"..this:GetID().."ClassFrame"..ix);

				-- and hide
				classFrame:Hide();
			end

			-- and show the echo loot frame
			lootFrame:Show();
		else
			-- hide the echo loot frame
			lootFrame:Hide();
		end
	else
		-- hide the echo loot frame
		lootFrame:Hide();
	end
end

-- GroupLootFrame Event handler
function Lootster_GroupLootFrame_OnEvent()
	-- first, pass to the callback function
	Lootster_GroupLootFrame_OnEventCB();

	-- is this the cancel loot roll event?
	if (event == "CANCEL_LOOT_ROLL") then
		-- make sure this is the roll we are handling
		if (arg1 == this.rollID) then
			-- hide our echo loot frame
			getglobal("Lootster_EchoLootFrame"..this:GetID()):Hide()
		end
	end
end

-- ChatFrame Event handler
function Lootster_ChatFrame_OnEvent(event)
	if		(event == "CHAT_MSG_RAID") then
		Lootster_MSG_PartyRaid(event);
	elseif	(event == "CHAT_MSG_PARTY") then
		Lootster_MSG_PartyRaid(event);
	elseif	(event == "CHAT_MSG_RAID_LEADER") then
		Lootster_MSG_PartyRaid(event);
	elseif	(event == "CHAT_MSG_SYSTEM") then
		Lootster_MSG_System(event);
	elseif	(event == "CHAT_MSG_WHISPER") then
		Lootster_MSG_Whisper(event);
	elseif	(event == "CHAT_MSG_WHISPER_INFORM") then
		Lootster_MSG_Whisper_Inform(event);
	else
		-- pass to chat frame for processing
		Lootster_ChatFrame_OnEventCB(event);
	end
end

-- ChatFrame Hyperlink Show handler
function Lootster_ChatFrame_OnHyperlinkShow(link, text, button)
	-- must be an item
	if (strsub(link, 1, 4) == "item") then
		-- see if they are echoing restrictions or linking the item
		if		(IsShiftKeyDown() and IsControlKeyDown() and (button == "RightButton") and (Lootster_Options.EchoRestrict == true) and (Lootster_Options.EchoByClick == true)) then
			-- display restrictions of the hyperlink
			Lootster_Class_Display_OnClick(text);
			return;
		elseif	(IsShiftKeyDown() and (button == "LeftButton")) then
			-- snarf the hyperlink
			Lootster_SetHyperlink(text);
		end
	end

	-- and pass to base class
	Lootster_ChatFrame_OnHyperlinkShowCB(link, text, button);

	-- update the UI
	Lootster_UpdateUI();
end

-- ContainerFrameItemButton Click handler
function Lootster_ContainerFrameItemButton_OnClick(button, ignoreShift)
	-- see if they are echoing restrictions or linking a bag item
	if		(IsShiftKeyDown() and IsControlKeyDown() and (button == "RightButton") and not ignoreShift and (Lootster_Options.EchoRestrict == true) and (Lootster_Options.EchoByClick == true)) then
		-- display restrictions of the hyperlink
		Lootster_Class_Display_OnClick(GetContainerItemLink(this:GetParent():GetID(), this:GetID()));
		return;
	elseif	(IsShiftKeyDown() and (button == "LeftButton") and not ignoreShift) then
		-- snarf the hyperlink
		Lootster_SetHyperlink(GetContainerItemLink(this:GetParent():GetID(), this:GetID()));
	end

	-- and pass to base class
	Lootster_ContainerFrameItemButton_OnClickCB(button, ignoreShift);

	-- update the UI
	Lootster_UpdateUI();
end

-- Party/Raid Message handler
function Lootster_MSG_PartyRaid(event)
	local	msg		= arg1;
	local	player	= arg2;

	-- argument breakdown is as follows:
	--
	-- message, sender, language, channel, arg5, arg6, arg7, channelNumber, channelName, loops, frame = arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, loops, frame

	-- pass to chat frame for processing
	Lootster_ChatFrame_OnEventCB(event);

	-- the user may have more than one chat frame - just use the one from default
	if (DEFAULT_CHAT_FRAME:GetID() ~= this:GetID()) then
		-- should be handled by default
		return;
	end

	-- if we are here, it was not a pass/reclaim during a roll call.  Check for auto-snoop processing
	if (Lootster_Options.AutoSnoop == true) then
		local	rollMode, modeType, modeDetail, modePrior, modeCaps, modeCall, capsCapHi, capsCapLo;

		local	restrictsCap, NBGCap, specifyCap, itemCap, linkCap, usingCap, dkpCap, dkpCapVal, itemCount, restrictCap1, restrictCap2, restrictCapP, restrictCapPU, restrictCapL;

		local	restricts = {};

		local	class, tied, hashcount, hashlist;

		local	isRollMode = false;
		local	isRollCall = false;

		-- process to see if its another Lootster switching modes
		_, _, modeType, modeDetail = string.find(msg, LOOTSTER_MODE_MODE_PATTERN);

		-- process to see if its another Lootster calling for a roll
		_,_, restrictsCap, NBGCap, specifyCap = string.find(msg, LOOTSTER_NBG_ALL_PATTERN);

		-- check various message combinations
		if		((player ~= Lootster_Self) and (modeType ~= nil) and (modeDetail ~= nil)) then
			-- okay, we may have a roll mode.  Tease it apart
			if		((modeType == LOOTSTER_MODE_1001000_PATTERN) or (modeType == LOOTSTER_MODE_NEEDGREED_PATTERN)) then
				-- extract normal details 
				_,_, modeCall = string.find(modeDetail, LOOTSTER_MODE_NORMMODE_PATTERN);

				-- a normal mode.  Process roll call
				if ((modeCall == LOOTSTER_MSG_REQUIRED) or (modeCall == LOOTSTER_MSG_OPTIONAL)) then
					-- optional roll call is allowed only for 100/1000 mode
					if ((modeType == LOOTSTER_MODE_NEEDGREED_PATTERN) and (modeCall == LOOTSTER_MSG_OPTIONAL)) then
						-- spoofed roll call change
						return;
					end
				else
					-- spoofed roll call change
					return;
				end

				-- mode is Normal
				rollMode = LOOTSTER_ENUM_MODE.USENORM;

				-- at this point, we can safely say its a roll mode
				isRollMode = true;
			elseif	((modeType == LOOTSTER_MODE_DKP_PATTERN) or (modeType == LOOTSTER_MODE_TIER_PATTERN) or (modeType == LOOTSTER_MODE_MODIFIED_PATTERN)) then
				-- must have DKP handling enabled
				if (Lootster_HasDKP == false) then
					-- we cannot handle this mode
					return;
				end

				-- extract DKP details 
				_,_, modePrior, modeCaps = string.find(modeDetail, LOOTSTER_MODE_DKPMODE_PATTERN);

				-- a DKP mode.  Process priority
				if ((modePrior == LOOTSTER_MODE_PRIORNONE_PATTERN) or (modePrior == LOOTSTER_MODE_PRIORUSED_PATTERN)) then
					-- process caps				
					if (modeCaps ~= LOOTSTER_MODE_CAPSNONE_PATTERN) then
						-- retrieve the caps
						_, _, capsCapHi, capsCapLo = string.find(modeCaps, LOOTSTER_MODE_CAPSUSED_PATTERN);

						if (capsCapLo == nil) then
							-- spoofed caps change
							return;
						end

						-- convert the text
						capsCapHi = tonumber(capsCapHi);
						capsCapLo = tonumber(capsCapLo);
					end
				else
					-- spoofed priority change
					return;
				end

				-- mode is Normal
				rollMode = LOOTSTER_ENUM_MODE.USEDKP;

				-- at this point, we can safely say its a roll mode
				isRollMode = true;
			else
				-- spoofed mode change
				return;
			end
		elseif	((player ~= Lootster_Self) and ((NBGCap == LOOTSTER_NBG_NEED) or (NBGCap == LOOTSTER_NBG_GREED) or (NBGCap == LOOTSTER_NBG_1001000) or (NBGCap == LOOTSTER_NBG_TIED))) then
			-- plead spoof prevention
			if ((NBGCap == LOOTSTER_NBG_GREED) and (restrictsCap ~= LOOTSTER_MSG_PLEASE)) then
				-- spoofed greed call - ignore
				return;
			end

			-- make sure current roll mode and roll type is consistent
			if		(NBGCap == LOOTSTER_NBG_1001000) then
				-- must be in Normal 100/1000 mode
				if ((Lootster_Options.RollMode ~= LOOTSTER_ENUM_MODE.USENORM) or (Lootster_Options.NormType ~= LOOTSTER_ENUM_NORM.BY1001000)) then
					-- spoofed mode call
					return;
				end
			elseif	((NBGCap == LOOTSTER_NBG_NEED) or (NBGCap == LOOTSTER_NBG_GREED)) then
				-- cannot be in Normal 100/1000
				if ((Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USENORM) and (Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000)) then
					-- spoofed mode call
					return;
				end
			end

			-- if this is not a straight plead, tease apart the restrictions
			if	(restrictsCap ~= LOOTSTER_MSG_PLEASE) then
				-- we have restrictions, depending on the type of call.  Either way, its in the same form.

				-- first, we must check for multi-restrictions first
				_, _, restrictCapP, restrictCapPU, restrictCapL = string.find(restrictsCap, LOOTSTER_NBG_RESTRICTN_PATTERN);

				if (restrictCapL == nil) then
					-- not a multi-restriction, we must check for two restrictions next
					_, _, restrictCap1, restrictCap2 = string.find(restrictsCap, LOOTSTER_NBG_RESTRICT2_PATTERN);

					if (restrictCap2 == nil) then
						-- not two restrictions, so check for a single restriction
						_, _, restrictCap1 = string.find(restrictsCap, LOOTSTER_NBG_RESTRICT1_PATTERN);
					end

					-- add restrictions as necessary
					if (restrictCap1 ~= nil) then
						-- only the one restriction
						if (Lootster_AddRestriction(NBGCap, restricts, restrictCap1) == true) then
							-- class/player spoof check - duplicate
							return;
						end
					end

					if (restrictCap2 ~= nil) then
						-- only the two restrictions
						if (Lootster_AddRestriction(NBGCap, restricts, restrictCap2) == true) then
							-- class/player spoof check - duplicate
							return;
						end
					end
				else
					-- we need to process each restriction
					for restrictCap1 in string.gfind(restrictCapP, LOOTSTER_NBG_RESTRICT1_PATTERN) do
						-- how we add this to the table depends on the NBG type
						if (Lootster_AddRestriction(NBGCap, restricts, restrictCap1) == true) then
							-- class/player spoof check - duplicate
							return;
						end
					end

					-- add penultimate and last restrictions
					if ((Lootster_AddRestriction(NBGCap, restricts, restrictCapPU) == true) or 
						(Lootster_AddRestriction(NBGCap, restricts, restrictCapL) == true)) then
						-- class/player spoof check - duplicate
						return;
					end
				end
			end

			-- class and playa spoof prevention
			if		((NBGCap == LOOTSTER_NBG_NEED) or (NBGCap == LOOTSTER_NBG_1001000)) then
				-- setup hashcount
				hashcount = table.getn(restricts);

				-- okay, validate the restricted classes
				for key, classRec in pairs(LOOTSTER_CLASS) do
					-- is he in restrictions?
					if (restricts[key] ~= nil) then
						-- class allowed
						hashcount = hashcount - 1;
					end
				end

				-- class spoofed if hashcount is not zero
				if (hashcount ~= 0) then
					return;
				end
			elseif	(NBGCap == LOOTSTER_NBG_TIED) then
				-- must be two or more players for a tied roll
				if (table.getn(restricts) <= 1) then
					-- TIED roll call spoof
					return;
				end

				-- setup hashlist
				hashlist = {};

				-- make sure players are valid
				for ix, tied in ipairs(restricts) do
					-- player must be in roster
					if (Lootster_Roster[tied] == nil) then
						-- player spoofed if not in roster
						return;
					end

					-- player cannot be duplicated
					if (hashlist[tied] ~= nil) then
						-- player spoofed if duplicate
						return;
					end

					-- add to hashlist
					hashlist[tied] = true;
				end
			end

			-- if we have a link, tease it apart
			if (specifyCap ~= "") then
				-- check for specfied item
				_,_, itemCap = string.find(specifyCap, LOOTSTER_NBG_ON_PATTERN);

				-- do we have an item?
				if (itemCap ~= nil) then
					-- okay, see if its generic
					_, _, itemCount, usingCap = string.find(itemCap, LOOTSTER_NBG_ITEMS_PATTERN);

					if		(itemCount == nil) then
						-- see if its a single real link
						_, _, linkCap, usingCap = string.find(itemCap, LOOTSTER_NBG_LINK1_PATTERN);

						-- if not a single link, check for multiple items
						if (linkCap == nil) then
							-- see if its multiple real link
							_, _, itemCount, linkCap, usingCap = string.find(itemCap, LOOTSTER_NBG_LINKN_PATTERN);
						end

						-- item count and in DKP mode?
						if ((itemCount ~= nil) and (Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP)) then
							-- cannot have an item count in DKP mode
							return;
						end

						-- is the link capture nil?
						if (linkCap == nil) then
							-- it better be a TIED roll call, since if there is no link there must be a using clause
							if		(NBGCap ~= LOOTSTER_NBG_TIED) then
								-- link spoof prevention
								return;
							elseif	(specifyCap ~= LOOTSTER_NBG_USING_PATTERN) then
								-- TIED roll call spoof prevention
								return;
							end
						else
							-- link is valid, but make sure of a tied roll
							if ((NBGCap == LOOTSTER_NBG_TIED) and (usingCap ~= LOOTSTER_NBG_USING_PATTERN)) then
								-- TIED roll call spoof prevention
								return;
							else
								-- see if we have a DKP costing - only in DKP mode of course
								if ((Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP) and (usingCap == "")) then
									-- spoofed roll call in DKP mode
									return;
								end

								-- see if we have a real DKP costing
								_, _, dkpCap = string.find(usingCap, LOOTSTER_NBG_COSTING_PATTERN);

								if ((dkpCap ~= nil) and (dkpCap ~= LOOTSTER_COST_DKPTDB) and (dkpCap ~= LOOTSTER_COST_DKP0TDB)) then
									-- we must have a real DKP value
									_, _, dkpCapVal = string.find(dkpCap, LOOTSTER_NBG_COSTINGDKP_PATTERN);

									if (dkpCapVal == nil) then
										-- DKP costing spoof prevention
										return;
									end
								end
							end
						end
					elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP) then
						-- cannot have an item count in DKP mode
						return;
					end
				end

				-- cannot have zero or negative item counts
				if		(itemCount == nil) then
					-- no item count
					itemCount = 1;
				elseif	(tonumber(itemCount) > 0) then
					-- convert to number
					itemCount = tonumber(itemCount);
				else
					-- spoofed roll call
					return;
				end
			else
				-- is this a TIED roll?
				if (NBGCap == LOOTSTER_NBG_TIED) then
					-- TIED roll call spoof prevention
					return;
				end

				-- certainly no link
				linkCap = nil;

				-- default item count is 1
				itemCount = 1;
			end 

			-- at this point, we can safely say its a roll call
			isRollCall = true;
		end

		-- if we are active and this is a roll mode or roll call, make sure we are deactivated
		if ((Lootster_Options.Active == true) and ((isRollMode == true) or (isRollCall == true))) then
			-- toggle off
			Lootster_RollFrameActive:SetChecked(false);

			-- and snarf
			Lootster_Roll_ActiveButton_Toggle();
		end

		-- process the auto-snoop
		if		(isRollMode == true) then
			-- clear rolls
			Lootster_Roll_ClearRolls_OnClick();

			-- update the UI
			Lootster_UpdateUI();

			-- set roll mode as required
			Lootster_Options.RollMode = rollMode;

			-- set roll mode
			Lootster_Option_RollMode_OnShow();

			-- determine new roll mode
			if		(rollMode == LOOTSTER_ENUM_MODE.USEDKP) then
				-- set requisite DKP mode
				if		(modeType == LOOTSTER_MODE_DKP_PATTERN) then
					-- set DKP mode
					Lootster_Options.DKPType = LOOTSTER_ENUM_DKP.BYDKP;
				elseif	(modeType == LOOTSTER_MODE_TIER_PATTERN) then
					-- set Tier mode
					Lootster_Options.DKPType = LOOTSTER_ENUM_DKP.BYTIER;
				elseif	(modeType == LOOTSTER_MODE_MODIFIED_PATTERN) then
					-- set DKP Modified mode
					Lootster_Options.DKPType = LOOTSTER_ENUM_DKP.BYMODIFIED;
				else
					-- default to Tier mode
					Lootster_Options.DKPType = LOOTSTER_ENUM_DKP.BYTIER;
				end

				-- set DKP type
				Lootster_Option_RollType_OnShow();

				-- set DKP priority toggle according to priority in effect
				Lootster_Options.DKPPrior = modePrior ~= LOOTSTER_MODE_PRIORNONE_PATTERN;

				Lootster_OptionsFrameDKPPriority:SetChecked(Lootster_Options.DKPPrior);

				-- set DKP capped toggle according to caps in effect
				Lootster_Options.DKPCaps = modeCaps ~= LOOTSTER_MODE_CAPSNONE_PATTERN;

				Lootster_OptionsFrameDKPCaps:SetChecked(Lootster_Options.DKPCaps);

				-- if caps are in effect, set those as well
				if (modeCaps ~= LOOTSTER_MODE_CAPSNONE_PATTERN) then
					-- update DKP hi and lo caps
					Lootster_OptionsFrameDKPHi:SetNumber(capsCapHi); 
					Lootster_OptionsFrameDKPLo:SetNumber(capsCapLo);

					-- cause snarf of set DKP caps
					Lootster_Option_DKPHi_Entered();
					Lootster_Option_DKPLo_Entered();
				end
			elseif	(rollMode == LOOTSTER_ENUM_MODE.USENORM) then
				-- set requisite Normal mode
				if		(modeType == LOOTSTER_MODE_1001000_PATTERN) then
					-- set 100/1000 mode
					Lootster_Options.NormType = LOOTSTER_ENUM_NORM.BY1001000;
				elseif	(modeType == LOOTSTER_MODE_NEEDGREED_PATTERN) then
					-- set Need then Greed mode
					Lootster_Options.NormType = LOOTSTER_ENUM_NORM.BYNEEDGREED;
				else
					-- default to Need then Greed mode
					Lootster_Options.NormType = LOOTSTER_ENUM_NORM.BYNEEDGREED;
				end

				-- set DKP type
				Lootster_Option_RollType_OnShow();

				-- set 100/1000 roll call toggle according to roll call in effect
				Lootster_Options.CorKRoll = modeCall ~= LOOTSTER_MSG_REQUIRED;

				Lootster_OptionsFrameNormCorKRoll:SetChecked(Lootster_Options.CorKRoll);
			end

			-- update roll handling
			Lootster_UpdateRollHandling();

			-- snooped roll mode - done
			return;
		elseif	(isRollCall == true) then	
			-- clear rolls
			Lootster_Roll_ClearRolls_OnClick();

			-- set the number of items being rolled on
			Lootster_RollFrameItems:SetNumber(itemCount);

			-- and spoof entry to transfer and update
			Lootster_Roll_Items_Entered();

			-- set the hyperlink as appropriate
			Lootster_SetHyperlink(linkCap);

			-- update the UI
			Lootster_UpdateUI();

			-- is this NEED or 100/1000?
			if		((NBGCap == LOOTSTER_NBG_NEED) or (NBGCap == LOOTSTER_NBG_1001000)) then
				-- see if an item was passed and it does not have a class restriction lock
				if ((Lootster_ClassRestrictedLock == false) and (table.getn(restricts) > 0)) then
					-- dude is class restricted by roll caller
					Lootster_ClassRestricted = true;

					-- no classes
					Lootster_ClassRestrictions = {};

					-- reset the current restriction mask
					Lootster_ClassRestrictionsMaskCurr = 0;

					-- reset count
					table.setn(Lootster_ClassRestrictions, 0);

					-- all these guys are plural, so reverse lookup
					for key, classRec in pairs(LOOTSTER_CLASS) do
						-- is he in restrictions?
						if (restricts[key] ~= nil) then
							-- set class restricted
							Lootster_ClassRestrictions[key] = true;

							-- add to current mask.  Since the original mask is unchanged, we can detect if
							-- these class restrictions differ from that previously saved
							Lootster_ClassRestrictionsMaskCurr = bit.bor(Lootster_ClassRestrictionsMaskCurr, classRec.Mask);

							-- bump count
							table.setn(Lootster_ClassRestrictions, table.getn(Lootster_ClassRestrictions) + 1);
						end
					end

					-- update the class frame
					Lootster_UpdateClass();
					 
					-- update restricted count
					Lootster_UpdateRestricted();

					-- show the class frame if we are visible
					if (Lootster_RollFrame:IsVisible() or Lootster_DataFrame:IsVisible() or Lootster_RuleFrame:IsVisible() or Lootster_OptionsFrame:IsVisible()) then
						Lootster_ClassFrame:Show();
					end
				end

				-- what kind of roll?
				if		(NBGCap == LOOTSTER_NBG_NEED) then
					-- force Need roll
					Lootster_Roll_NeedRoll_OnClick();
				elseif	(NBGCap == LOOTSTER_NBG_1001000) then
					-- force 100/1000 roll
					Lootster_Roll_1001000Roll_OnClick();
				end
			elseif	(NBGCap == LOOTSTER_NBG_GREED) then
				-- force Greed roll
				Lootster_Roll_GreedRoll_OnClick();
			elseif	(NBGCap == LOOTSTER_NBG_TIED) then
				-- calculate the positions
				Lootster_CalculatePositions();

				-- okay, add the tied players, if any
				for ix, tied in ipairs(restricts) do
					-- player allowed to roll
					Lootster_AddPlayer(tied);
				end

				-- sort the rolls
				Lootster_Roll_Sort();

				-- update received roll status
				Lootster_UpdateUI();	

				-- update the screen
				Lootster_Roll_Update();

				-- force Tied roll
				Lootster_Roll_TiedRoll_OnClick();
			end

			-- snooped roll call - done
			return;
		end
	end

	-- see if it was a pass/reclaim
	if		(string.lower(msg) == LOOTSTER_CMD_PASS) then
		-- let the player pass their roll
		Lootster_PassRoll(player);

		-- processed
		return;
	elseif	(string.lower(msg) == LOOTSTER_CMD_RECLAIM) then
		-- let the player reclaim their roll
		Lootster_ReclaimRoll(player);

		-- processed
		return;
	end
end

-- System Message handler
function Lootster_MSG_System(event)
	local player, roll, min_roll, max_roll;

	-- pass to chat frame for processing
	Lootster_ChatFrame_OnEventCB(event);

	-- attempt to decode /random roll
	_, _, player, roll, minRoll, maxRoll = string.find(arg1, LOOTSTER_ROLL_PATTERN)

	-- if we have a player we have a playa
	if (player ~= nil) then
		Lootster_ProcessRoll(player, roll, minRoll, maxRoll)
	end
end

-- Whisper Message handler
function Lootster_MSG_Whisper(event)
	local	player	= arg2;
	local	msg		= arg1;

	-- is this the default chat frame?
	if (DEFAULT_CHAT_FRAME:GetID() == this:GetID()) then
		-- pass to our inquiry handler unless we are whispering to ourselves (can be done)
		if ((player == Lootster_Self) or (Lootster_PlayerInquiry(player, msg) == false)) then
			-- pass to chat frame for processing
			Lootster_ChatFrame_OnEventCB(event);
		end
	else
		-- pass to chat frame for processing
		Lootster_ChatFrame_OnEventCB(event);
	end
end

-- Whisper Inform Message handler
function Lootster_MSG_Whisper_Inform(event)
	local	player	= arg2;
	local	msg		= arg1;

	-- is this the default chat frame?
	if (DEFAULT_CHAT_FRAME:GetID() == this:GetID()) then
		-- pass to our inquiry handler if we are whipsering to ourselves (can be done)
		if ((player ~= Lootster_Self) or (Lootster_PlayerInquiry(player, msg) == false)) then
			-- not a command from ourselves.  If no message, showing debug messages or no queued To Whispers we always display
			if ((msg == nil) or (Lootster_Options.DebugMsgs == true) or (table.getn(Lootster_ToWhisperQueue) == 0)) then
				Lootster_ChatFrame_OnEventCB(event);
			else
				-- see if this is the queued To Whisper
				if (arg1 == Lootster_ToWhisperQueue[1]) then
					-- remove this message
					table.remove(Lootster_ToWhisperQueue, 1);
				else
					-- not a To Whisper from us, so display
					Lootster_ChatFrame_OnEventCB(event);
				end
			end
		end
	else
		-- pass to chat frame for processing
		Lootster_ChatFrame_OnEventCB(event);
	end
end

-- UI Toggle handler
function Lootster_Toggle()
	-- handle toggling of the UI
	if (Lootster_Options.MiniMap == true) then
		-- ensure button is unhighlighted
		Lootster_MiniMapButtonNorm:Show();
		Lootster_MiniMapButtonHigh:Hide();

		-- MiniMap Operation
		if (Lootster_RollFrame:IsVisible() or Lootster_DataFrame:IsVisible() or Lootster_RuleFrame:IsVisible() or Lootster_OptionsFrame:IsVisible()) then
			if (Lootster_Options.Sound) then
				PlaySound("igMiniMapClose");
			end

			-- hide
			Lootster_Title:Hide();
			Lootster_TabsFrame:Hide();
			Lootster_RollFrame:Hide();
			Lootster_DataFrame:Hide();
			Lootster_RuleFrame:Hide();
			Lootster_OptionsFrame:Hide();

			Lootster_ClassFrame:Hide();

			-- hide dialogs et al
			Lootster_DataFrameAdjustDKPFrame:Hide();

			Lootster_DataFrameRaidAttendFrame:Hide();
			Lootster_DataFrameDKPAdjustsFrame:Hide();

			-- are we in Normal 100/1000 mode using auto-clear on close?
			if ((Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USENORM) and (Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000) and (Lootster_Options.CorKClose == true)) then
				-- clear rolls
				Lootster_Roll_ClearRolls_OnClick();
			end
		else
			if (Lootster_Options.Sound) then
				PlaySound("igMiniMapOpen");
			end

			-- if we are class restricted, we show the class dialog
			if (Lootster_ClassRestricted == true) then
				Lootster_ClassFrame:Show();
			else
				-- reset class restrictions
				Lootster_ResetClass();

				-- update the class UI
				Lootster_UpdateClass();

				-- update the UI
				Lootster_UpdateUI();
			end

			-- show
			Lootster_OptionsFrame:Show();
			Lootster_RuleFrame:Show();
			Lootster_DataFrame:Show();
			Lootster_RollFrame:Show();
			Lootster_TabsFrame:Show();
			Lootster_Title:Show();
		end
	else
		-- ensure the button is unpressed
		Lootster_Title:SetChecked(false);

		-- normal operation
		if (Lootster_RollFrame:IsVisible() or Lootster_DataFrame:IsVisible() or Lootster_RuleFrame:IsVisible() or Lootster_OptionsFrame:IsVisible()) then
			if (Lootster_Options.Sound) then
				PlaySound("igMiniMapClose");
			end

			-- hide
			Lootster_TabsFrame:Hide();
			Lootster_RollFrame:Hide();
			Lootster_DataFrame:Hide();
			Lootster_RuleFrame:Hide();
			Lootster_OptionsFrame:Hide();

			Lootster_ClassFrame:Hide();

			-- hide dialogs et al
			Lootster_DataFrameAdjustDKPFrame:Hide();

			Lootster_DataFrameRaidAttendFrame:Hide();
			Lootster_DataFrameDKPAdjustsFrame:Hide();

			-- are we in Normal 100/1000 mode using auto-clear on close?
			if ((Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USENORM) and (Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000) and (Lootster_Options.CorKClose == true)) then
				-- clear rolls
				Lootster_Roll_ClearRolls_OnClick();
			end
		else
			if (Lootster_Options.Sound) then
				PlaySound("igMiniMapOpen");
			end

			-- if we are class restricted, we show the class dialog
			if (Lootster_ClassRestricted == true) then
				Lootster_ClassFrame:Show();
			else
				-- reset class restrictions
				Lootster_ResetClass();

				-- update the class UI
				Lootster_UpdateClass();

				-- update the UI
				Lootster_UpdateUI();
			end

			-- show
			Lootster_OptionsFrame:Show();
			Lootster_RuleFrame:Show();
			Lootster_DataFrame:Show();
			Lootster_RollFrame:Show();
			Lootster_TabsFrame:Show();
		end
	end
end

-- Adjustments Load handler
function Lootster_AdjustLoad()
	local	dkpcount = 0;
	local	dkp;
	local	tier, app, trial, prior;

	local	ix = 0;

	-- reset DKP and adjust total lists
	Lootster_DKP = {};
	Lootster_AdjustTotal = {};

	-- create the DKP table
	for player, dkpRec in pairs(Lootster_MainDKP) do
		-- determine the dkp and tier for this raw dkp
		dkp = Lootster_CalcDKP(dkpRec.DKP);
		tier = Lootster_CalcTier(dkpRec.DKP);

		-- determine membership, if any
		app = (dkpRec.App ~= nil) and dkpRec.App;
		trial = (dkpRec.Trial ~= nil) and dkpRec.Trial;

		-- calculate membership priority
		prior = Lootster_CalcPriority(app, trial);

		-- stuff into DKP table
		Lootster_DKP[player] = { Player=player, Class="-", DKP=dkp, DKPRaw=dkpRec.DKP, DKPAdj=0, Tier=tier, App=app, Trial=trial, Priority=prior };

		-- stuff into adjustment total table
		Lootster_AdjustTotal[player] = { Player=player, DKPAct=nil, DKPTot=0, Epoch=time(), RecIx=nil };

		-- dump player count
		dkpcount = dkpcount + 1;
	end

	-- initialise the park player indirection table
	for key, value in pairs(Lootster_ParkDKP) do
		ix = ix + 1;

		Lootster_ParkSort[ix] = key;
	end

	-- sort the park players
	table.sort(Lootster_ParkSort);

	-- add park players to DKP and Adjust table
	for player, parRec in pairs(Lootster_ParkDKP) do
		-- determine the tier for no DKP
		dkp = Lootster_CalcDKP(0);
		tier = Lootster_CalcTier(0);

		-- calculate membership priority
		prior = Lootster_CalcPriority(false, false);

		-- stuff into DKP table
		Lootster_DKP[player] = { Player=player, Class="-", DKP=dkp, DKPRaw=0, DKPAdj=0, Tier=tier, App=false, Trial=false, Priority=prior };

		-- stuff into adjustment total table
		Lootster_AdjustTotal[player] = { Player=player, DKPAct=nil, DKPTot=0, Epoch=time(), RecIx=nil };

		-- dump player count
		dkpcount = dkpcount + 1;
	end

	-- process the adjustment table
	for ix, adjRec in ipairs(Lootster_Adjust) do
		-- is this guy an alt total record?
		if		((Lootster_AltsDKP[adjRec.Player] ~= nil) and (adjRec.DKPAct == nil)) then
			-- we have a total record for an alt - delete it
			table.remove(Lootster_Adjust, ix);

			ix = ix - 1;
		else
			-- is this an alt record?
			if	(Lootster_AltsDKP[adjRec.Player] ~= nil) then
				-- the main became the alt - transfer the adjustment record
				adjRec.Player = Lootster_AltsDKP[adjRec.Player].Name;
			end

			-- have we got a total record yet?
			if (Lootster_AdjustTotal[adjRec.Player] == nil) then
				-- new total adjustment record
				Lootster_AdjustTotal[adjRec.Player] = { Player=adjRec.Player, DKPAct=nil, DKPTot=0, Epoch=time(), RecIx=nil };
			end

			-- see if this adjustment record is a total record
			if (adjRec.DKPAct == nil) then
				-- yup, so snarf it's index
				Lootster_AdjustTotal[adjRec.Player].RecIx=ix;
			else
				-- accumulate its actual DKP adjustment
				Lootster_AdjustTotal[adjRec.Player].DKPTot=Lootster_AdjustTotal[adjRec.Player].DKPTot + adjRec.DKPAct;
			end

			-- update this adjustment record's running total
			adjRec.DKPTot = Lootster_AdjustTotal[adjRec.Player].DKPTot;
		end
	end

	-- for any adjustment totals that don't have a adjustment record, create one
	for player, totRec in pairs(Lootster_AdjustTotal) do
		-- no adjust record index?
		if (totRec.RecIx == nil) then
			-- create total record for this guy
			table.insert(Lootster_Adjust, { Player=player, DKPAct=nil, DKPTot=totRec.DKPTot, Epoch=time(), Reason=LOOTSTER_ADJUSTDKP_TOTALREASON, Comment="" });

			-- bookkeep the record index
			totRec.RecIx = table.getn(Lootster_Adjust);
		else
			-- update the adjustment's total record
			Lootster_Adjust[totRec.RecIx].DKPTot = totRec.DKPTot;
		end

		-- do we have a DKP entry for this guy?
		if (Lootster_DKP[player] ~= nil) then
			-- stuff total adjustment into DKP table
			Lootster_DKP[player].DKPAdj = totRec.DKPTot;

			-- determine the DKP tier for this guys DKP and adjustment
			dkp = Lootster_CalcDKP(Lootster_DKP[player].DKPRaw + Lootster_DKP[player].DKPAdj);
			tier = Lootster_CalcTier(Lootster_DKP[player].DKPRaw + Lootster_DKP[player].DKPAdj);

			-- and update the DKP, tier and membership
			Lootster_DKP[player].DKP = dkp;
			Lootster_DKP[player].Tier = tier;
		else
			-- determine the tier for this adjustment
			dkp = Lootster_CalcDKP(totRec.DKPTot);
			tier = Lootster_CalcTier(totRec.DKPTot);

			-- determine membership, if any
			app = (totRec.App ~= nil) and totRec.App;
			trial = (totRec.Trial ~= nil) and totRec.Trial;

			-- calculate membership priority
			prior = Lootster_CalcPriority(app, trial);

			-- stuff into DKP table
			Lootster_DKP[player] = { Player=player, Class="-", DKP=dkp, DKPRaw=0, DKPAdj=totRec.DKPTot, Tier=tier, App=app, Trial=trial, Priority=prior };

			-- dump player count
			dkpcount = dkpcount + 1;
		end
	end

	-- update DKP table length
	table.setn(Lootster_DKP, dkpcount);
end

-- Player Entry into World handler
function Lootster_PLAYER_Enter()
	local	faction, cix;
	local	dix = 1;
	local	button;

	-- determine language and player class to jetison
	faction = UnitFactionGroup("player");

	if		(faction == "Alliance") then
		Lootster_Language = LOOTSTER_LANG_COMMON;

		Lootster_ClassIgnore = "SHAMAN";
	elseif  (faction == "Horde") then
		Lootster_Language = LOOTSTER_LANG_ORCISH;

		Lootster_ClassIgnore = "PALADIN";
	end

	-- initialise class frame
	for cix = 1, table.getn(LOOTSTER_CLASS_SORT), 1 do
		-- is this the ignore class?
		if (LOOTSTER_CLASS_SORT[cix] ~= Lootster_ClassIgnore) then
			-- get the class item button
			button = getglobal("Lootster_ClassFrameClass"..dix.."Text");

			-- hammer the text into this guy
			button:SetText(LOOTSTER_CLASS[LOOTSTER_CLASS_SORT[cix]].Singular);

			-- and bump button count
			dix = dix + 1;
		end
	end

	-- set the size of the class table to reflect count of classes
	table.setn(LOOTSTER_CLASS, dix - 1);
end

-- Party/Raid Roster handler
function Lootster_PARTY_Roster()
	local	unit, pcount, player, class, name, main;
	local	ix;

	local   adj, dkp, tier, app, trial, prior;
	local	adjRec;
	local	mcount = 0;

	-- reset attendance list
	Lootster_Roster = {};

	if		(GetNumRaidMembers() > 0) then
		-- get new player count
		pcount = GetNumRaidMembers()

		Lootster_PlayerCount = pcount;
		
		-- get the raid attendance
		for ix=1, pcount,1 do
			-- form the unit name
			unit = "raid"..ix;

			-- get the player name
			player = UnitName(unit);

			-- no player (no information there yet) or unknown, move on
			if ((player ~= nil) and (player ~= UNKNOWNOBJECT)) then
				-- get the player class
				class, classtype = UnitClass(unit);

				-- force player name to lower case for later matching
				name = string.lower(player);

				-- and bookkeep
				Lootster_Roster[player] = { Name=name, Class=class, ClassType=classtype  };
			else
				-- adjust the player count
				Lootster_PlayerCount = Lootster_PlayerCount - 1;
			end
		end
	elseif	(GetNumPartyMembers() > 0) then
		-- get new player count
		pcount = GetNumPartyMembers();

		Lootster_PlayerCount = pcount;
		
		-- get the raid attendance
		for ix=1, pcount, 1 do
			-- form the unit name
			unit = "party"..ix;

			-- get the player name
			player = UnitName(unit);

			-- no player (no information there yet) or unknown, move on
			if ((player ~= nil) and (player ~= UNKNOWNOBJECT)) then
				-- get the player class
				class, classtype = UnitClass(unit);

				-- force player name to lower case for later matching
				name = string.lower(player);

				-- and bookkeep
				Lootster_Roster[player] = { Name=name, Class=class, ClassType=classtype };
			else
				-- adjust the player count
				Lootster_PlayerCount = Lootster_PlayerCount - 1;
			end
		end

		-- add us
		Lootster_PlayerCount = Lootster_PlayerCount + 1;
	else
		-- just us
		Lootster_PlayerCount = 1;
	end

	-- force ourselves to lower case for later matching
	name = string.lower(Lootster_Self);

	Lootster_Roster[Lootster_Self] = { Name=name, Class=Lootster_SelfClass, ClassType=Lootster_SelfClassType };

	-- iterate through roll table looking for ex-parrots
	for key, value in pairs(Lootster_Rolls) do
		-- in the roster?
		if (Lootster_Roster[key] == nil) then
			-- if this guy actually rolled, adjust the roll count
			if (value.Roll ~= nil) then
				Lootster_RollCount = Lootster_RollCount - 1;
			end
				
			-- update element count
			table.setn(Lootster_Rolls, table.getn(Lootster_Rolls) - 1);

			-- remove the record
			Lootster_Rolls[key] = nil;
		end
	end

	-- reset Alt/Main and Main/Alt Look-aside Tables
	Lootster_MainALT = {};
	Lootster_ALTMain = {};

	-- create the Alt/Main and Main/Alt Look-aside Table
	for player, rosRec in pairs(Lootster_Roster) do
		-- is this guy an alt?
		if (Lootster_AltsDKP[player] ~= nil) then
			-- add this guy to the Main to Alt look-aside table
			Lootster_MainALT[Lootster_AltsDKP[player].Name] = player;

			-- add this guy to the Alt to Main look-aside table
			Lootster_ALTMain[player] = Lootster_AltsDKP[player].Name;
		end
	end

	-- anybody not in main DKP table gets a default entry
	for player, rosRec in pairs(Lootster_Roster) do
		-- get the main name for this guy (could be alt)
		main = Lootster_GetALTMain(player);

		-- this guy in the DKP table?
		if		(Lootster_DKP[main] == nil) then
			-- determine the tier for no DKP
			dkp = Lootster_CalcDKP(0);
			tier = Lootster_CalcTier(0);

			-- determine membership, if any
			app = (rosRec.App ~= nil) and rosRec.App;
			trial = (rosRec.Trial ~= nil) and rosRec.Trial;

			-- calculate membership priority
			prior = Lootster_CalcPriority(app, trial);

			-- stuff into DKP table.  Note there is no way to know the class if this is an alt
			if (main == player) then
				Lootster_DKP[main] = { Player=main, Class=rosRec.Class, DKP=dkp, DKPRaw=0, DKPAdj=0, Tier=tier, App=app, Trial=trial, Priority=prior };
			else
				Lootster_DKP[main] = { Player=main, Class="-", DKP=dkp, DKPRaw=0, DKPAdj=0, Tier=tier, App=false, Trial=false, Priority=prior };
			end

			-- stuff into adjust table
			table.insert(Lootster_Adjust, { Player=main, DKPAct=nil, DKPTot=0, Epoch=time(), Reason=LOOTSTER_ADJUSTDKP_TOTALREASON, Comment="" });

			-- bump player count
			mcount = mcount + 1;
		elseif ((main == player) and (Lootster_DKP[main].Class == "-")) then
			-- update the class since this is the main
			Lootster_DKP[main].Class = rosRec.Class;
		end
	end

	-- update DKP table length
	table.setn(Lootster_DKP, table.getn(Lootster_DKP) + mcount);

	-- update restricted count
	Lootster_UpdateRestricted();

	-- resort rolls
	Lootster_Roll_Sort();

	-- update received roll status
	Lootster_UpdateUI();

	-- update the screen
	Lootster_Roll_Update();

	-- sort DKP data using current sort
	Lootster_Data_Sort(nil);
end

-- Party/Raid Leader handler
function Lootster_PARTY_Leader()
end

-- Loot Opened handler
function Lootster_LOOT_Opened()
end

-- Loot Closed handler
function Lootster_LOOT_Closed()
	-- clear item link if we are using the loot item
	if (Lootster_ItemSlot ~= nil) then
		Lootster_Roll_ClearItem_OnClick();
	end
end

-- Loot Slot Cleared handler
function Lootster_LOOT_Slot_Cleared()
	-- reset our item if this was the guy that was toasted
	if (arg1 == Lootster_ItemSlot) then
		Lootster_LOOT_Closed();
	end
end

-- Check Location handler
function Lootster_CheckLocation()
	local width			= Lootster_RollFrame:GetWidth();
	local width2		= width / 2;
	local height		= Lootster_RollFrame:GetHeight();

	local tabwidth		= Lootster_TabsFrame:GetWidth();
	local tabheight		= Lootster_TabsFrame:GetHeight();

	Lootster_RollFrame:ClearAllPoints();
	Lootster_RollFrame:SetPoint("TOPLEFT", "Lootster_Title", "BOTTOM", -width2, 0);
	Lootster_RollFrame:SetPoint("TOPRIGHT", "Lootster_Title", "BOTTOM", width2, 0);

	Lootster_TabsFrame:ClearAllPoints();
	Lootster_TabsFrame:SetPoint("TOPLEFT", "Lootster_RollFrame", "BOTTOMLEFT", 0, 7);
	Lootster_TabsFrame:SetPoint("TOPRIGHT", "Lootster_RollFrame", "BOTTOMLEFT", tabwidth, 7-tabheight);

	Lootster_ClassFrame:ClearAllPoints();
	Lootster_ClassFrame:SetPoint("TOPLEFT", "Lootster_RollFrame", "TOPRIGHT", -7, 0);
end

-- Check Echo Use handler
function Lootster_CheckEchoUse()
	-- are we allowing click display of class restrictions?
	if (Lootster_Options.EchoRestrict == false) then
		-- disable echo To check boxes
		Lootster_OptionsFrameEchoToChat:Disable();
		Lootster_OptionsFrameEchoToCTRA:Disable();

		-- disable echo By check boxes
		Lootster_OptionsFrameEchoByClick:Disable();
		Lootster_OptionsFrameEchoByGroupLoot:Disable();
	else
		-- enable echo To check boxes
		Lootster_OptionsFrameEchoToChat:Enable();
		Lootster_OptionsFrameEchoToCTRA:Enable();

		-- enable echo By check boxes
		Lootster_OptionsFrameEchoByClick:Enable();
		Lootster_OptionsFrameEchoByGroupLoot:Enable();
	end
end		

-- Check Mode Use handler
function Lootster_CheckModeUse()
	-- show the mode widgets as required
	if		(Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP) then
		-- hide the item count
		Lootster_RollFrameItems:Hide();
		Lootster_RollFrameItemsROFrame:Hide();

		-- show loot assignment button
		Lootster_RollFrameAssignLoot:Show();

		-- show the data tab
		Lootster_DataTab:Show();

		-- show anchors to force repaint
		Lootster_Anchor1Tab:Show();
		Lootster_Anchor2Tab:Show();

		-- move rule tab relative to options tab
		Lootster_RuleTab:ClearAllPoints();
		Lootster_RuleTab:SetPoint("TOPLEFT", "Lootster_Anchor2Tab", "TOPLEFT", 0, 0);
		Lootster_RuleTab:SetPoint("BOTTOMRIGHT", "Lootster_Anchor2Tab", "BOTTOMRIGHT", 0, 0);

		-- and rehide anchors
		Lootster_Anchor2Tab:Hide();
		Lootster_Anchor1Tab:Hide();

		-- update 100/1000 UI
		Lootster_CheckCorKUse();

		-- show DKP and Tier heading for roll tab
		Lootster_RollFrameColumnHeader4:SetText(LOOTSTER_ROLL_DKP);
		Lootster_RollFrameColumnHeader5:SetText(LOOTSTER_ROLL_TIER);

		-- update rule table show rules label
		Lootster_RuleFrameRulesFrameLabel:SetText(string.format(LOOTSTER_RULE_RULE, LOOTSTER_OPTION_ROLLMODELIST[Lootster_Options.RollMode]));

		-- update rules tab with DKP rules
		Lootster_RuleFrameRulesFrameText:SetText(Lootster_Rules.RulesDKP);

		-- setup the roll type for using DKP
		Lootster_Option_RollType_OnShow();

		-- show the DKP mode option frame
		Lootster_OptionsFrameRollManageDKPFrame:Show();

		-- hide the Normal 100/1000 mode option frame
		Lootster_OptionsFrameRollManageCorKFrame:Hide();
	elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USENORM) then
		-- show the item count
		Lootster_RollFrameItems:Show();
		Lootster_RollFrameItemsROFrame:Hide();

		-- hide loot assignment button
		Lootster_RollFrameAssignLoot:Hide();

		-- hide the data tab
		Lootster_DataTab:Hide();

		-- show anchors to force repaint
		Lootster_Anchor1Tab:Show();
		Lootster_Anchor2Tab:Show();

		-- move rule tab relative to data tab
		Lootster_RuleTab:ClearAllPoints();
		Lootster_RuleTab:SetPoint("TOPLEFT", "Lootster_Anchor1Tab", "TOPLEFT", 0, 0);
		Lootster_RuleTab:SetPoint("BOTTOMRIGHT", "Lootster_Anchor1Tab", "BOTTOMRIGHT", 0, 0);

		-- and rehide anchors
		Lootster_Anchor2Tab:Hide();
		Lootster_Anchor1Tab:Hide();

		-- update 100/1000 UI
		Lootster_CheckCorKUse();

		-- what Normal mode are we using?
		if (Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000) then
			-- set DKP and Tier heading to Need or Greed
			Lootster_RollFrameColumnHeader4:SetText(LOOTSTER_ROLL_N_G);
		else
			-- erase DKP and Tier heading for roll tab
			Lootster_RollFrameColumnHeader4:SetText("");
		end

		-- erase Tier heading for roll tab
		Lootster_RollFrameColumnHeader5:SetText("");

		-- update rule table show rules label
		Lootster_RuleFrameRulesFrameLabel:SetText(string.format(LOOTSTER_RULE_RULE, LOOTSTER_OPTION_ROLLMODELIST[Lootster_Options.RollMode]));

		-- update rules tab with normal rules
		Lootster_RuleFrameRulesFrameText:SetText(Lootster_Rules.RulesNorm);

		-- setup the roll type for using DKP
		Lootster_Option_RollType_OnShow();

		-- hide the DKP mode option frame
		Lootster_OptionsFrameRollManageDKPFrame:Hide();

		-- see what Normal type is in effect
		if (Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000) then
			-- show the Normal 100/1000 mode option frame
			Lootster_OptionsFrameRollManageCorKFrame:Show();
		else
			-- hide the Normal 100/1000 mode option frame
			Lootster_OptionsFrameRollManageCorKFrame:Hide();
		end
	end
end

-- Check 100/1000 Use handler
function Lootster_CheckCorKUse()
	-- show the 100/1000 widgets as required
	if		((Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USENORM) and (Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000)) then
		-- hide normal buttons
		Lootster_RollFrameNeedRoll:Hide();
		Lootster_RollFrameGreedRoll:Hide();

		Lootster_RollFrameRoll:Hide();

		-- show CorK buttons
		Lootster_RollFrame1001000Roll:Show();

		Lootster_RollFrameRoll100:Show();
		Lootster_RollFrameRoll1000:Show();

		-- do we allow auto-roll?
		if (Lootster_Options.CorKRoll == false) then
			-- disable other CorK options
			Lootster_OptionsFrameNormCorKOpen:Disable();
			Lootster_OptionsFrameNormCorKClose:Disable();
		else
			-- enable other CorK options
			Lootster_OptionsFrameNormCorKOpen:Enable();
			Lootster_OptionsFrameNormCorKClose:Enable();
		end
	else
		-- show normal buttons
		Lootster_RollFrameNeedRoll:Show();
		Lootster_RollFrameGreedRoll:Show();

		Lootster_RollFrameRoll:Show();

		-- hide CorK buttons
		Lootster_RollFrame1001000Roll:Hide();

		Lootster_RollFrameRoll100:Hide();
		Lootster_RollFrameRoll1000:Hide();
	end
end

-- Process Restrictions handle
function Lootster_ProcessRestrictions(link, slot)
	local	itemLink, ix, field, text, classes, class, flag;

	-- reset item details
	Lootster_ItemID = nil;
	Lootster_ItemLink = nil;
	Lootster_ItemSlot = nil;
	Lootster_ItemText = "";

	-- reset class restrictions
	Lootster_ResetClass();

	-- do we have an item?
	if (link ~= nil) then
		-- wire in item link
		Lootster_ItemLink = link;

		-- do we have a slot?
		if (slot ~= nil) then
			-- wire up slot
			Lootster_ItemSlot = slot;
		end

		-- get the item details for this link
		Lootster_ItemID, 
		Lootster_ItemText, 
		Lootster_ClassRestricted, 
		Lootster_ClassRestrictedLock, 
		Lootster_ClassRestrictions, 
		Lootster_ClassRestrictionsMaskOrig = Lootster_GetItemDetails(Lootster_ItemLink);

		-- save orginal mask as current mask to dected changes
		Lootster_ClassRestrictionsMaskCurr = Lootster_ClassRestrictionsMaskOrig;
	end

	-- did we find restrictions?
	if (Lootster_ClassRestricted == true) then
		-- update the class frame
		Lootster_UpdateClass();
		 
		-- update restricted count
		Lootster_UpdateRestricted();

		-- show the class frame if we are visible
		if (Lootster_RollFrame:IsVisible() or Lootster_DataFrame:IsVisible() or Lootster_RuleFrame:IsVisible() or Lootster_OptionsFrame:IsVisible()) then
			Lootster_ClassFrame:Show();
		end
	else
		-- update the class UI
		Lootster_UpdateClass();
	end

	-- update the UI
	Lootster_UpdateUI();
end

-- Process Assignment handler
function Lootster_ProcessAssignment()
	local	name, items, dkp, reason;

	-- reset located items, dkp and text
	items = 0;
	dkp = 0;
	reason = "";

	-- do we have link text?
	if (Lootster_ItemText ~= nil) then
		-- attempt to locate this item
		name = string.lower(Lootster_ItemText);

		for itemkey, itemRec in pairs(Lootster_ItemDKP) do
			-- does this item match the current loot?
			if (string.find(itemRec.Name, name) ~= nil) then
				-- snarf the dkp
				dkp = -itemRec.DKP;

				-- and bump located count
				items = items + 1;
			end
		end

		-- if we found more that one item, reset DKP since we don't know which one
		if (items ~= 1) then
			dkp = 0;
		end

		-- snarf item text for reason
		reason = Lootster_ItemText;
	end

	return dkp, reason, items;
end

-- Roll Clear Rolls handler
function Lootster_Roll_ClearRolls_OnClick()
	-- erase rolls
	Lootster_Rolls = {};

	-- reset record count
	table.setn(Lootster_Rolls, 0);

	-- reset the roll sorts
	Lootster_RollsSort = {};

	-- reset record count
	table.setn(Lootster_RollsSort, 0);

	-- reset roll and restricted count
	Lootster_RollCount = 0;

	-- reset current roll NBG to nothing (between roll calls)
	Lootster_NBG = nil;

	-- reset tied indicator, rolls and count
	Lootster_Tied = false;
	Lootster_TiedRolls = {};
	Lootster_TiedItemCount = 0;

	-- reset item count
	Lootster_RollFrameItems:SetNumber(1);

	-- and spoof entry to transfer and update
	Lootster_Roll_Items_Entered();

	-- reset pass/reclaim text
	Lootster_RollFramePassReclaim:SetText(LOOTSTER_ROLL_PASS);

	-- update the roll
	Lootster_UpdateRoll();

	-- update received counter
	Lootster_UpdateUI();

	-- and update the screen
	Lootster_Roll_Update();
end

-- Items handler
function Lootster_Roll_Items_Entered()
	-- get the new item count
	Lootster_ItemCount = Lootster_RollFrameItems:GetNumber();

	-- must be positive
	if (Lootster_ItemCount < 0) then
		Lootster_ItemCount = 1;
		
		-- update
		Lootster_RollFrameItems:SetNumber(Lootster_ItemCount);
	else
		-- update read-only RO version
		Lootster_RollFrameItemsRO:SetText(Lootster_ItemCount);
	end

	-- update item prompt
	Lootster_UpdateItemPrompt();
end

-- Assign Loot handler
function Lootster_Roll_AssignLoot_OnClick()
	local	count, dkp, reason;

	-- no positive rolls means we don't have a winner
	if		((Lootster_RollCount > 0) and (Lootster_Rolls[Lootster_RollsSort[1]].Roll > 0)) then
		-- get the player (name and main)
		Lootster_AdjustName = Lootster_Rolls[Lootster_RollsSort[1]].Player;
		Lootster_AdjustMain = Lootster_GetALTMain(Lootster_AdjustName);
	elseif	(Lootster_ItemLink ~= nil) then
		-- no winner yet
		Lootster_AdjustName = nil;
		Lootster_AdjustMain = nil;
	end

	-- retrieve default DKP and reason text
	dkp, reason = Lootster_ProcessAssignment();

	-- set default DKP value and reason
	Lootster_RollFrameAssignLootFrameDKP:SetNumber(dkp);
	Lootster_RollFrameAssignLootFrameReason:SetText(reason);

	-- no comment
	Lootster_RollFrameAssignLootFrameCommentText:SetText("\n");

	-- show loot assignment frame
	Lootster_RollFrameAssignLootFrame:Show();
end

-- Active Toggle handler
function Lootster_Roll_ActiveButton_Toggle()
	-- this is easy
	Lootster_Options.Active = (Lootster_RollFrameActive:GetChecked() ~= nil);

	-- disable/enable passive rolling checkbox
	if (Lootster_Options.Active == true) then
		Lootster_RollFramePassive:Disable();
	else
		Lootster_RollFramePassive:Enable();
	end

	-- update roll handling
	Lootster_UpdateUI();
end

-- Need Roll Call handler
function Lootster_Roll_NeedRoll_OnClick()
	-- set current roll NBG to need
	Lootster_NBG = LOOTSTER_NBG_NEED;

	-- if the item count is less than or equal to zero, set to 1
	if (Lootster_ItemCount <= 0) then
		-- set item count to default
		Lootster_RollFrameItems:SetNumber(1);

		-- and spoof entry to transfer and update
		Lootster_Roll_Items_Entered();
	end

	-- create roll plead and ignore texts
	Lootster_CreatePlead();

	-- calculate player positioning for DKP
	Lootster_CalculatePositions();

	-- update received roll status
	Lootster_UpdateUI();	

	-- format the need roll message and let everyone know
	if		(Lootster_ItemPrompt == nil) then
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_NBG, Lootster_NBG_ClassPlease, Lootster_NBG));
	elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USENORM) then
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_NBG_LINK, Lootster_NBG_ClassPlease, Lootster_NBG, Lootster_ItemPrompt));
	else
		local	dkp, reason, items, cost;
		
		-- retrieve default DKP, reason text and item count
		dkp, reason, items = Lootster_ProcessAssignment();

		if		(items == 0) then
			-- to be determined
			cost = LOOTSTER_COST_DKPTDB;
		elseif	(dkp == 0) then
			-- no cost or to be determined
			cost = LOOTSTER_COST_DKP0TDB;
		else
			-- format cost
			cost = string.format(LOOTSTER_COST_DKP, -dkp);
		end
		
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_NBG_LINK_COST, Lootster_NBG_ClassPlease, Lootster_NBG, Lootster_ItemPrompt, cost));
	end

	-- are we using DKP?
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP) then
		-- if this is DKP by Tier, broadcast tiers prompt
		if (Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
			Lootster_SendBroadcast(Lootster_TiersPrompt);
		end

		-- hammer through the roster whispering each their DKP
		for player, rosRec in pairs(Lootster_Roster) do
			-- are we using class restrictions?
			if ((Lootster_ClassRestricted == false) or ((Lootster_ClassRestrictions[rosRec.ClassType] ~= nil) and (Lootster_ClassRestrictions[rosRec.ClassType] == true))) then
				-- echo roll to player with class
				Lootster_EchoPlayerRoll(player);
			end
		end
	end
end

-- Greed Roll Call handler
function Lootster_Roll_GreedRoll_OnClick()
	-- set current roll NBG to greed
	Lootster_NBG = LOOTSTER_NBG_GREED;

	-- if the item count is less than or equal to zero, set to 1
	if (Lootster_ItemCount <= 0) then
		-- set item count to default
		Lootster_RollFrameItems:SetNumber(1);

		-- and spoof entry to transfer and update
		Lootster_Roll_Items_Entered();
	end

	-- create roll plead and ignore texts
	Lootster_CreatePlead();	

	-- calculate player positioning for DKP
	Lootster_CalculatePositions();

	-- update received roll status
	Lootster_UpdateUI();	

	-- format the greed roll message and let everyone know
	if (Lootster_ItemPrompt == nil) then
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_NBG, Lootster_NBG_ClassPlease, Lootster_NBG));
	elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USENORM) then
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_NBG_LINK, Lootster_NBG_ClassPlease, Lootster_NBG, Lootster_ItemPrompt));
	else
		local	dkp, reason, items, cost;
		
		-- retrieve default DKP, reason text and item count
		dkp, reason, items = Lootster_ProcessAssignment();

		if		(items == 0) then
			-- to be determined
			cost = LOOTSTER_COST_DKPTDB;
		elseif	(dkp == 0) then
			-- no cost or to be determined
			cost = LOOTSTER_COST_DKP0TDB;
		else
			-- format cost
			cost = string.format(LOOTSTER_COST_DKP, -dkp);
		end
		
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_NBG_LINK_COST, Lootster_NBG_ClassPlease, Lootster_NBG, Lootster_ItemPrompt, cost));
	end

	-- are we using DKP?
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP) then
		-- if this is DKP by Tier, broadcast tiers prompt
		if (Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
			Lootster_SendBroadcast(Lootster_TiersPrompt);
		end

		-- hammer through the roster whispering each their DKP
		for player, value in pairs(Lootster_Roster) do
			-- echo roll to player
			Lootster_EchoPlayerRoll(player);
		end
	end
end

-- 100/1000 Roll Call handler
function Lootster_Roll_1001000Roll_OnClick()
	-- set current roll NBG to 100/1000
	Lootster_NBG = LOOTSTER_NBG_1001000;

	-- if the item count is less than or equal to zero, set to 1
	if (Lootster_ItemCount <= 0) then
		-- set item count to default
		Lootster_RollFrameItems:SetNumber(1);

		-- and spoof entry to transfer and update
		Lootster_Roll_Items_Entered();
	end

	-- create roll plead and ignore texts
	Lootster_CreatePlead();

	-- calculate player positioning for DKP
	Lootster_CalculatePositions();

	-- update received roll status
	Lootster_UpdateUI();	

	-- format the 100/1000 roll message and let everyone know
	if		(Lootster_ItemPrompt == nil) then
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_NBG, Lootster_NBG_ClassPlease, Lootster_NBG));
	else
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_NBG_LINK, Lootster_NBG_ClassPlease, Lootster_NBG, Lootster_ItemPrompt));
	end
end

-- Tied Roll Call handler
function Lootster_Roll_TiedRoll_OnClick()
	local	count, ix;

	local	msgTie = "";

	-- set current roll NBG to tied
	Lootster_NBG = LOOTSTER_NBG_TIED;

	-- reset roll count
	Lootster_RollCount = 0;

	-- set the new item count of items remaining to be distributed
	Lootster_RollFrameItems:SetNumber(Lootster_TiedItemCount);

	-- and spoof entry to transfer and update
	Lootster_Roll_Items_Entered();

	-- reset list of rolls and sort order
	Lootster_Rolls = {};
	Lootster_RollsSort = {};

	-- build list of ties to roll
	count = table.getn(Lootster_TiedRolls);

	for ix=1, count, 1 do
		-- copy this tied player
		Lootster_Rolls[Lootster_TiedRollsSort[ix]] = Lootster_TiedRolls[Lootster_TiedRollsSort[ix]];

		-- update the sort order
		Lootster_RollsSort[ix] = Lootster_TiedRolls[Lootster_TiedRollsSort[ix]].Player;

		-- add name
		msgTie = msgTie..Lootster_TiedRolls[Lootster_TiedRollsSort[ix]].Player;

		if		(ix < (count - 1)) then
			msgTie = msgTie..LOOTSTER_MSG_SEP;
		elseif	(ix == (count - 1)) then
			msgTie = msgTie..LOOTSTER_MSG_AND;
		end
	end

	-- update count of rolls
	table.setn(Lootster_Rolls, count);
	table.setn(Lootster_RollsSort, count);

	-- update the screen
	Lootster_Roll_Update();

	-- update the roll
	Lootster_UpdateRoll();

	-- update received roll status
	Lootster_UpdateUI();	

	-- format the tied roll message and let everyone know
	if (Lootster_ItemPrompt == nil) then
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_NBGTIED, msgTie, Lootster_NBG));
	else
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_NBGTIED_LINK, msgTie, Lootster_NBG, Lootster_ItemPrompt));
	end
end

-- Roll Count handler
function Lootster_Roll_RollCount_OnClick()
	local	rcount, rix, lcount, lix, player;

	local	msgLagName = "";

	local	playerLag = {};

	-- get the count of rolls
	rcount = table.getn(Lootster_Rolls);

	-- build yet to roll or pass announcement
	for rix=1, rcount, 1 do
		-- has this guy rolled?
		if (Lootster_Rolls[Lootster_RollsSort[rix]].Roll == nil) then
			-- add the laggard
			table.insert(playerLag, rix);
		end
	end

	if (table.getn(playerLag) ~= 0) then
		-- get count of laggards
		lcount = table.getn(playerLag);

		-- build laggard announcement
		for lix=1, lcount, 1 do
			-- put the laggard in the message
			msgLagName = msgLagName..Lootster_Rolls[Lootster_RollsSort[playerLag[lix]]].Player

			if		(lix < (lcount - 1)) then
				msgLagName = msgLagName..LOOTSTER_MSG_SEP;
			elseif	(lix == (lcount - 1)) then
				msgLagName = msgLagName..LOOTSTER_MSG_AND;
			end
		end

		-- announce the laggards.  Determine message
		if (Lootster_ItemLink == nil) then
			-- see how many laggards we have
			if (lcount == 1) then
				Lootster_SendBroadcast(string.format(LOOTSTER_MSG_LAGGARD1, msgLagName));
			else
				Lootster_SendBroadcast(string.format(LOOTSTER_MSG_LAGGARDN, msgLagName));
			end
		else
			-- how many many laggards we have
			if (lcount == 1) then
				Lootster_SendBroadcast(string.format(LOOTSTER_MSG_LAGGARD1_LINK, msgLagName, Lootster_ItemLink));
			else
				Lootster_SendBroadcast(string.format(LOOTSTER_MSG_LAGGARDN_LINK, msgLagName, Lootster_ItemLink));
			end
		end

		-- hammer through each player sending them their roll command, as required
		for lix=1, lcount, 1 do
			-- snarf player
			player = Lootster_Rolls[Lootster_RollsSort[playerLag[lix]]].Player;

			-- have they switched off laggard roll command tells?
			if (Lootster_TestPlayerTell(player, "AckNoRoll") == true) then
				-- send them their roll command
				Lootster_AskForRoll(player);
			end
		end
	end
end

-- Roll Countdown handler
function Lootster_Roll_Countdown_OnClick()
	-- initialise countdown counter
	Lootster_CountdownCount = Lootster_Options.CounterSec;

	-- reset the timer frame update time
	Lootster_Timer.timeSinceLastUpdate = 0;

	-- and let people know
	if (Lootster_ItemLink == nil) then
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_COUNTDOWN, Lootster_NBG, Lootster_CountdownCount));
	else
		Lootster_SendBroadcast(string.format(LOOTSTER_MSG_COUNTDOWN_LINK, Lootster_NBG, Lootster_ItemLink, Lootster_CountdownCount));
	end
end

-- Roll Announce handler
function Lootster_Roll_Announce_OnClick()
	local	items, wcount, rcount, tcount, wix, rix, tix, cix;

	local	rollInfo, msgRollName, msgRollPrefix;

	local	msgWinName = "";
	local	msgWinRoll = "";
	local	msgTieName = "";
	local	msgRollInfo = "";

	local	msgRemain = "";

	local	playerCan = {};
	local	playerWin = {};
	local	playerTie = {};

	-- determine the roll type and whether there is roll info
	if		((Lootster_NBG == LOOTSTER_NBG_TIED) or (Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USENORM)) then
		-- no roll information, normal roll
		rollInfo = false;
		msgRollName = "";
		msgRollPrefix = LOOTSTER_ROLL_PREFIX;
	elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYDKP) then
		-- has roll information, DKP-based roll
		rollInfo = true;
		msgRollName = LOOTSTER_ROLL_DKPNAME;
		msgRollPrefix = LOOTSTER_ROLL_DKPPREFIX;
	elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
		-- has roll information, Tier-based roll
		rollInfo = true;
		msgRollName = LOOTSTER_ROLL_TIERNAME;
		msgRollPrefix = LOOTSTER_ROLL_TIERPREFIX;
	elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYMODIFIED) then
		-- has roll information, Modified DKP roll
		rollInfo = true;
		msgRollName = "";
		msgRollPrefix = LOOTSTER_ROLL_DKPMODIFIEDPREFIX;
	else
		-- no roll information, normal roll
		rollInfo = false;
		msgRollName = "";
		msgRollPrefix = LOOTSTER_ROLL_PREFIX;
	end

	-- snarf count of items to distribute
	items = Lootster_ItemCount;

	-- snarf count of items to distribute in event of a tie
	Lootster_TiedItemCount = Lootster_ItemCount;

	-- get the count of rolls
	rcount = table.getn(Lootster_Rolls);

	-- set roll index
	rix = 1;

	-- while we have items to win, get winners
	while ((items > 0) and (rix <= rcount)) do
		-- do we have a valid roll?
		if ((Lootster_Rolls[Lootster_RollsSort[rix]].Roll == nil) or (Lootster_Rolls[Lootster_RollsSort[rix]].Roll <= 0)) then
			-- none left in the list can be a valid roll
			rix = rcount + 1;
		else
			-- get this candidate
			playerCan = { rix };

			-- calculate starting index for ties
			tix = rix + 1;

			-- gather all the possible candidates with the same roll
			while ((tix <= rcount) and (Lootster_RollEqual(Lootster_RollsSort[rix], Lootster_RollsSort[tix]) == true)) do
				-- get tieing  player
				table.insert(playerCan, tix);

				tix = tix + 1;
			end

			-- okay, now see if all the tieing players each have a item available for them
			if ((items - (tix - rix)) >= 0) then
				-- we have some winners!
				for cix in playerCan do
					table.insert(playerWin, playerCan[cix]);
				end

				-- subtract these won items from the tied item count
				Lootster_TiedItemCount = Lootster_TiedItemCount - (tix - rix);
			else
				-- we have some ties!
				for cix in playerCan do
					table.insert(playerTie, playerCan[cix]);
				end
			end

			-- calculate the remaining items to roll on
			items = items - (tix - rix);

			-- the roll starting position is where we left off
			rix = tix;
		end
	end

	-- see if we have any outright winners
	if (table.getn(playerWin) ~= 0) then
		-- get count of winners
		wcount = table.getn(playerWin);

		-- build winners announcement
		for wix=1, wcount, 1 do
			-- add name
			msgWinName = msgWinName..Lootster_Rolls[Lootster_RollsSort[playerWin[wix]]].Player;

			-- add roll
			msgWinRoll = msgWinRoll..Lootster_Rolls[Lootster_RollsSort[playerWin[wix]]].Roll;

			-- is there roll information?
			if (rollInfo == true) then
				-- we have roll information - gather it up
				if		(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYDKP) then
					msgRollInfo = string.format(LOOTSTER_ROLL_INFO, msgRollName, Lootster_Rolls[Lootster_RollsSort[playerWin[wix]]].Priority, Lootster_Rolls[Lootster_RollsSort[playerWin[wix]]].DKP);
				elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
					msgRollInfo = string.format(LOOTSTER_ROLL_INFO, msgRollName, Lootster_Rolls[Lootster_RollsSort[playerWin[wix]]].Priority, Lootster_Rolls[Lootster_RollsSort[playerWin[wix]]].Tier);
				else
					msgRollInfo = "";
				end
			else
				msgRollInfo = "";
			end

			if		(wcount == 1) then
				msgWinRoll = msgWinRoll..msgRollInfo;
			elseif	(wix < (wcount - 1)) then
				msgWinName = msgWinName..LOOTSTER_MSG_SEP;
				msgWinRoll = msgWinRoll..msgRollInfo..LOOTSTER_MSG_SEP;
			elseif	(wix == (wcount - 1)) then
				msgWinName = msgWinName..LOOTSTER_MSG_AND;
				msgWinRoll = msgWinRoll..msgRollInfo..LOOTSTER_MSG_AND;
			end
		end

		-- announce outright winners
		if (Lootster_ItemLink == nil) then
			Lootster_SendBroadcast(string.format(LOOTSTER_MSG_ANNOUNCE, msgWinName, msgRollPrefix, msgWinRoll));
		else
			Lootster_SendBroadcast(string.format(LOOTSTER_MSG_ANNOUNCE_LINK, msgWinName, Lootster_ItemLink, msgRollPrefix, msgWinRoll));
		end
	end

	-- see if we have any tied players or items left over
	if		(table.getn(playerTie) ~= 0) then
		-- reset list of tied rolls and sort order
		Lootster_TiedRolls = {};
		Lootster_TiedRollsSort = {};

		-- get count of ties
		tcount = table.getn(playerTie);

		-- copy tied players and build tied announcement
		for tix=1, tcount, 1 do
			-- copy this tied player
			Lootster_TiedRolls[Lootster_RollsSort[playerTie[tix]]] = Lootster_CopyRecord(Lootster_Rolls[Lootster_RollsSort[playerTie[tix]]]);

			-- update the sort order
			Lootster_TiedRollsSort[tix] = Lootster_Rolls[Lootster_RollsSort[playerTie[tix]]].Player;

			-- add name
			msgTieName = msgTieName..Lootster_Rolls[Lootster_RollsSort[playerTie[tix]]].Player;

			if		(tix < (tcount - 1)) then
				msgTieName = msgTieName..LOOTSTER_MSG_SEP;
			elseif	(tix == (tcount - 1)) then
				msgTieName = msgTieName..LOOTSTER_MSG_AND;
			end
		end

		-- update count of ties
		table.setn(Lootster_TiedRolls, tcount);
		table.setn(Lootster_TiedRollsSort, tcount);

		-- is there roll information?
		if (rollInfo == true) then
			-- we have roll information - gather it up
			if		(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYDKP) then
				msgRollInfo = Lootster_Rolls[Lootster_RollsSort[playerTie[1]]].Roll..string.format(LOOTSTER_ROLL_INFO, msgRollName, Lootster_Rolls[Lootster_RollsSort[playerTie[1]]].Priority, Lootster_Rolls[Lootster_RollsSort[playerTie[1]]].DKP);
			elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
				msgRollInfo = Lootster_Rolls[Lootster_RollsSort[playerTie[1]]].Roll..string.format(LOOTSTER_ROLL_INFO, msgRollName, Lootster_Rolls[Lootster_RollsSort[playerTie[1]]].Priority, Lootster_Rolls[Lootster_RollsSort[playerTie[1]]].Tier);
			else
				msgRollInfo = Lootster_Rolls[Lootster_RollsSort[playerTie[1]]].Roll;
			end
		else
			msgRollInfo = Lootster_Rolls[Lootster_RollsSort[playerTie[1]]].Roll;
		end

		-- announce ties
		if (Lootster_ItemLink == nil) then
			Lootster_SendBroadcast(string.format(LOOTSTER_MSG_TIED, msgTieName, msgRollPrefix, msgRollInfo));
		else
			Lootster_SendBroadcast(string.format(LOOTSTER_MSG_TIED_LINK, msgTieName, Lootster_ItemLink, msgRollPrefix, msgRollInfo));
		end

		-- now reset current roll data for the ties
		for key, value in pairs(Lootster_TiedRolls) do
			Lootster_TiedRolls[key].Roll = nil;
			Lootster_TiedRolls[key].Bad = nil;
			Lootster_TiedRolls[key].Dup = nil;
		end

		-- set tied flag
		Lootster_Tied = true;

		-- update received roll status
		Lootster_UpdateUI();	
	elseif	(items > 0) then
		-- announce leftovers.  Determine message
		if (Lootster_ItemLink == nil) then
			-- how many left over
			if (items == 1) then
				Lootster_SendBroadcast(string.format(LOOTSTER_MSG_UNCLAIMED1));
			else
				Lootster_SendBroadcast(string.format(LOOTSTER_MSG_UNCLAIMEDN, items));
			end
		else
			-- how many left over
			if (items == 1) then
				Lootster_SendBroadcast(string.format(LOOTSTER_MSG_UNCLAIMED1_LINK, Lootster_ItemLink));
			else
				Lootster_SendBroadcast(string.format(LOOTSTER_MSG_UNCLAIMEDN_LINK, items, Lootster_ItemLink));
			end
		end
	end
end

-- Passive Button Click handler
function Lootster_Roll_PassiveButton_Toggle()
	-- this is easy
	Lootster_Options.Passive = (Lootster_RollFramePassive:GetChecked() ~= nil);

	-- update roll handling
	Lootster_UpdateUI();
end

-- Roll Roll handler
function Lootster_Roll_Roll_OnClick()
	-- good luck!
	RandomRoll(1, Lootster_SelfRoll)
end

-- Roll Roll 100 handler
function Lootster_Roll_Roll100_OnClick()
	-- good luck!
	RandomRoll(1, 100)
end

-- Roll Roll 1000 handler
function Lootster_Roll_Roll1000_OnClick()
	-- good luck!
	RandomRoll(1, 1000)
end

-- Pass/Reclaim Roll handler
function Lootster_Roll_PassReclaim_OnClick()
	-- see what we need to do for ourselves
	if		((Lootster_Rolls[Lootster_Self] == nil) or (Lootster_Rolls[Lootster_Self].Roll == nil) or (Lootster_Rolls[Lootster_Self].Roll >= 0)) then
		-- see if we need to inform people
		if (Lootster_PlayerCount == 1) then
			-- just pass internally
			Lootster_PassRoll(Lootster_Self);
		else
			-- let everyone know we are passing.  If we are inactive but allowing passive
			-- rolls/passes, force this bad boy out
			if ((Lootster_Options.Active == false) and (Lootster_Options.Passive == true)) then
				-- force out to party/raid chat
				Lootster_SendBroadcast(LOOTSTER_CMD_PASS, true);
			else
				-- normal broadcast...
				Lootster_SendBroadcast(LOOTSTER_CMD_PASS);
			end				
		end
	elseif	((Lootster_Rolls[Lootster_Self] ~= nil) and ((Lootster_Rolls[Lootster_Self].Roll ~= nil) and (Lootster_Rolls[Lootster_Self].Roll < 0))) then
		-- see if we need to inform people
		if (Lootster_PlayerCount == 1) then
			-- just reclaim internally
			Lootster_ReclaimRoll(Lootster_Self);
		else
			-- let everyone know we are reclaiming.  If we are inactive but allowing passive
			-- rolls/passes, force this bad boy out
			if ((Lootster_Options.Active == false) and (Lootster_Options.Passive == true)) then
				-- force out to party/raid chat
				Lootster_SendBroadcast(LOOTSTER_CMD_RECLAIM, true);
			else
				-- normal broadcast...
				Lootster_SendBroadcast(LOOTSTER_CMD_RECLAIM);
			end				
		end
	end
end

-- Roll Item handler
function Lootster_Roll_Item_OnClick(button)
	-- must have a linked item
	if (Lootster_ItemLink ~= nil) then
		-- I wonder what they think they are doing...
		if (button == "LeftButton") then
			-- are they trying to link to chat?
			if (IsShiftKeyDown()) then
				-- make sure chat window is visible
				if (ChatFrameEditBox:IsVisible()) then
					ChatFrameEditBox:Insert(Lootster_ItemLink);
				end
			else
				-- show the item if we have one
				SetItemRef(Lootster_ItemLink);
			end
		end
	end
end

-- Clear Item Link handler
function Lootster_Roll_ClearItem_OnClick()
	-- reset the hyperlinks
	Lootster_SetHyperlink(nil);

	-- update the UI
	Lootster_UpdateUI();
end

-- Item Link Click handler
function Lootster_Roll_ItemLink_OnClick()
	local	itemLink;

	-- do we have a link?
	if (Lootster_ItemLink ~= nil) then
		for itemLink in string.gfind(Lootster_ItemLink, LOOTSTER_ITEMLINK_PATTERN) do
			-- show item reference tooltip
			ShowUIPanel(ItemRefTooltip);

			-- make sure we can see it
			if (not ItemRefTooltip:IsVisible()) then
				ItemRefTooltip:SetOwner(UIParent, "ANCHOR_PRESERVE");
			end

			-- set the link
			ItemRefTooltip:SetHyperlink(itemLink);
		end
	end
end

-- Show Assign Loot handler
function Lootster_Roll_AssignLoot_OnShow()
end

-- Hide Assign Loot handler
function Lootster_Roll_AssignLoot_OnHide()
	-- reset assign loot values
	Lootster_RollFrameAssignLootFrameDKP:SetNumber(0);
	Lootster_RollFrameAssignLootFrameReason:SetText("");
	Lootster_RollFrameAssignLootFrameCommentText:SetText("\n");
end

-- Roll Assign Loot Player Show handler
function Lootster_Roll_AssignPlayer_OnShow()
	-- setup the player drop down
	UIDropDownMenu_Initialize(this, Lootster_Roll_AssignPlayer_Initialise, "MENU");

	-- set width
	UIDropDownMenu_SetWidth(160);

	-- and justify left
	Lootster_RollFrameAssignLootPlayerDropDownText:SetJustifyH("LEFT");
end

-- Roll Assign Loot Player Initaliser handler
function Lootster_Roll_AssignPlayer_Initialise()
	local	pcount, pix, gix;
	local	groupInfo = {};
	local	playerInfo = {};

	-- see what menu level we are
	if		(UIDROPDOWNMENU_MENU_LEVEL == 1) then
		-- is this a raid?
		if (GetNumRaidMembers() > 0) then
			-- reset assignment details
			Lootster_AssignGroups = {};
			Lootster_AssignPlayers = {};

			-- get player count
			pcount = GetNumRaidMembers();

			-- form menu level for raid groups
			playerInfo = {};
			playerInfo.text = LOOTSTER_ASSIGNLOOT_TO;
			playerInfo.notCheckable = 1;
			playerInfo.isTitle = 1;

			-- add title button
			UIDropDownMenu_AddButton(playerInfo);

			-- gather players and groups
			for pix=1, pcount do
				-- accumulate all the groups 
				player, _, group = GetRaidRosterInfo(pix);

				-- add group to group list
				Lootster_AssignGroups[group] = true;

				-- add player to group list, making sure we have a table for him
				if (Lootster_AssignPlayers[group] == nil) then
					Lootster_AssignPlayers[group] = {};
				end

				table.insert(Lootster_AssignPlayers[group], player);
			end

			-- form group buttons
			for gix=1, 8 do
				-- this group exists?
				if ((Lootster_AssignGroups[gix] ~= nil) and (Lootster_AssignGroups[gix] == true)) then
					-- form group button
					groupInfo = {};
					groupInfo.text = GROUP.." "..gix;
					groupInfo.hasArrow = 1;
					groupInfo.notCheckable = 1;
					groupInfo.value = gix;
					groupInfo.func = nil;

					-- add group button
					UIDropDownMenu_AddButton(groupInfo);
				end
			end

			-- form park player buttons
			for currIx, player in ipairs(Lootster_ParkSort) do
				-- form park player button
				playerInfo = {};
				playerInfo.text = player;
				playerInfo.value = player;
				playerInfo.func = Lootster_Roll_AssignPlayer_OnSelect;

				-- add player button
				UIDropDownMenu_AddButton(playerInfo);
			end
		else
			-- setup the group with no menuing.  First, us
			playerInfo = {};
			playerInfo.text = Lootster_Self;
			playerInfo.value = Lootster_Self;
			playerInfo.func = Lootster_Roll_AssignPlayer_OnSelect;

			-- add player button
			UIDropDownMenu_AddButton(playerInfo, UIDROPDOWNMENU_MENU_LEVEL);
			
			for currIx=1, MAX_PARTY_MEMBERS, 1 do
				-- get party member
				player = UnitName("party"..currIx);

				-- no player (no information there yet) or unknown, move on
				if ((player ~= nil) and (player ~= UNKNOWNOBJECT)) then
					-- form player button
					playerInfo = {};
					playerInfo.text = player;
					playerInfo.value = player;
					playerInfo.func = Lootster_Roll_AssignPlayer_OnSelect;

					-- add player button
					UIDropDownMenu_AddButton(playerInfo);
				end
			end

			-- form park player buttons
			for currIx, player in ipairs(Lootster_ParkSort) do
				-- form park player button
				playerInfo = {};
				playerInfo.text = player;
				playerInfo.value = player;
				playerInfo.func = Lootster_Roll_AssignPlayer_OnSelect;

				-- add player button
				UIDropDownMenu_AddButton(playerInfo);
			end
		end
	elseif	(UIDROPDOWNMENU_MENU_LEVEL == 2) then
		-- form the buttons for the group's players
		for pix=1, table.getn(Lootster_AssignPlayers[UIDROPDOWNMENU_MENU_VALUE]) do

			-- get the player name
			player = Lootster_AssignPlayers[UIDROPDOWNMENU_MENU_VALUE][pix];

			-- no player (no information there yet) or unknown, move on
			if ((player ~= nil) and (player ~= UNKNOWNOBJECT)) then
				-- form player button
				playerInfo = {};
				playerInfo.text = player;
				playerInfo.value = player;
				playerInfo.func = Lootster_Roll_AssignPlayer_OnSelect;

				-- add player button
				UIDropDownMenu_AddButton(playerInfo, UIDROPDOWNMENU_MENU_LEVEL);
			end
		end
	end

	-- select the winner if we have one
	if (Lootster_AdjustMain ~= nil) then
		-- he's a winner!
		UIDropDownMenu_SetText(Lootster_AdjustName, Lootster_RollFrameAssignLootPlayerDropDown);
		UIDropDownMenu_SetSelectedName(Lootster_RollFrameAssignLootPlayerDropDown, Lootster_AdjustName);

		-- enable assign button
		Lootster_RollFrameAssignLootFrameAssign:Enable();
	else
		-- no winner yet - reset
		UIDropDownMenu_SetText("", Lootster_RollFrameAssignLootPlayerDropDown);
		UIDropDownMenu_SetSelectedName(Lootster_RollFrameAssignLootPlayerDropDown, nil);

		-- disable assign button
		Lootster_RollFrameAssignLootFrameAssign:Disable();
	end
end

-- Assign Player Select handle
function Lootster_Roll_AssignPlayer_OnSelect()
	-- retrieve the selected playa (name and main)
	Lootster_AdjustName = this.value;
	Lootster_AdjustMain = Lootster_GetALTMain(Lootster_AdjustName);

	-- enable assign button
	Lootster_RollFrameAssignLootFrameAssign:Enable();

	-- and select him in the drop down
	UIDropDownMenu_SetText(Lootster_AdjustName, Lootster_RollFrameAssignLootPlayerDropDown);
	UIDropDownMenu_SetSelectedName(Lootster_RollFrameAssignLootPlayerDropDown, Lootster_AdjustName);

	-- close menus
	CloseDropDownMenus();
end

-- Roll Assign Loot DKP handler
function Lootster_Roll_AssignDKP_Entered()
end

-- Roll Assign Loot Reason handler
function Lootster_Roll_AssignReason_Entered()
end

-- Roll Assign Loot Comment handler
function Lootster_Roll_AssignComment_TextChanged()
end

-- Roll Assign Loot handler
function Lootster_AssignLoot_Assign_OnClick()
	local dkp, reason, comment, tier;

	-- no assignee we are done
	if (Lootster_AdjustMain == nil) then
		return;
	end

	-- retrieve data
	dkp = Lootster_RollFrameAssignLootFrameDKP:GetNumber();
	reason = Lootster_RollFrameAssignLootFrameReason:GetText();
	comment = Lootster_AppendTrailingLineBreak(Lootster_RollFrameAssignLootFrameCommentText:GetText());

	-- let player know there DKP was created if they are on roster
	if (Lootster_Roster[Lootster_AdjustMain] ~= nil) then
		Lootster_SendPrivate(Lootster_AdjustName, string.format(LOOTSTER_MSG_DKPCREATED, dkp, reason));
	end

	-- we are creating a new adjustment record
	table.insert(Lootster_Adjust, { Player=Lootster_AdjustMain, DKPAct=dkp, DKPTot=0, Epoch=time(), Reason=reason, Comment=comment });

	-- update the record's index
	Lootster_AdjustIx = table.getn(Lootster_Adjust);

	-- fold in new DKP
	Lootster_DKP[Lootster_AdjustMain].DKPAdj = Lootster_DKP[Lootster_AdjustMain].DKPAdj + Lootster_Adjust[Lootster_AdjustIx].DKPAct;

	-- determine the new DKP tier for this dkp and adjustment
	dkp = Lootster_CalcDKP(Lootster_DKP[Lootster_AdjustMain].DKPRaw + Lootster_DKP[Lootster_AdjustMain].DKPAdj);
	tier = Lootster_CalcTier(Lootster_DKP[Lootster_AdjustMain].DKPRaw + Lootster_DKP[Lootster_AdjustMain].DKPAdj);

	-- update the player's DKP and tier
	Lootster_DKP[Lootster_AdjustMain].DKP = dkp;
	Lootster_DKP[Lootster_AdjustMain].Tier = tier;

	-- resort DKP data using current sort
	Lootster_Data_Sort(nil);

	-- echo DKP and roll to player if in roster
	if (Lootster_Roster[Lootster_AdjustName] ~= nil) then
		Lootster_EchoPlayerDKP(Lootster_AdjustName, Lootster_AdjustName);
		Lootster_EchoPlayerRoll(Lootster_AdjustName, true);
	end

	-- did our DKP change?
	if ((Lootster_AdjustName == Lootster_Self) and (Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP)) then
		-- update our roll text
		Lootster_UpdateRoll();
	end

	-- reset adjust player
	Lootster_AdjustName = nil;
	Lootster_AdjustMain = nil;

	-- hide the UI
	Lootster_RollFrameAssignLootFrame:Hide();

	-- clear item link
	Lootster_Roll_ClearItem_OnClick();
end

-- Restrict Roll handler
function Lootster_Class_RestrictRoll_OnClick()
	-- reset class restrictions
	Lootster_ResetClass();

	-- update the class UI
	Lootster_UpdateClass();

	-- update the UI
	Lootster_UpdateUI();

	-- toggle the class restriction frame
	if (Lootster_ClassFrame:IsVisible()) then
		Lootster_ClassFrame:Hide();
	else
		Lootster_ClassFrame:Show();
	end
end

-- Restrict Roll Class handler
function Lootster_Class_PermitButton_Toggle()
	local	button, class, new;

	-- classes cannot be locked down
	if (Lootster_ClassRestrictedLock == false) then
		-- get the class item button
		button = getglobal("Lootster_ClassFrameClass"..this:GetID().."Text");

		-- retrieve the invariant class for this guy
		class = Lootster_ClassSingular[button:GetText()];

		-- is this a new class entry?
		if (Lootster_ClassRestrictions[class] == nil) then
			-- bump count
			table.setn(Lootster_ClassRestrictions, table.getn(Lootster_ClassRestrictions) + 1);
		end

		-- mark the class appropriately
		Lootster_ClassRestrictions[class] = (this:GetChecked() ~= nil);

		-- update the current restriction mask accordingly
		if (Lootster_ClassRestrictions[class] == false) then
			Lootster_ClassRestrictionsMaskCurr = bit.band(Lootster_ClassRestrictionsMaskCurr, bit.bnot(LOOTSTER_CLASS[class].Mask));
		else
			Lootster_ClassRestrictionsMaskCurr = bit.bor(Lootster_ClassRestrictionsMaskCurr, LOOTSTER_CLASS[class].Mask);
		end

		-- mark roll as class restricted if we have some classes marked
		Lootster_ClassRestricted = (Lootster_ClassRestrictionsMaskCurr ~= 0);

		-- update restricted count
		Lootster_UpdateRestricted();

		-- update the UI
		Lootster_UpdateUI();
	end
end

-- Display Custom Restrictions Class handler
function Lootster_Class_Display_OnClick(itemLink)
	local	itemText = "";
	local	restrictions = {};

	local	permitted = "";
	-- have we been passed a link, or we use current?
	if (itemLink == nil) then
		-- use current link, text and restrictions
		itemLink = Lootster_ItemLink;
		itemText = Lootster_ItemText;

		restrictions = Lootster_ClassRestrictions;
	else
		-- retrieve text and restrictions for the link
		_, itemText, _, _, restrictions = Lootster_GetItemDetails(itemLink);
	end

	-- see if we have class restrictions
	if (table.getn(restrictions) > 0) then
		local	class, count, ix;
		local	classes = {};

		-- build an alphabetical list of restricted classes
		for ix, flag in ipairs(LOOTSTER_CLASS_SORT) do
			-- this class restricted?
			if ((LOOTSTER_CLASS_SORT[ix] ~= Lootster_ClassIgnore) and (restrictions[LOOTSTER_CLASS_SORT[ix]] == true)) then
				table.insert(classes, LOOTSTER_CLASS_SORT[ix]);
			end
		end

		-- now build the class please and class ignore texts
		count = table.getn(classes);

		for ix=1, count, 1 do
			-- add plural class to please text
			permitted = permitted..LOOTSTER_CLASS[classes[ix]].Plural;

			if		(ix < (count - 1)) then
				permitted = permitted..LOOTSTER_MSG_SEP;
			elseif (ix == (count - 1)) then
				permitted = permitted..LOOTSTER_MSG_AND;
			end
		end

		-- do we have no class restrictions?
		if (count == 0) then
			-- let them know there are none
			permitted = LOOTSTER_MSG_NORESTRICTIONS;
		end
	else
		-- let them know there are none
		permitted = LOOTSTER_MSG_NORESTRICTIONS;
	end

	-- do we have an item?
	if (itemLink == nil) then
		-- punching this out to party/raid?
		if (Lootster_Options.EchoToChat == true) then
			-- broadcast
			Lootster_SendBroadcast(string.format(LOOTSTER_MSG_CHATRESTRICT, LOOTSTER_LABEL_LOOTSTER, permitted), true);
		end

		-- punching this out to CT_RaidAssist?
		if ((Lootster_Options.EchoToCTRA == true) and (CT_RA_Channel ~= nil) and (CT_RA_Level > 0)) then
			-- broadcast
			CT_RA_AddMessage(LOOTSTER_CTRACMD_MSG..string.format(LOOTSTER_MSG_CHATRESTRICT, LOOTSTER_LABEL_LOOTSTER, permitted));
		end
	else
		-- punching this out to party/raid?
		if (Lootster_Options.EchoToChat == true) then
			-- broadcast
			Lootster_SendBroadcast(string.format(LOOTSTER_MSG_CHATRESTRICT_LINK, LOOTSTER_LABEL_LOOTSTER, itemText, permitted), true);
		end

		-- punching this out to CT_RaidAssist and we are able to?
		if ((Lootster_Options.EchoToCTRA == true) and (CT_RA_Channel ~= nil) and (CT_RA_Level > 0)) then
			-- broadcast
			CT_RA_AddMessage(LOOTSTER_CTRACMD_MSG..string.format(LOOTSTER_MSG_CHATRESTRICT_LINK, LOOTSTER_LABEL_LOOTSTER, itemText, permitted));
		end
	end
end

-- Remember Remember Restrictions Class handler
function Lootster_Class_Remember_OnClick()
	-- if the restrictions are not locked we can save our own settings
	if ((Lootster_ClassRestrictedLock == false) and (Lootster_ItemID ~= nil)) then
		local	class, flag;

		local	classes = {};

		-- prepare list of classes
		for class, flag in Lootster_ClassRestrictions do
			-- this guy on?
			if (flag == true) then
				-- snarf
				table.insert(classes, class);
			end
		end

		-- update the restricted loot table
		Lootster_Restrict[Lootster_ItemID] = { Text=Lootster_ItemText, Classes=classes };

		-- update the original restrictions mask
		Lootster_ClassRestrictionsMaskOrig = Lootster_ClassRestrictionsMaskCurr;

		-- update the UI
		Lootster_UpdateUI();
	end
end

-- Forget Forget Restrictions Class handler
function Lootster_Class_Forget_OnClick()
	-- if the restricted roll button is disabled, this is class loot, and we just ignore
	if ((Lootster_ClassRestrictedLock == false) and (Lootster_ItemID ~= nil)) then
		-- smack this entry
		Lootster_Restrict[Lootster_ItemID] = nil;

		-- reset the original and current restrictions mask
		Lootster_ClassRestrictionsMaskOrig = 0;

		-- update the UI
		Lootster_UpdateUI();
	end
end

-- Roll Row Click handler
function Lootster_Roll_Button_OnClick()
end

-- Roll Update handler
function Lootster_Roll_Update()
	local	count;
	local	offset;
	local	row, ix;

	local	rowButton, rowName, rowRoll, rowRoll, rowClass, rowDKP, rowTier, rowBad, rowDup;

	local	item;

	-- retrieve count of roll items
	count = table.getn(Lootster_RollsSort);	

	-- retrieve the scroll offset
	offset = FauxScrollFrame_GetOffset(Lootster_RollFrameScrollFrame);

	-- hammer through the roll frame rows
	for row=1, LOOTSTER_ROLL_LINES, 1 do
		-- calculate actual the roll item index
		ix = row + offset;

		-- retrieve the row components
		rowButton	= getglobal("Lootster_RollFrameButton"..row);

		-- do we have roll for the row?
		if (ix <= count) then
			-- get the text elements
			rowName		= getglobal("Lootster_RollFrameButton"..row.."Name");
			rowRoll		= getglobal("Lootster_RollFrameButton"..row.."Roll");
			rowClass	= getglobal("Lootster_RollFrameButton"..row.."Class");
			rowDKP		= getglobal("Lootster_RollFrameButton"..row.."DKP");
			rowTier		= getglobal("Lootster_RollFrameButton"..row.."Tier");
			rowBad		= getglobal("Lootster_RollFrameButton"..row.."Bad");
			rowDup		= getglobal("Lootster_RollFrameButton"..row.."Dup");

			-- okay, retrieve the roll item
			item = Lootster_Rolls[Lootster_RollsSort[ix]];

			-- format the requisiste roll and stuff into the text elements
			rowName:SetText(item.Player);
			rowClass:SetText(item.Class);

			-- are we using DKP?
			if		(Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP) then
				-- set up the valies
				rowDKP:SetText(item.DKP);

				-- DKP by DKP or Tier?
				if		(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYDKP) then
					rowTier:SetText(item.Priority);
				elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
					rowTier:SetText(item.Priority..item.Tier);
				else
					rowTier:SetText("");
				end
			elseif	((Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USENORM) and (Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000)) then
				-- determine if they have rolled Need or Greed
				if		(item.Priority == LOOTSTER_ENUM_NBG.NEED) then
					rowDKP:SetText(LOOTSTER_NBG_NEED);
				elseif	(item.Priority == LOOTSTER_ENUM_NBG.GREED) then
					rowDKP:SetText(LOOTSTER_NBG_GREED);
				else
					rowDKP:SetText("");
				end

				-- erase values
				rowTier:SetText("");
			else
				-- erase values
				rowDKP:SetText("");
				rowTier:SetText("");
			end

			-- the rest of the data maybe nil
			if (item.Roll == nil) then
				rowRoll:SetText("-");
			else
				rowRoll:SetText(item.Roll);
			end

			if (item.Bad == nil) then
				rowBad:SetText("-");
			else
				rowBad:SetText(item.Bad);
			end

			if (item.Dup == nil) then
				rowDup:SetText("-");
			else
				rowDup:SetText(item.Dup);
			end

			-- and show the row
			rowButton:Show();
		else
			-- hide this row
			rowButton:Hide();
		end
	end

	-- update the scroll frame appropriately
	FauxScrollFrame_Update(Lootster_RollFrameScrollFrame, count, LOOTSTER_ROLL_LINES, LOOTSTER_FRAME_HEIGHT);
end

-- Show Help handler
function Lootster_Rule_ShowHelp_OnClick(player)
	-- output the help to party/raid/player
	for ix, msg in ipairs(LOOTSTER_HELP) do
		-- punching this out to the party/raid?
		if (player == nil) then
			-- party/raid
			Lootster_SendBroadcast(msg);
		else
			-- player
			Lootster_SendPrivate(player, msg);
		end
	end

	-- is DKP in use?
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP) then
		-- output the help to party/raid/player
		for ix, msg in ipairs(LOOTSTER_HELPDKP) do
			-- punching this out to the party/raid?
			if (player == nil) then
				-- party/raid
				Lootster_SendBroadcast(msg);
			else
				-- player
				Lootster_SendPrivate(player, msg);
			end
		end
	end
end

-- Show Rules handler
function Lootster_Rule_ShowRules_OnClick(player)
	local ix = 1;
	local rules, msg;

	-- determine which rule set to use
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP) then
		rules = Lootster_Rules.RulesDKP;
	else
		rules = Lootster_Rules.RulesNorm;
	end

	-- chop the looting rules up according to line ends
	for msg in string.gfind(rules, "(.-)\n") do
		-- punching this out to the party/raid?
		if (player == nil) then
			-- party/raid
			Lootster_SendBroadcast(msg);
		else
			-- player
			Lootster_SendPrivate(player, msg);
		end
	end

	-- get the roll handling message
	msg = Lootster_GetRollHandling();

	-- punching this out to the party/raid?
	if (player == nil) then
		-- party/raid
		Lootster_SendBroadcast(msg);
	else
		-- player
		Lootster_SendPrivate(player, msg);
	end
end

-- Looting Rules Text Changed handler
function Lootster_Rule_Rules_TextChanged()
	local	rules;

	-- snarf rules
	rules = Lootster_AppendTrailingLineBreak(Lootster_RuleFrameRulesFrameText:GetText());

	-- determine which rule set to set
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP) then
		Lootster_Rules.RulesDKP = rules;
	else
		Lootster_Rules.RulesNorm = rules;
	end
end

-- Data Reload handler
function Lootster_Data_View_OnClick()
	-- toggle the data view
	Lootster_ViewDKP = not Lootster_ViewDKP;

	-- determine the DKP or Adjust frame to view
	if (Lootster_ViewDKP == true) then
		-- hide adjust frame, show DKP frame
		Lootster_DataFrameAdjustFrame:Hide();
		Lootster_DataFrameDKPFrame:Show();

		-- flip view button text
		Lootster_DataFrameView:SetText(LOOTSTER_DATA_VIEWADJ);
	else
		-- hide DKP frame, show adjust frame
		Lootster_DataFrameDKPFrame:Hide();
		Lootster_DataFrameAdjustFrame:Show();

		-- flip view button text
		Lootster_DataFrameView:SetText(LOOTSTER_DATA_VIEWDKP);
	end

	-- update the respective frame's data
	Lootster_Data_Update();
end

-- Data Whisper All handler
function Lootster_Data_WhisperAll_OnClick()
	-- hammer through the roster whispering each their DKP
	for player, value in pairs(Lootster_Roster) do
		-- echo DKP and roll to player
		Lootster_EchoPlayerDKP(player, player);
		Lootster_EchoPlayerRoll(player, true);
	end
end

-- Data Raid Attendance handler
function Lootster_Data_Attendance_OnClick()
	-- show raid attendance frame
	Lootster_DataFrameRaidAttendFrame:Show();
end

-- Data DKP Adjustments handler
function Lootster_Data_Adjustment_OnClick()
	-- show DKP adjustments frame
	Lootster_DataFrameDKPAdjustsFrame:Show();
end

-- Data Whisper Player handler
function Lootster_Data_WhisperPlayer_OnClick()
	local	offset;
	local	ix;
	local	player;

	-- retrieve the scroll offset
	offset = FauxScrollFrame_GetOffset(Lootster_DataFrameDKPFrameScrollFrame);

	-- calculate actual the DKP item index
	ix = this:GetID() + offset;

	-- get the DKP item
	player = Lootster_DKP[Lootster_DKPSort[ix]].Player;

	-- echo DKP to player
	Lootster_EchoPlayerDKP(player, player, true);
end

-- Data Insert Adjust handler
function Lootster_Data_InsertAdjust_OnClick()
	local	offset, ix, name, items, dkp;

	-- retrieve the scroll offset
	offset = FauxScrollFrame_GetOffset(Lootster_DataFrameAdjustFrameScrollFrame);

	-- calculate actual the DKP item index
	ix = this:GetID() + offset;

	-- get the adjustment record index
	Lootster_AdjustIx = Lootster_AdjustSort[ix];

	-- get the player (main and name)
	Lootster_AdjustMain = Lootster_Adjust[Lootster_AdjustIx].Player;
	Lootster_AdjustName = Lootster_GetMainALT(Lootster_AdjustMain);

	-- set prompts for player
	Lootster_DataFrameAdjustDKPFrameText:SetText(string.format(LOOTSTER_DATA_ADJUSTDKP, Lootster_AdjustName));
	Lootster_DataFrameAdjustDKPFrameAdjust:SetText(LOOTSTER_DATA_INSERT);

	-- do we have a loot link?
	if (Lootster_ItemLink ~= nil) then
		-- reset located items
		items = 0;

		-- attempt to locate this item
		name = string.lower(Lootster_ItemText);

		for itemkey, itemRec in pairs(Lootster_ItemDKP) do
			-- does this item match the current loot?
			if (string.find(itemRec.Name, name) ~= nil) then
				-- snarf the dkp
				dkp = -itemRec.DKP;

				-- and bump located count
				items = items + 1;
			end
		end

		-- if we found only one item, use it's DKP
		if (items == 1) then
			Lootster_DataFrameAdjustDKPFrameDKP:SetNumber(dkp);
		else
			-- set default DKP value
			Lootster_DataFrameAdjustDKPFrameDKP:SetNumber(0);
		end

		Lootster_DataFrameAdjustDKPFrameReason:SetText(Lootster_ItemText);
	else
		-- set default DKP value
		Lootster_DataFrameAdjustDKPFrameDKP:SetNumber(0);

		Lootster_DataFrameAdjustDKPFrameReason:SetText("");
	end

	Lootster_DataFrameAdjustDKPFrameCommentText:SetText("\n");

	-- and show the adjust DKP dialog
	Lootster_DataFrameAdjustDKPFrame:Show();
end

-- Data Modify Adjust handler
function Lootster_Data_ModifyAdjust_OnClick()
	local	offset, ix;

	-- retrieve the scroll offset
	offset = FauxScrollFrame_GetOffset(Lootster_DataFrameAdjustFrameScrollFrame);

	-- calculate actual the DKP item index
	ix = this:GetID() + offset;

	-- get the adjustment record index
	Lootster_AdjustIx = Lootster_AdjustSort[ix];

	-- get the player (main and name)
	Lootster_AdjustMain = Lootster_Adjust[Lootster_AdjustIx].Player;
	Lootster_AdjustName = Lootster_GetMainALT(Lootster_AdjustMain);

	-- set prompts for player
	Lootster_DataFrameAdjustDKPFrameText:SetText(string.format(LOOTSTER_DATA_ADJUSTDKP, Lootster_AdjustName));
	Lootster_DataFrameAdjustDKPFrameAdjust:SetText(LOOTSTER_DATA_MODIFY);

	-- set the record's DKP, reason and comment values
	Lootster_DataFrameAdjustDKPFrameDKP:SetNumber(Lootster_Adjust[Lootster_AdjustIx].DKPAct);
	Lootster_DataFrameAdjustDKPFrameReason:SetText(Lootster_Adjust[Lootster_AdjustIx].Reason);
	Lootster_DataFrameAdjustDKPFrameCommentText:SetText(Lootster_Adjust[Lootster_AdjustIx].Comment);

	-- and show the adjust DKP dialog
	Lootster_DataFrameAdjustDKPFrame:Show();
end

-- Data Delete Adjust Click handler
function Lootster_Data_DeleteAdjust_OnClick()
	local	offset, ix;

	-- retrieve the scroll offset
	offset = FauxScrollFrame_GetOffset(Lootster_DataFrameAdjustFrameScrollFrame);

	-- calculate actual the DKP item index
	ix = this:GetID() + offset;

	-- get the adjustment record index
	Lootster_AdjustIx = Lootster_AdjustSort[ix];

	-- get the player (main and name)
	Lootster_AdjustMain = Lootster_Adjust[Lootster_AdjustIx].Player;
	Lootster_AdjustName = Lootster_GetMainALT(Lootster_AdjustMain);
end

-- Data Delete Adjust Accept handler
function Lootster_Data_DeleteAdjust_OnAccept()
	local	dkp, tier;

	-- let player know there DKP was changed if they are on roster
	if (Lootster_Roster[Lootster_AdjustName] ~= nil) then
		Lootster_SendPrivate(Lootster_AdjustName, string.format(LOOTSTER_MSG_DKPDELETED, Lootster_Adjust[Lootster_AdjustIx].DKPAct, Lootster_Adjust[Lootster_AdjustIx].Reason));
	end

	-- back out the existing DKP adjustment
	Lootster_DKP[Lootster_AdjustMain].DKPAdj = Lootster_DKP[Lootster_AdjustMain].DKPAdj - Lootster_Adjust[Lootster_AdjustIx].DKPAct;

	-- remove adjust record
	table.remove(Lootster_Adjust, Lootster_AdjustIx);

	-- determine the new DKP tier for this dkp and adjustment
	dkp = Lootster_CalcDKP(Lootster_DKP[Lootster_AdjustMain].DKPRaw + Lootster_DKP[Lootster_AdjustMain].DKPAdj);
	tier = Lootster_CalcTier(Lootster_DKP[Lootster_AdjustMain].DKPRaw + Lootster_DKP[Lootster_AdjustMain].DKPAdj);

	-- update the player's DKP and tier
	Lootster_DKP[Lootster_AdjustMain].DKP = dkp;
	Lootster_DKP[Lootster_AdjustMain].Tier = tier;

	-- resort DKP data using current sort
	Lootster_Data_Sort(nil);

	-- echo DKP and roll to player if in roster
	if (Lootster_Roster[Lootster_AdjustName] ~= nil) then
		Lootster_EchoPlayerDKP(Lootster_AdjustName, Lootster_AdjustName);
		Lootster_EchoPlayerRoll(Lootster_AdjustName, true);
	end

	-- did our DKP change?
	if ((Lootster_AdjustName == Lootster_Self) and (Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP)) then
		-- update our roll text
		Lootster_UpdateRoll();
	end

	-- reset adjust index and player
	Lootster_AdjustIx = nil;
	Lootster_AdjustName = nil;
	Lootster_AdjustMain = nil;
end

-- Data Delete Adjust Cancel handler
function Lootster_Data_DeleteAdjust_OnCancel()
	-- reset adjust index and player
	Lootster_AdjustIx = nil;
	Lootster_AdjustName = nil;
	Lootster_AdjustMain = nil;
end

-- Data Delete ALL Adjust handler
function Lootster_Data_DeleteAdjustAll_OnClick()
	-- well this is easy.  Simply reset the adjust table
	Lootster_Adjust = {};

	-- and force an adjustment load
	Lootster_AdjustLoad();

	-- force a roster update
	Lootster_PARTY_Roster();

	-- sort DKP data using current sort
	Lootster_Data_Sort(nil);

	-- let them know
	Lootster_SendBroadcast(LOOTSTER_MSG_DKPDELETEDALL);

	-- did our DKP change?
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP) then
		-- update our roll text
		Lootster_UpdateRoll();
	end

	-- and whisper their DKP and rolls
	Lootster_Data_WhisperAll_OnClick();
end

-- Data Row Click handler
function Lootster_Data_Button_OnClick()
end

-- Data Row Enter handler
function Lootster_Data_Button_OnEnter()
	local	offset, ix, tooltip;

	-- retrieve the scroll offset
	offset = FauxScrollFrame_GetOffset(Lootster_DataFrameAdjustFrameScrollFrame);

	-- calculate actual the DKP item index and get the adjustment record index
	ix = Lootster_AdjustSort[this:GetID() + offset];

	-- format the tooltip message according to record type
	if (Lootster_Adjust[ix].DKPAct == nil) then
		-- total record
		tooltip = string.format(LOOTSTER_MSG_DKPTOOLTIPTOT, Lootster_GetMainALT(Lootster_Adjust[ix].Player), Lootster_Adjust[ix].DKPTot);
	else
		-- adjustment record
		tooltip = string.format(LOOTSTER_MSG_DKPTOOLTIPADJ, Lootster_GetMainALT(Lootster_Adjust[ix].Player), Lootster_Adjust[ix].DKPAct, Lootster_Adjust[ix].Reason);
	end

	return tooltip;
end

-- Show Raid Attendance handler
function Lootster_RaidAttend_OnShow()
	-- simply build raid attendance list
	Lootster_RaidAttend_Refresh_OnClick();
end

-- Refresh Raid Attendance handler
function Lootster_RaidAttend_Refresh_OnClick()
	local	main;
	local	msgRoster = "";

	-- hammer through the roster building attendance list
	for player, value in pairs(Lootster_Roster) do
		-- get the main for this alt
		main = Lootster_GetALTMain(player);

		msgRoster = msgRoster..main.."\r\n";
	end

	Lootster_DataFrameRaidAttendFrameReport:SetText(msgRoster);
end

-- Show DKP Adjustments handler
function Lootster_DKPAdjusts_OnShow()
	-- simply build DKP adjustments list
	Lootster_DKPAdjusts_Refresh_OnClick();
end

-- Refresh DKP Adjustments handler
function Lootster_DKPAdjusts_Refresh_OnClick()
	local	alt;
	local	msgAdjust = "";

	-- hammer through the player's adjustments building adjustments list
	for ix, adjRec in ipairs(Lootster_Adjust) do
		-- ignore total records
		if (adjRec.DKPAct ~= nil) then
			-- get the alt for this main
			alt = Lootster_GetMainALT(adjRec.Player);

			msgAdjust = msgAdjust..adjRec.Player.."\t["..alt.."]\t"..adjRec.DKPAct.."\t\""..adjRec.Reason.."\"\t\""..Lootster_RemoveTrailingLineBreak(adjRec.Comment).."\"\r\n";
		end
	end

	-- make sure we have at least one line
	if (string.len(msgAdjust) == 0) then
		msgAdjust = "\r\n";
	end

	Lootster_DataFrameDKPAdjustsFrameReport:SetText(msgAdjust);
end

-- Show Adjust DKP handler
function Lootster_Data_AdjustDKP_OnShow()
end

-- Hide Adjust DKP handler
function Lootster_Data_AdjustDKP_OnHide()
	-- reset adjust index and player
	Lootster_AdjustIx = nil;
	Lootster_AdjustName = nil;
	Lootster_AdjustMain = nil;

	-- reset adjust DKP values
	Lootster_DataFrameAdjustDKPFrameText:SetText("");
	Lootster_DataFrameAdjustDKPFrameDKP:SetNumber(0);
	Lootster_DataFrameAdjustDKPFrameReason:SetText("");
	Lootster_DataFrameAdjustDKPFrameCommentText:SetText("\n");
end

-- Data Adjust DKP DKP handler
function Lootster_Data_AdjustDKP_Entered()
end

-- Data Adjust DKP Reason handlerhandler
function Lootster_Data_AdjustReason_Entered()
end

-- Data Adjust DKP Comment handler
function Lootster_Data_AdjustComment_TextChanged()
end

-- Data DKP Adjust handler
function Lootster_AdjustDKP_Adjust_OnClick()
	-- must have an adjustment index
	if (Lootster_AdjustIx ~= nil) then
		local dkp, reason, comment, tier;

		-- retrieve data
		dkp = Lootster_DataFrameAdjustDKPFrameDKP:GetNumber();
		reason = Lootster_DataFrameAdjustDKPFrameReason:GetText();
		comment = Lootster_AppendTrailingLineBreak(Lootster_DataFrameAdjustDKPFrameCommentText:GetText());

		-- are we creating or modifying an adjustment record?
		if (Lootster_Adjust[Lootster_AdjustIx].DKPAct == nil) then
			-- let player know there DKP was created if they are on roster
			if (Lootster_Roster[Lootster_AdjustName] ~= nil) then
				Lootster_SendPrivate(Lootster_AdjustName, string.format(LOOTSTER_MSG_DKPCREATED, dkp, reason));
			end

			-- we are creating a new adjustment record
			table.insert(Lootster_Adjust, { Player=Lootster_AdjustMain, DKPAct=dkp, DKPTot=0, Epoch=time(), Reason=reason, Comment=comment });

			-- update the record's index
			Lootster_AdjustIx = table.getn(Lootster_Adjust);
		else
			-- let player know there DKP was changed if they are on roster
			if (Lootster_Roster[Lootster_AdjustName] ~= nil) then
				Lootster_SendPrivate(Lootster_AdjustName, string.format(LOOTSTER_MSG_DKPCHANGED, dkp, reason, Lootster_Adjust[Lootster_AdjustIx].DKPAct, Lootster_Adjust[Lootster_AdjustIx].Reason));
			end

			-- we are modifying an existing adjustment record.  First, back out the existing DKP adjustment
			Lootster_DKP[Lootster_AdjustMain].DKPAdj = Lootster_DKP[Lootster_AdjustMain].DKPAdj - Lootster_Adjust[Lootster_AdjustIx].DKPAct;

			-- update record
			Lootster_Adjust[Lootster_AdjustIx].DKPAct = dkp;
			Lootster_Adjust[Lootster_AdjustIx].Reason = reason;
			Lootster_Adjust[Lootster_AdjustIx].Comment = comment;
		end

		-- fold in new DKP
		Lootster_DKP[Lootster_AdjustMain].DKPAdj = Lootster_DKP[Lootster_AdjustMain].DKPAdj + Lootster_Adjust[Lootster_AdjustIx].DKPAct;

		-- determine the new DKP tier for this dkp and adjustment
		dkp = Lootster_CalcDKP(Lootster_DKP[Lootster_AdjustMain].DKPRaw + Lootster_DKP[Lootster_AdjustMain].DKPAdj);
		tier = Lootster_CalcTier(Lootster_DKP[Lootster_AdjustMain].DKPRaw + Lootster_DKP[Lootster_AdjustMain].DKPAdj);

		-- update the player's DKP and tier
		Lootster_DKP[Lootster_AdjustMain].DKP = dkp;
		Lootster_DKP[Lootster_AdjustMain].Tier = tier;

		-- resort DKP data using current sort
		Lootster_Data_Sort(nil);

		-- echo DKP and roll to player if in roster
		if (Lootster_Roster[Lootster_AdjustName] ~= nil) then
			Lootster_EchoPlayerDKP(Lootster_AdjustName, Lootster_AdjustName);
			Lootster_EchoPlayerRoll(Lootster_AdjustName, true);
		end

		-- did our DKP change?
		if ((Lootster_AdjustName == Lootster_Self) and (Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP)) then
			-- update our roll text
			Lootster_UpdateRoll();
		end

		-- reset adjust index and player
		Lootster_AdjustIx = nil;
		Lootster_AdjustName = nil;
		Lootster_AdjustMain = nil;
	else
		-- hide the UI
		Lootster_DataFrameAdjustDKPFrame:Hide();
	end
end

-- Data Sort handler
function Lootster_Data_Sort(col)
	local	ix = 1;

	-- are we doing current sort order?
	if		(col ~= nil) then
		-- are we inverting sort order?
		if (col == Lootster_DKPSortCol) then
			-- flip sort order
			Lootster_DKPSortOrd = not Lootster_DKPSortOrd;
		else
			-- force ascending
			Lootster_DKPSortOrd = true;
		end

		Lootster_DKPSortCol = col;
	end

	-- initialise the DKP sort indirection table
	table.setn(Lootster_DKPSort, table.getn(Lootster_DKP));

	for key, value in pairs(Lootster_DKP) do
		Lootster_DKPSort[ix] = key;
		ix = ix + 1;
	end

	-- sort the DKP data.  We use a sorted indirection table
	table.sort(Lootster_DKPSort, Lootster_DataDKPTest);

	-- initialise the adjust sort indirection table
	table.setn(Lootster_AdjustSort, table.getn(Lootster_Adjust));

	for ix, value in ipairs(Lootster_Adjust) do
		Lootster_AdjustSort[ix] = ix;
	end

	-- sort the adjust data.  We use a sorted indirection table
	table.sort(Lootster_AdjustSort, Lootster_DataAdjustTest);

	-- and update screen
	Lootster_Data_Update();

	-- hide the UI
	Lootster_DataFrameAdjustDKPFrame:Hide();
end

-- Data Update handler
function Lootster_Data_Update()
	local	count;
	local	offset;
	local	row, ix;

	local	rowButton, rowWhisper, rowInsert, rowModify, rowDelete, rowName, rowDate, rowClass, rowDKP, rowDKPRaw, rowDKPAdj, rowTier;

	local	item, alt;
	local	player = "";
	local	dkptot;

	-- what is our view?
	if (Lootster_ViewDKP == true) then
		-- retrieve count of DKP items
		count = table.getn(Lootster_DKPSort);

		-- retrieve the scroll offset for DKP view
		offset = FauxScrollFrame_GetOffset(Lootster_DataFrameDKPFrameScrollFrame);
	else
		-- retrieve count of adjust items
		count = table.getn(Lootster_AdjustSort);

		-- retrieve the scroll offset for adjust view
		offset = FauxScrollFrame_GetOffset(Lootster_DataFrameAdjustFrameScrollFrame);
	end

	-- hammer through the data frame rows
	for row=1, LOOTSTER_DATA_LINES, 1 do
		-- calculate actual the DKP/adjust item index
		ix = row + offset;

		-- what is our view?
		if (Lootster_ViewDKP == true) then
			-- retrieve the DKP row components
			rowButton	= getglobal("Lootster_DataFrameDKPFrameButton"..row);
			rowWhisper	= getglobal("Lootster_DataFrameDKPFrameWhisper"..row);

			-- do we have data for the row?
			if (ix <= count) then
				-- get the text elements
				rowName		= getglobal("Lootster_DataFrameDKPFrameButton"..row.."Name");
				rowClass	= getglobal("Lootster_DataFrameDKPFrameButton"..row.."Class");
				rowDKP		= getglobal("Lootster_DataFrameDKPFrameButton"..row.."DKP");
				rowDKPRaw	= getglobal("Lootster_DataFrameDKPFrameButton"..row.."DKPRaw");
				rowDKPAdj	= getglobal("Lootster_DataFrameDKPFrameButton"..row.."DKPAdj");
				rowTier		= getglobal("Lootster_DataFrameDKPFrameButton"..row.."Tier");

				-- okay, retrieve the DKP item
				item = Lootster_DKP[Lootster_DKPSort[ix]];

				-- this is main record, but the alt may be playing.  Resolve to that alt if it is playing
				alt = Lootster_GetMainALT(item.Player);

				-- format the requisiste data and stuff into the text elements
				rowName:SetText(alt);
				rowClass:SetText(item.Class);
				rowDKP:SetText(item.DKP);
				rowDKPRaw:SetText(string.format("%.2f", item.DKPRaw));
				rowDKPAdj:SetText(item.DKPAdj);

				-- DKP by DKP or Tier?
				if		(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYDKP) then
					rowTier:SetText(item.Priority);
				elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
					rowTier:SetText(item.Priority..item.Tier);
				else
					rowTier:SetText("");
				end

				-- and show the row
				rowButton:Show();
				rowWhisper:Show();
			else
				-- hide this row
				rowButton:Hide();
				rowWhisper:Hide();
			end
		else
			-- retrieve the adjust row components
			rowButton	= getglobal("Lootster_DataFrameAdjustFrameButton"..row);
			rowInsert	= getglobal("Lootster_DataFrameAdjustFrameInsert"..row);
			rowModify	= getglobal("Lootster_DataFrameAdjustFrameModify"..row);
			rowDelete	= getglobal("Lootster_DataFrameAdjustFrameDelete"..row);

			-- do we have data for the row?
			if (ix <= count) then
				-- get the text elements
				rowName		= getglobal("Lootster_DataFrameAdjustFrameButton"..row.."Name");
				rowDate		= getglobal("Lootster_DataFrameAdjustFrameButton"..row.."Date");
				rowAdjust	= getglobal("Lootster_DataFrameAdjustFrameButton"..row.."Adjust");
				rowTotal	= getglobal("Lootster_DataFrameAdjustFrameButton"..row.."Total");

				-- okay, retrieve the adjust item
				item = Lootster_Adjust[Lootster_AdjustSort[ix]];

				-- is this the same player as the last one?
				if (player ~= item.Player) then
					-- this is main record, but the alt may be playing.  Resolve to that alt if it is playing
					alt = Lootster_GetMainALT(item.Player);

					-- reset player and total DKP adjusted
					player = item.Player;
					dkptot = 0;
				end

				-- format the requisiste data and stuff into the text elements
				rowName:SetText(alt);

				-- no actual DKP means this is a total record
				if (item.DKPAct ~= nil) then
					rowDate:SetText(date(LOOTSTER_ECHO_DATE, item.Epoch));
					rowAdjust:SetText(item.DKPAct);

					-- add this adjustment to the total
					dkptot = dkptot + item.DKPAct;
				else
					rowDate:SetText("");
					rowAdjust:SetText("");
				end

				-- update total record
				item.DKPTot = dkptot;

				rowTotal:SetText(item.DKPTot);

				-- and show the row
				rowButton:Show();

				-- we need to determine what buttons to show
				if (item.DKPAct ~= nil) then
					-- actual adjustment - can modify/delete
					rowInsert:Hide();
					rowModify:Show();
					rowDelete:Show();
				else
					-- total adjustment - can insert only
					rowInsert:Show();
					rowModify:Hide();
					rowDelete:Hide();
				end
			else
				-- hide this row
				rowButton:Hide();
				rowInsert:Hide();
				rowModify:Hide();
				rowDelete:Hide();
			end
		end
	end

	-- what is our view?
	if (Lootster_ViewDKP == true) then
		-- update the scroll frame appropriately
		FauxScrollFrame_Update(Lootster_DataFrameDKPFrameScrollFrame, count, LOOTSTER_DATA_LINES, LOOTSTER_FRAME_HEIGHT);
	else
		-- update the scroll frame appropriately
		FauxScrollFrame_Update(Lootster_DataFrameAdjustFrameScrollFrame, count, LOOTSTER_DATA_LINES, LOOTSTER_FRAME_HEIGHT);
	end
end

-- Option MiniMap Button Toggle handler
function Lootster_Option_MiniMapButton_Toggle()
	-- retrieve value
	Lootster_Options.MiniMap = (Lootster_OptionsFrameMiniMapButton:GetChecked() ~= nil);

	-- and show/hide the actual button
	if (Lootster_Options.MiniMap == true) then
		-- on she goes
		PlaySound("igMainMenuOptionCheckBoxOn");

		Lootster_MiniMapButtonFrame:Show();
	else
		-- off she goes
		PlaySound("igMainMenuOptionCheckBoxOff");

		Lootster_MiniMapButtonFrame:Hide();
	end
end

-- Option MiniMap Button Value handler
function Lootster_Option_MiniMapButton_OnValue()
	-- retrieve value
	Lootster_Options.MiniMapPos = Lootster_OptionsFrameMiniMapSlider:GetValue();

	-- update slidertext
	Lootster_OptionsFrameMiniMapSliderText:SetText(Lootster_Options.MiniMapPos);

	-- reflect the position
	Lootster_MiniMapButton_UpdatePosition();
end

-- Option Suppress Chat Toggle handler
function Lootster_Option_Suppress_Toggle()
	-- retrieve value
	Lootster_Options.Suppress = (Lootster_OptionsFrameSuppress:GetChecked() ~= nil);
end

-- Option Acknowledge Roll Toggle handler
function Lootster_Option_AckRoll_Toggle()
	-- retrieve value
	Lootster_Options.AckRoll = (Lootster_OptionsFrameAckRoll:GetChecked() ~= nil);
end

-- Option Acknowledge No Call Toggle handler
function Lootster_Option_AckNoCall_Toggle()
	-- retrieve value
	Lootster_Options.AckNoCall = (Lootster_OptionsFrameAckNoCall:GetChecked() ~= nil);
end

-- Option Acknowledge No Roll Toggle handler
function Lootster_Option_AckNoRoll_Toggle()
	-- retrieve value
	Lootster_Options.AckNoRoll = (Lootster_OptionsFrameAckNoRoll:GetChecked() ~= nil);
end

-- Option Counter Toggle handler
function Lootster_Option_Counter_Toggle()
	-- retrieve value
	Lootster_Options.Counter = (Lootster_OptionsFrameCounter:GetChecked() ~= nil);

	-- update the countdown button
	Lootster_UpdateUI();
end

-- Option Counter Value handler
function Lootster_Option_Counter_Entered()
	-- retrieve value
	Lootster_Options.CounterSec = Lootster_OptionsFrameSeconds:GetNumber();

	-- must be positive
	if (Lootster_Options.CounterSec < 0) then
		Lootster_Options.CounterSec = -Lootster_Options.CounterSec;

		-- update
		Lootster_OptionsFrameSeconds:SetNumber(Lootster_Options.CounterSec);
	end

	-- update the countdown button
	Lootster_UpdateUI();
end

-- Option Echo Restrictions Toggle handler
function Lootster_Option_EchoRestrict_Toggle()
	-- retrieve value
	Lootster_Options.EchoRestrict = (Lootster_OptionsFrameEchoRestrict:GetChecked() ~= nil);

	-- update echo UI
	Lootster_CheckEchoUse();
end

-- Option Echo By Click Toggle handler
function Lootster_Option_EchoByClick_Toggle()
	-- retrieve value
	Lootster_Options.EchoByClick = (Lootster_OptionsFrameEchoByClick:GetChecked() ~= nil);

	-- update echo UI
	Lootster_CheckEchoUse();
end

-- Option Echo By Group Loot Toggle handler
function Lootster_Option_EchoByGroupLoot_Toggle()
	-- retrieve value
	Lootster_Options.EchoByGroupLoot = (Lootster_OptionsFrameEchoByGroupLoot:GetChecked() ~= nil);

	-- update echo UI
	Lootster_CheckEchoUse();
end

-- Option Echo to Chat Toggle handler
function Lootster_Option_EchoToChat_Toggle()
	-- retrieve value
	Lootster_Options.EchoToChat = (Lootster_OptionsFrameEchoToChat:GetChecked() ~= nil);
end

-- Option Echo to CT_RaidAssist Toggle handler
function Lootster_Option_EchoToCTRA_Toggle()
	-- retrieve value
	Lootster_Options.EchoToCTRA = (Lootster_OptionsFrameEchoToCTRA:GetChecked() ~= nil);
end

-- Option Auto-Snoop Toggle handler
function Lootster_Option_AutoSnoop_Toggle()
	-- retrieve value
	Lootster_Options.AutoSnoop = (Lootster_OptionsFrameAutoSnoop:GetChecked() ~= nil);
end

-- Option Debug Messages Chat Toggle handler
function Lootster_Option_DebugMsgs_Toggle()
	-- retrieve value
	Lootster_Options.DebugMsgs = (Lootster_OptionsFrameDebugMsgs:GetChecked() ~= nil);

	-- if we are switching on debug messages, clear the To Whisper queue
	if (Lootster_Options.DebugMsgs) then
		-- initialise queue
		Lootster_ToWhisperQueue = {};
	end
end

-- Option Roll Mode Load handler
function Lootster_Option_RollMode_OnLoad()
	-- initially disable
	Lootster_OptionsFrameRollModeButton:Disable();

	-- set width
	UIDropDownMenu_SetWidth(150);
end

-- Option Roll Mode Show handler
function Lootster_Option_RollMode_OnShow()
	-- setup the roll mode drop down
	UIDropDownMenu_Initialize(Lootster_OptionsFrameRollMode, Lootster_Option_RollMode_Initialise);

	-- set initial selection
	UIDropDownMenu_SetSelectedID(Lootster_OptionsFrameRollMode, Lootster_Options.RollMode);
end

-- Option Roll Mode Load Initaliser handler
function Lootster_Option_RollMode_Initialise()
	local info;

	for ix, type in ipairs(LOOTSTER_OPTION_ROLLMODELIST) do
		-- form mode button
		info = {};
		info.text = type;
		info.func = Lootster_Option_RollMode_OnSelect;

		-- add roll mode button
		UIDropDownMenu_AddButton(info);
	end
end

-- Option Roll Mode Select handler
function Lootster_Option_RollMode_OnSelect()
	-- select this entry
	UIDropDownMenu_SetSelectedID(Lootster_OptionsFrameRollMode, this:GetID());

	-- and snarf new mode
	Lootster_Options.RollMode = this:GetID();

	-- update roll handling
	Lootster_UpdateRollHandling();
end

-- Option Roll Type Load handler
function Lootster_Option_RollType_OnLoad()
	-- set width
	UIDropDownMenu_SetWidth(150);
end

-- Option Roll Type Show handler
function Lootster_Option_RollType_OnShow()
	-- setup the roll type drop down
	UIDropDownMenu_Initialize(Lootster_OptionsFrameRollType, Lootster_Option_RollType_Initialise);

	-- set initial selection depending on mode
	if		(Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP) then
		-- DKP type
		UIDropDownMenu_SetSelectedID(Lootster_OptionsFrameRollType, Lootster_Options.DKPType);
	elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USENORM) then
		-- normal type
		UIDropDownMenu_SetSelectedID(Lootster_OptionsFrameRollType, Lootster_Options.NormType);
	end
end

-- Option Roll Type Load Initaliser handler
function Lootster_Option_RollType_Initialise()
	local list, info, type;

	-- determine which list to use
	if		(Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP) then
		-- DKP type
		list = LOOTSTER_OPTION_DKPTYPELIST;
	elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USENORM) then
		-- normal type
		list = LOOTSTER_OPTION_NORMTYPELIST;
	else
		list = {};
	end

	for ix, type in ipairs(list) do
		-- form type button
		info = {};
		info.text = type;
		info.func = Lootster_Option_RollType_OnSelect;

		-- add DKP type button
		UIDropDownMenu_AddButton(info);
	end
end

-- Option Roll Type Select handler
function Lootster_Option_RollType_OnSelect()
	-- select this entry
	UIDropDownMenu_SetSelectedID(Lootster_OptionsFrameRollType, this:GetID());

	-- and snarf new type
	if		(Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP) then
		-- DKP type
		Lootster_Options.DKPType = this:GetID();
	elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USENORM) then
		-- normal type
		Lootster_Options.NormType = this:GetID();
	end

	-- update roll handling
	Lootster_UpdateRollHandling();
end

-- Option DKP Priority Toggle handler
function Lootster_Option_DKPPriority_Toggle()
	-- retrieve value
	Lootster_Options.DKPPrior = (Lootster_OptionsFrameDKPPriority:GetChecked() ~= nil);

	-- update roll handling
	Lootster_UpdateRollHandling();
end

-- Option DKP Caps Toggle handler
function Lootster_Option_DKPCaps_Toggle()
	-- retrieve value
	Lootster_Options.DKPCaps = (Lootster_OptionsFrameDKPCaps:GetChecked() ~= nil);

	-- update roll handling
	Lootster_UpdateRollHandling();
end

-- Option DKP Hi Cap Focus Gained handler
function Lootster_Option_DKPHi_FocusGained()
	-- save the current value so we can detect changes
	Lootster_DKPHiSave = Lootster_Options.DKPHi;
end

-- Option DKP Hi Cap Value handler
function Lootster_Option_DKPHi_Entered()
	-- retrieve value
	Lootster_Options.DKPHi = Lootster_OptionsFrameDKPHi:GetNumber();

	-- must be positive
	if (Lootster_Options.DKPHi < 0) then
		Lootster_Options.DKPHi = -Lootster_Options.DKPHi;
		
		-- update
		Lootster_OptionsFrameDKPHi:SetNumber(Lootster_Options.DKPHi);
	else
		-- update read-only RO version
		Lootster_OptionsFrameDKPHiRO:SetText(Lootster_Options.DKPHi);
	end

	-- reformat our roll button text
	Lootster_UpdateRoll();
end

-- Option DKP Hi Cap Focus Lost handler
function Lootster_Option_DKPHi_FocusLost()
	-- did the Hi DKP cap change?
	if (Lootster_DKPHiSave ~= Lootster_Options.DKPHi) then
		-- update roll handling to setup caps
		Lootster_UpdateRollHandling();
	end

	-- and reset the DKP Hi cap save
	Lootster_DKPHiSave = nil;
end

-- Option DKP Lo Cap Focus Gained handler
function Lootster_Option_DKPLo_FocusGained()
	-- save the current value so we can detect changes
	Lootster_DKPLoSave = Lootster_Options.DKPLo;
end

-- Option DKP Lo Cap Value handler
function Lootster_Option_DKPLo_Entered()
	-- retrieve value
	Lootster_Options.DKPLo = Lootster_OptionsFrameDKPLo:GetNumber();

	-- must be positive
	if (Lootster_Options.DKPLo < 0) then
		Lootster_Options.DKPLo = -Lootster_Options.DKPLo;

		-- update
		Lootster_OptionsFrameDKPLo:SetNumber(Lootster_Options.DKPLo);
	else
		-- update read-only RO version
		Lootster_OptionsFrameDKPLoRO:SetText(Lootster_Options.DKPLo);
	end

	-- reformat our roll button text
	Lootster_UpdateRoll();
end

-- Option DKP Lo Cap Focus Lost handler
function Lootster_Option_DKPLo_FocusLost()
	-- did the Lo DKP cap change?
	if (Lootster_DKPLoSave ~= Lootster_Options.DKPLo) then
		-- update roll handling to setup caps
		Lootster_UpdateRollHandling();
	end

	-- and reset the DKP Lo cap save
	Lootster_DKPLoSave = nil;
end

-- Option Normal 100/1000 Roll Toggle handler
function Lootster_Option_NormCorKRoll_Toggle()
	-- retrieve value
	Lootster_Options.CorKRoll = (Lootster_OptionsFrameNormCorKRoll:GetChecked() ~= nil);

	-- update roll handling to setup 100/1000 rolling
	Lootster_UpdateRollHandling();
end

-- Option Normal 100/1000 Open Toggle handler
function Lootster_Option_NormCorKOpen_Toggle()
	-- retrieve value
	Lootster_Options.CorKOpen = (Lootster_OptionsFrameNormCorKOpen:GetChecked() ~= nil);
end

-- Option Normal 100/1000 Close Toggle handler
function Lootster_Option_NormCorKClose_Toggle()
	-- retrieve value
	Lootster_Options.CorKClose = (Lootster_OptionsFrameNormCorKClose:GetChecked() ~= nil);
end

-- MiniMap Button Position handler
function Lootster_MiniMapButton_UpdatePosition()
	-- update the MiniMap position
	Lootster_MiniMapButtonFrame:SetPoint("TOPLEFT", "Minimap", "TOPLEFT",
										 (52 - (80 * cos(Lootster_Options.MiniMapPos))),
										 (80 * sin(Lootster_Options.MiniMapPos)) - 52);
end

-- Send Broadcast Message handler
function Lootster_SendBroadcast(msg, show)
	local   chan = "SAY";

	-- deterine the channel we should broadcast on
	if		(GetNumRaidMembers() > 0) then
		chan = "RAID";
	elseif	(GetNumPartyMembers() > 0) then
		chan = "PARTY";
	end

	-- are we active?
	if (((Lootster_Options.Active == true) or (show == true)) and (chan ~= "SAY")) then
		-- send to party/raid
		SendChatMessage(msg, chan);
	else
		-- send to ourselves and let it decide
		Lootster_SendPrivate(chan, msg);
	end
end

-- Send Private Message handler
function Lootster_SendPrivate(player, msg, show)
	-- are we active or we always show?
	if		(((Lootster_Options.Active == true) or (show == true)) and (player ~= "SAY")) then
		-- who are we sending it too?
		if (Lootster_Self == player) then
			-- send to self
			if (DEFAULT_CHAT_FRAME) then
				DEFAULT_CHAT_FRAME:AddMessage(msg);
			end
		else
			-- are we showing debug messages?
			if (not Lootster_Options.DebugMsgs) then
				-- place this message on the To Whisper queue so its echo will be supressed
				table.insert(Lootster_ToWhisperQueue, msg);
			end

			-- send to playa
			SendChatMessage(msg, "WHISPER", Lootster_Language, player);
		end
	elseif	(Lootster_Options.DebugMsgs == true) then
		-- debugging, send to ourselves
		if (DEFAULT_CHAT_FRAME) then
			DEFAULT_CHAT_FRAME:AddMessage(string.format("<To %s> %s", player, msg));
		end
	end
end

-- Player Inquiry handler
function Lootster_PlayerInquiry(player, msg)
	local	cmd, subcmd;

	local	proc = false;
	local	help = false;

	-- we received a whisper - see if it's a lootster command.  Chunk it up baby
	_, _, cmd	 = string.find(msg, LOOTSTER_CMD_PATTERN);
	_, _, subcmd = string.find(msg, LOOTSTER_SUBCMD_PATTERN);

	if		(cmd == LOOTSTER_CMD_LOOT) then
		-- loot command - see what the subcommand was
		if		(subcmd ~= nil) then
			-- see what the subcommand is
			if		(subcmd == LOOTSTER_SUBCMD_HELP) then
				-- echo help
				Lootster_Rule_ShowHelp_OnClick(player);
			elseif	(subcmd == LOOTSTER_SUBCMD_ROLL) then
				-- echo player's roll command
				Lootster_EchoPlayerRoll(player, true);
			elseif	(subcmd == LOOTSTER_SUBCMD_RULES) then
				-- echo rules
				Lootster_Rule_ShowRules_OnClick(player);
			elseif	(subcmd == LOOTSTER_SUBCMD_VERSION) then
				-- echo current version
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_LOAD, LOOTSTER_VERSION), true);
			else
				-- please help me
				help = true;
			end
		else
			-- please help me
			help = true;
		end

		-- processed this guy
		proc = true;
	elseif	(cmd == LOOTSTER_CMD_ADJ) then
		-- adjust command - see what the subcommand is, if any
		if		(subcmd == nil) then
			-- echo player's adjustments
			Lootster_EchoPlayerAdjusts(player, player);
		else
			local	class, name;

			-- see what the subcommand is a class or a player
			class = string.lower(subcmd);

			name = string.lower(subcmd);

			if (Lootster_ClassLower[class] ~= nil) then
				-- they want the adjusts for players in the class
				for playerkey, rosRec in pairs(Lootster_Roster) do
					-- is this player of that class?
					if (rosRec.ClassType == Lootster_ClassLower[class]) then
						-- echo this player's adjustments
						Lootster_EchoPlayerAdjusts(player, playerkey);
					end
				end
			else
				-- they want the adjusts for matching players
				for playerkey, rosRec in pairs(Lootster_Roster) do
					-- does this player match the passed name
					if (string.find(rosRec.Name, name) ~= nil) then
						-- echo this player's adjustments
						Lootster_EchoPlayerAdjusts(player, playerkey);
					end
				end
			end
		end

		-- processed this guy
		proc = true;
	elseif	(cmd == LOOTSTER_CMD_DKP) then
		-- DKP command - see what the subcommand is, if any
		if		(subcmd == nil) then
			-- echo player's DKP
			Lootster_EchoPlayerDKP(player, player);
		else
			local	class, name;

			-- see what the subcommand is a class or a player
			class = string.lower(subcmd);

			name = string.lower(subcmd);

			if (LOOTSTER_CLASS[class] ~= nil) then
				-- they want the DKP for players in the class
				for playerkey, rosRec in pairs(Lootster_Roster) do
					-- is this player of that class?
					if (rosRec.ClassType == LOOTSTER_CLASS[class].ClassType) then
						-- echo this player's DKP
						Lootster_EchoPlayerDKP(player, playerkey);
					end
				end
			else
				-- they want the DKP for matching players
				for playerkey, rosRec in pairs(Lootster_Roster) do
					-- does this player match the passed name
					if (string.find(rosRec.Name, name) ~= nil) then
						-- echo this player's DKP
						Lootster_EchoPlayerDKP(player, playerkey);
					end
				end
			end
		end

		-- processed this guy
		proc = true;
	elseif	(cmd == LOOTSTER_CMD_MOB) then
		-- item command - see what the item subcommand is
		if		(subcmd == nil) then
			-- please help me
			help = true;
		else
			local	name;

			name = string.lower(subcmd);

			-- they want the DKP for items dropped by matching mobs
			for mobkey, mobsRec in pairs(Lootster_MobsDKP) do
				-- does this mob match the passed name
				if (string.find(mobsRec.Name, name) ~= nil) then
					-- hammer through all items looking for items dropped by this guy
					for itemkey, itemRec in pairs(Lootster_ItemDKP) do
						-- does this player match the passed name
						if (mobkey == itemRec.Mob) then
							-- echo this item's DKP
							Lootster_EchoItemDKP(player, itemkey);
						end
					end
				end
			end
		end

		-- processed this guy
		proc = true;
	elseif	(cmd == LOOTSTER_CMD_ITEM) then
		-- item command - see what the item subcommand is
		if		(subcmd == nil) then
			-- please help me
			help = true;
		else
			local	name;

			name = string.lower(subcmd);

			-- they want the DKP for matching items
			for itemkey, itemRec in pairs(Lootster_ItemDKP) do
				-- does this player match the passed name
				if (string.find(itemRec.Name, name) ~= nil) then
					-- echo this item's DKP
					Lootster_EchoItemDKP(player, itemkey);
				end
			end
		end

		-- processed this guy
		proc = true;
	elseif	(cmd == LOOTSTER_CMD_TELL) then
		-- tell command - see what the subcommand was
		if		(subcmd ~= nil) then
			-- see what the subcommand is
			if		(subcmd == LOOTSTER_SUBCMD_ROLL) then
				-- toggle this player's roll whispers
				Lootster_Players[player].AckRoll = not Lootster_TestPlayerTell(player, "AckRoll");

				-- let em know
				if (Lootster_Players[player].AckRoll == true) then
					Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_TELL_TOGGLE, LOOTSTER_TELL_ACKROLL, LOOTSTER_TOGGLE_ON));
				else
					Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_TELL_TOGGLE, LOOTSTER_TELL_ACKROLL, LOOTSTER_TOGGLE_OFF));
				end
			elseif	(subcmd == LOOTSTER_SUBCMD_NOCALL) then
				-- toggle this player's no call whispers
				Lootster_Players[player].AckNoCall = not Lootster_TestPlayerTell(player, "AckNoCall");

				-- let em know
				if (Lootster_Players[player].AckNoCall == true) then
					Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_TELL_TOGGLE, LOOTSTER_TELL_ACKNOCALL, LOOTSTER_TOGGLE_ON));
				else
					Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_TELL_TOGGLE, LOOTSTER_TELL_ACKNOCALL, LOOTSTER_TOGGLE_OFF));
				end
			elseif	(subcmd == LOOTSTER_SUBCMD_NOROLL) then
				-- toggle this player's no laggard roll command whispers
				Lootster_Players[player].AckNoRoll = not Lootster_TestPlayerTell(player, "AckNoRoll");

				-- let em know
				if (Lootster_Players[player].AckNoRoll == true) then
					Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_TELL_TOGGLE, LOOTSTER_TELL_ACKNOROLL, LOOTSTER_TOGGLE_ON));
				else
					Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_TELL_TOGGLE, LOOTSTER_TELL_ACKNOROLL, LOOTSTER_TOGGLE_OFF));
				end
			elseif	(subcmd == LOOTSTER_SUBCMD_RESET) then
				-- remove any player whisper toggle overrides
				Lootster_Players[player] = nil;

				-- let em know
				Lootster_SendPrivate(player, LOOTSTER_MSG_TELL_RESET);
			else
				-- please help me
				help = true;
			end
		else
			-- please help me
			help = true;
		end

		-- processed this guy
		proc = true;
	end

	-- are they are noddy?
	if (help) then
		-- tell them they got it wrong, then echo help
		Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_BADCOMMAND, msg));

		Lootster_Rule_ShowHelp_OnClick(player);
	end

	return proc;
end

-- Add Roller
function Lootster_AddRoller(player)
	-- if the roll table is empty, we bookkeep all the guys so we have a visual
	-- on who has and has not rolled
	if (table.getn(Lootster_Rolls) == 0) then
		-- add this roller first
		Lootster_AddPlayer(player);

		-- do the rest of the raid
		for key, value in pairs(Lootster_Roster) do
			-- in the roll list?
			if (Lootster_Rolls[key] == nil) then
				-- add this player
				Lootster_AddPlayer(key);
			end
		end
	else
		-- just make sure this guy is added (joined after roll started)
		Lootster_AddPlayer(player);
	end
end

-- Add Player
function Lootster_AddPlayer(player)
	-- is this guy in the roll roster?
	if (Lootster_RosterRoll[player] == nil) then
		-- ignore this guy
		return;
	end

	-- is the player already in the table?
	if (Lootster_Rolls[player] == nil) then
		-- nope, so insert with default data
		Lootster_Rolls[player] = { Player=player, Roll=nil, Class=Lootster_Roster[player].Class, DKP=Lootster_RosterRoll[player].DKP, Tier=Lootster_RosterRoll[player].Tier, App=Lootster_RosterRoll[player].App, Trial=Lootster_RosterRoll[player].Trial, Priority=Lootster_RosterRoll[player].Priority, Bad=nil, Dup=nil };

		-- update record count
		table.setn(Lootster_Rolls, table.getn(Lootster_Rolls) + 1);
	end
end

-- Ask Player for a Roll handler
function Lootster_AskForRoll(player)
	-- see what roll mode we are in
	if		(Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP) then
		local	rngRoll;

		-- determine DKP roll
		rngRoll = Lootster_GetPlayerRoll(player);

		-- ask them to roll
		if (Lootster_ItemLink == nil) then
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ASKN, Lootster_NBG, rngRoll));
		else
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ASKN_LINK, Lootster_NBG, Lootster_ItemLink, rngRoll));
		end
	elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USENORM) then
		-- 100/1000 or Need then Greed?
		if		(Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000) then
			-- ask them to roll 100/1000
			if (Lootster_ItemLink == nil) then
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ASK1000, Lootster_NBG));
			else
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ASK1000_LINK, Lootster_NBG, Lootster_ItemLink));
			end
		elseif	(Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BYNEEDGREED) then
			-- ask them to roll 100
			if (Lootster_ItemLink == nil) then
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ASK100, Lootster_NBG));
			else
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ASK100_LINK, Lootster_NBG, Lootster_ItemLink));
			end
		end
	end
end

-- Update Roll Text handler
function Lootster_UpdateRoll()
	-- update our roll button text
	if		((Lootster_NBG == LOOTSTER_NBG_TIED) and (Lootster_Rolls[Lootster_Self] ~= nil)) then
		-- tied roll is 100
		Lootster_SelfRoll = 100;
	elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP) then
		-- get our DKP roll
		Lootster_SelfRoll = Lootster_GetPlayerRoll(Lootster_Self);
	else
		-- default roll
		Lootster_SelfRoll = 100;
	end

	-- format for the roll button
	Lootster_RollFrameRoll:SetText(string.format(LOOTSTER_ROLL_ROLLRNG_FMT, Lootster_SelfRoll));
end

-- Reset Class handler
function Lootster_ResetClass()
	-- reset restricted count
	Lootster_RestrictedCount = 0;

	-- make sure we clear current class restriction flags
	Lootster_ClassRestricted = false;
	Lootster_ClassRestrictedLock = false;

	-- no classes
	Lootster_ClassRestrictions = {};

	-- reset the restriction masks
	Lootster_ClassRestrictionsMaskOrig = 0;
	Lootster_ClassRestrictionsMaskCurr = 0;

	-- reset count
	table.setn(Lootster_ClassRestrictions, 0);
end

-- Update Class handler
function Lootster_UpdateClass()
	local	cix;
	local	dix = 1;
	local	button;

	-- set the class restrictions
	for cix = 1, table.getn(LOOTSTER_CLASS_SORT), 1 do
		-- is this the ignore class?
		if (LOOTSTER_CLASS_SORT[cix] ~= Lootster_ClassIgnore) then
			-- get the class item button
			button = getglobal("Lootster_ClassFrameClass"..dix);

			-- is this guy allowed?
			if ((Lootster_ClassRestrictions[LOOTSTER_CLASS_SORT[cix]] ~= nil) and (Lootster_ClassRestrictions[LOOTSTER_CLASS_SORT[cix]] == true)) then
				button:SetChecked(true);
			else
				button:SetChecked(false);
			end

			-- enable/disable the button depending on whether these class restrictions are locked down
			if (Lootster_ClassRestrictedLock == true) then
				button:Disable();
			else
				button:Enable();
			end

			-- and bump button count
			dix = dix + 1;
		end
	end
end

-- Update Restricted Count handler
function Lootster_UpdateRestricted()
	-- reset restricted count
	Lootster_RestrictedCount = 0;

	-- hammer through the roster counting allowed classes
	for player, rosRec in pairs(Lootster_Roster) do
		-- is this player allowed to roll?
		if ((Lootster_ClassRestrictions[rosRec.ClassType] ~= nil) and (Lootster_ClassRestrictions[rosRec.ClassType] == true)) then
			Lootster_RestrictedCount = Lootster_RestrictedCount + 1;
		end
	end
end

-- Process Roll handler
function Lootster_ProcessRoll(player, roll, minRoll, maxRoll)
	local   rngRoll;

	-- if no roll call, are we in Normal 100/1000 mode using auto-roll?
	if ((Lootster_NBG == nil) and (Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USENORM) and (Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000) and (Lootster_Options.CorKRoll == true)) then
		-- we are allowing auto-roll, so force that mode
		Lootster_Roll_1001000Roll_OnClick();

		-- is the Looster window open?
		if (not (Lootster_RollFrame:IsVisible() or Lootster_DataFrame:IsVisible() or Lootster_RuleFrame:IsVisible() or Lootster_OptionsFrame:IsVisible())) then
			-- Lootster is close, so are we to open on roll?
			if (Lootster_Options.CorKOpen == true) then
				-- yup, so fire up the window
				Lootster_Toggle();
			else
				-- we in minimap mode?
				if (Lootster_Options.MiniMap == true) then
					-- ensure button is highlighted
					Lootster_MiniMapButtonNorm:Hide();
					Lootster_MiniMapButtonHigh:Show();
				else
					-- nope, so highlight the button
					Lootster_Title:SetChecked(true);
				end
			end
		end
	end

	-- make sure there has been a roll call and player is in roster
	if		(Lootster_NBG == nil) then
		-- are we to ack the no call for roll?
		if (Lootster_TestPlayerTell(player, "AckNoCall") == true) then
			-- format the no roll call message for the player and let them know
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_NONBGPLAYER, Lootster_Self));

			-- format the no roll call message for ourselves and let us know
			Lootster_SendPrivate(Lootster_Self, string.format(LOOTSTER_MSG_NONBGSELF, player));
		end
		return;
	elseif	(Lootster_Roster[player] == nil) then
		-- format the no member message for ourselves and let us know
		Lootster_SendPrivate(Lootster_Self, string.format(LOOTSTER_MSG_NOTMEMBER, player));
		return;
	elseif	(Lootster_NBG == LOOTSTER_NBG_TIED) then
		-- in a tied situation, only the tied players are allowed to roll
		if (Lootster_Rolls[player] == nil) then
			-- too bad buddy - format the not tied winner message
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_NOTTIEDPLAYER));

			-- format the not tied winner message for ourselves and let us know
			Lootster_SendPrivate(Lootster_Self, string.format(LOOTSTER_MSG_NOTTIEDSELF, player));
			return;
		end
	end

	-- convert roll values
	roll	= tonumber(roll);
	minRoll	= tonumber(minRoll);
	maxRoll	= tonumber(maxRoll);

	-- if we are not using DKP, rolls must be normal (1-100)
	if		(Lootster_NBG == LOOTSTER_NBG_TIED) then
		-- tied roll range is 100
		rngRoll = 100;
	elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP) then
		-- calculate DKP roll
		rngRoll = Lootster_GetPlayerRoll(player);
	else
		-- normal is 100
		rngRoll = 100;
	end

	-- is this guy allowed to roll?
	if		(Lootster_RosterRoll[player] == nil) then
		-- naughty naughty bad Zoot!
		Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_NOTROLLCLASS, roll, minRoll, maxRoll, Lootster_NBG_ClassIgnore));
		return;
	elseif	((Lootster_NBG == LOOTSTER_NBG_1001000) and (maxRoll == 100) and (Lootster_ClassRestricted == true) and 
			 ((Lootster_ClassRestrictions[Lootster_Roster[player].ClassType] == nil) or (Lootster_ClassRestrictions[Lootster_Roster[player].ClassType] == false))) then
		-- this is 100/1000 call, and they rolled Need for something that is class restricted against them
		Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_NOTROLLCLASS, roll, minRoll, maxRoll, Lootster_NBG_ClassIgnore));
		return;
	end

	-- bookkeep the roller
	Lootster_AddRoller(player);

	-- check for reclaim, valid and duplicate rolls
	if		((Lootster_Rolls[player].Roll ~= nil) and (Lootster_Rolls[player].Roll > 0)) then
		-- if this is 100/1000 mode, then they are allowed to downgrade from Need to Greed
		if ((Lootster_NBG == LOOTSTER_NBG_1001000) and (minRoll == 1) and (maxRoll == 1000) and (Lootster_Rolls[player].Priority == LOOTSTER_ENUM_NBG.NEED)) then
			-- are we to ack the roll?
			if (Lootster_TestPlayerTell(player, "AckRoll") == true) then
				-- format the ack message and let them know
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKROLLTOGREED, roll, minRoll, maxRoll));
			end

			-- bookkeep the roll
			Lootster_Rolls[player].Roll = roll;

			-- this is now a Greed
			Lootster_Rolls[player].Priority = LOOTSTER_ENUM_NBG.GREED;
		else
			-- format the duplicate message and let them know
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_DUP, roll, minRoll, maxRoll, Lootster_Rolls[player].Roll));

			-- bookkeep the duplicate roll
			if (Lootster_Rolls[player].Dup == nil) then
				Lootster_Rolls[player].Dup = 1;
			else
				Lootster_Rolls[player].Dup = Lootster_Rolls[player].Dup + 1;
			end
		end
	elseif	((Lootster_Rolls[player].Roll ~= nil) and (Lootster_Rolls[player].Roll < 0)) then
		-- if this is 100/1000 mode, then they are allowed to downgrade from Need to Greed
		if ((Lootster_NBG == LOOTSTER_NBG_1001000) and (minRoll == 1) and (maxRoll == 1000) and (Lootster_Rolls[player].Priority == LOOTSTER_ENUM_NBG.NEED)) then
			-- are we to ack the roll?
			if (Lootster_TestPlayerTell(player, "AckRoll") == true) then
				-- format the ack message and let them know
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKROLLTOGREED, roll, minRoll, maxRoll));
			end

			-- bookkeep the roll
			Lootster_Rolls[player].Roll = roll;

			-- this is now a Greed
			Lootster_Rolls[player].Priority = LOOTSTER_ENUM_NBG.GREED;

			-- did this come from us?
			if (player == Lootster_Self) then
				-- update the text to indicate pass
				Lootster_RollFramePassReclaim:SetText(LOOTSTER_ROLL_PASS);
			end
		else
			-- they passed a previous roll - let them know they need to reclaim rather than reroll
			if (Lootster_ItemLink == nil) then
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_MUSTRECLAIMROLL, -Lootster_Rolls[player].Roll, Lootster_NBG));
			else
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_MUSTRECLAIMROLL_LINK, -Lootster_Rolls[player].Roll, Lootster_NBG, Lootster_ItemLink));
			end
			return;
		end
	elseif	((minRoll ~= 1) or 
			 ((maxRoll ~= rngRoll) and ((Lootster_NBG ~= LOOTSTER_NBG_1001000) or (maxRoll ~= 1000)))) then
		-- format the reject message and let them know
		Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_REJECT, roll, minRoll, maxRoll));

		-- inform user to roll
		Lootster_AskForRoll(player);

		-- bookkeep the bad roll
		if (Lootster_Rolls[player].Bad == nil) then
			Lootster_Rolls[player].Bad = 1;
		else
			Lootster_Rolls[player].Bad = Lootster_Rolls[player].Bad + 1;
		end
	else
		-- are we to ack the roll?
		if (Lootster_TestPlayerTell(player, "AckRoll") == true) then
			-- format the ack message and let them know
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKROLL, roll, minRoll, maxRoll));
		end

		-- bump roll count unless they had passed
		if (Lootster_Rolls[player].Roll ~= 0) then
			Lootster_RollCount = Lootster_RollCount + 1;
		end

		-- bookkeep the roll
		Lootster_Rolls[player].Roll = roll;

		-- are we using 100/1000?
		if (Lootster_NBG == LOOTSTER_NBG_1001000) then
			-- 100 is a Greed roll
			if (maxRoll == 100) then
				-- this is Need
				Lootster_Rolls[player].Priority = LOOTSTER_ENUM_NBG.NEED;
			else
				-- this is Greed
				Lootster_Rolls[player].Priority = LOOTSTER_ENUM_NBG.GREED;
			end
		end
	end

	-- sort the rolls
	Lootster_Roll_Sort();

	-- update received roll status
	Lootster_UpdateUI();	

	-- update the screen
	Lootster_Roll_Update();
end

-- Create Roll Plead handler
function Lootster_CreatePlead()
	local	class, count, ix;

	local	classes = {};

	-- handle the class restrictions if we are rolling Need or 100/1000 and they are set
	if ((Lootster_NBG ~= nil) and ((Lootster_NBG == LOOTSTER_NBG_NEED) or (Lootster_NBG == LOOTSTER_NBG_1001000))) then
		-- see if we have class restrict
		if (table.getn(Lootster_ClassRestrictions) > 0) then
			-- build an alphabetical list of restricted classes
			for ix, flag in ipairs(LOOTSTER_CLASS_SORT) do
				-- is this not the ignore class and this class restricted?
				if ((LOOTSTER_CLASS_SORT[ix] ~= Lootster_ClassIgnore) and (Lootster_ClassRestrictions[LOOTSTER_CLASS_SORT[ix]] == true)) then
					table.insert(classes, LOOTSTER_CLASS_SORT[ix]);
				end
			end

			-- now build the class please and class ignore texts
			count = table.getn(classes);

			Lootster_NBG_ClassPlease = "";
			Lootster_NBG_ClassIgnore = "";

			for ix=1, count, 1 do
				-- add plural class to please text
				Lootster_NBG_ClassPlease = Lootster_NBG_ClassPlease..LOOTSTER_CLASS[classes[ix]].Plural;

				if		(ix < (count - 1)) then
					Lootster_NBG_ClassPlease = Lootster_NBG_ClassPlease..LOOTSTER_MSG_SEP;
				elseif (ix == (count - 1)) then
					Lootster_NBG_ClassPlease = Lootster_NBG_ClassPlease..LOOTSTER_MSG_AND;
				end
			
				-- add singular class to ignore text
				Lootster_NBG_ClassIgnore = Lootster_NBG_ClassIgnore..LOOTSTER_CLASS[classes[ix]].Singular;

				if		(ix < (count - 1)) then
					Lootster_NBG_ClassIgnore = Lootster_NBG_ClassIgnore..LOOTSTER_MSG_SEP;
				elseif (ix == (count - 1)) then
					Lootster_NBG_ClassIgnore = Lootster_NBG_ClassIgnore..LOOTSTER_MSG_OR;
				end
			end

			-- do we have no class restrictions?
			if (count == 0) then
				-- reset class restrictions
				Lootster_ResetClass();

				-- update the class UI
				Lootster_UpdateClass();

				-- update the UI
				Lootster_UpdateUI();

				-- nope, so use normal plead
				Lootster_NBG_ClassPlease = LOOTSTER_MSG_PLEASE;
			else
				-- yup, so use the class plead
				Lootster_NBG_ClassPlease = string.format(LOOTSTER_MSG_PLEASE_CLASS, Lootster_NBG_ClassPlease);
			end
		else
			-- set the normal plead 
			Lootster_NBG_ClassPlease = LOOTSTER_MSG_PLEASE;
		end
	else
		-- set the normal plead 
		Lootster_NBG_ClassPlease = LOOTSTER_MSG_PLEASE;
	end
end

-- Update UI handler
function Lootster_UpdateUI()
	-- enable clear rolls and NBGs depending on state
	if		((Lootster_Tied == true) and (Lootster_NBG ~= LOOTSTER_NBG_TIED)) then
		-- clearable
		Lootster_RollFrameClearRolls:Enable();

		-- waiting for tied roll
		Lootster_RollFrameTiedRoll:Enable();
	elseif	(Lootster_NBG ~= nil) then
		-- clearable
		Lootster_RollFrameClearRolls:Enable();

		-- waiting for rolls
		Lootster_RollFrameNeedRoll:Disable();
		Lootster_RollFrameGreedRoll:Disable();
		Lootster_RollFrame1001000Roll:Disable();
		Lootster_RollFrameTiedRoll:Disable();
	else
		-- can't clear!
		Lootster_RollFrameClearRolls:Disable();

		-- waiting for roll call
		Lootster_RollFrameNeedRoll:Enable();
		Lootster_RollFrameGreedRoll:Enable();
		Lootster_RollFrame1001000Roll:Enable();
		Lootster_RollFrameTiedRoll:Disable();
	end

	-- format received count out of players
	if		(Lootster_NBG == LOOTSTER_NBG_TIED) then
		Lootster_RollFrameRollCount:SetText(string.format(LOOTSTER_ROLL_ROLLCOUNT_FMT, Lootster_RollCount, table.getn(Lootster_Rolls)));
	elseif	((Lootster_NBG == LOOTSTER_NBG_NEED) and (Lootster_ClassRestricted == true)) then
		Lootster_RollFrameRollCount:SetText(string.format(LOOTSTER_ROLL_ROLLCOUNT_FMT, Lootster_RollCount, Lootster_RestrictedCount));
	else
		Lootster_RollFrameRollCount:SetText(string.format(LOOTSTER_ROLL_ROLLCOUNT_FMT, Lootster_RollCount, Lootster_PlayerCount));
	end

	-- set the text color appropriately
	if		((Lootster_NBG == nil) or (Lootster_RollCount == 0)) then
		Lootster_RollFrameRollCount:Disable();
	elseif	((Lootster_NBG == LOOTSTER_NBG_TIED) and (Lootster_RollCount < table.getn(Lootster_Rolls))) then
		Lootster_RollFrameRollCount:Enable();
	elseif	((Lootster_NBG == LOOTSTER_NBG_NEED) and (Lootster_ClassRestricted == true) and (Lootster_RollCount < Lootster_RestrictedCount)) then
		Lootster_RollFrameRollCount:Enable();
	elseif	(((Lootster_NBG ~= LOOTSTER_NBG_NEED) or (Lootster_ClassRestricted == false)) and (Lootster_RollCount < Lootster_PlayerCount)) then
		Lootster_RollFrameRollCount:Enable();
	else	
		Lootster_RollFrameRollCount:Disable();
	end

	-- enable countdown button if NBG set
	if ((Lootster_Options.Counter == false) or (Lootster_Options.CounterSec == 0) or (Lootster_NBG == nil) or 
		((Lootster_NBG == LOOTSTER_NBG_TIED) and (Lootster_RollCount == table.getn(Lootster_Rolls))) or
		((Lootster_NBG == LOOTSTER_NBG_NEED) and (Lootster_ClassRestricted == true) and (Lootster_RollCount == Lootster_RestrictedCount)) or
		(((Lootster_NBG ~= LOOTSTER_NBG_NEED) or (Lootster_ClassRestricted == false)) and (Lootster_RollCount == Lootster_PlayerCount))) then
		Lootster_RollFrameCountdown:Disable();
	else
		Lootster_RollFrameCountdown:Enable();
	end

	-- enable announce button if we have (unpassed) rolls.  Also handle loot assignment if using DKP
	if		(Lootster_ItemCount <= 0) then
		-- no items left	
		Lootster_RollFrameAnnounce:Disable();
	elseif	((Lootster_RollCount == 0) or (Lootster_Rolls[Lootster_RollsSort[1]].Roll <= 0)) then
		-- using DKP?
		if (Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP) then
			-- if we have loot linked, we will allow them to assign loot (Bank/Rotted)
			if (Lootster_ItemLink ~= nil) then
				-- allow loot assignment without roll
				Lootster_RollFrameAssignLoot:Enable();
			else
				-- disallow loot assignment
				Lootster_RollFrameAssignLoot:Disable();
			end
		end
		
		-- and disallow announcement	
		Lootster_RollFrameAnnounce:Disable();
	else
		-- using DKP?
		if (Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP) then
			-- allow loot assignment	
			Lootster_RollFrameAssignLoot:Enable();
		end
		
		-- and allow announcement	
		Lootster_RollFrameAnnounce:Enable();
	end

	-- enable roll button if we haven't (pass) rolled (and we are allowed too in a tie)
	if		((Lootster_Options.Active == false) and (Lootster_Options.Passive == true)) then
		-- we are not the active looter in passive roll/pass mode, so enable rolling if we ourselves are not class restricted or its not a Need roll
		if		((Lootster_NBG == LOOTSTER_NBG_NEED) and (Lootster_ClassRestricted == true) and ((Lootster_ClassRestrictions[Lootster_SelfClassType] == nil) or (Lootster_ClassRestrictions[Lootster_SelfClassType] == false))) then
			Lootster_RollFrameRoll:Disable();
		elseif	(Lootster_NBG == LOOTSTER_NBG_1001000) then
			-- 100/1000 rolling - only enable 100 roll if we are allowed to
			if ((Lootster_ClassRestricted == true) and ((Lootster_ClassRestrictions[Lootster_SelfClassType] == nil) or (Lootster_ClassRestrictions[Lootster_SelfClassType] == false))) then
				Lootster_RollFrameRoll100:Disable();
			else
				Lootster_RollFrameRoll100:Enable();
			end

			Lootster_RollFrameRoll1000:Enable();
		else
			Lootster_RollFrameRoll:Enable();
			Lootster_RollFrameRoll100:Enable();
			Lootster_RollFrameRoll1000:Enable();
		end
	elseif	(Lootster_NBG == nil) then
		Lootster_RollFrameRoll:Disable();

		-- are in 100/1000 and are allowed to roll without a call?
		if ((Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USENORM) and (Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000) and (Lootster_Options.CorKRoll == true)) then
			Lootster_RollFrameRoll100:Enable();
			Lootster_RollFrameRoll1000:Enable();
		else
			Lootster_RollFrameRoll100:Disable();
			Lootster_RollFrameRoll1000:Disable();
		end
	elseif	((Lootster_Rolls[Lootster_Self] ~= nil) and (Lootster_Rolls[Lootster_Self].Roll ~= nil) and (Lootster_Rolls[Lootster_Self].Roll ~= 0)) then
		Lootster_RollFrameRoll:Disable();
		Lootster_RollFrameRoll100:Disable();

		-- if we are in 100/1000 mode, and they rolled Need, we can downgrade to Greed
		if ((Lootster_NBG == LOOTSTER_NBG_1001000) and (Lootster_Rolls[Lootster_Self].Priority == LOOTSTER_ENUM_NBG.NEED)) then
			Lootster_RollFrameRoll1000:Enable();
		else
			Lootster_RollFrameRoll1000:Disable();
		end
	else
		-- see if we are in a tie or restricted or its not a Need roll 
		if		((Lootster_NBG == LOOTSTER_NBG_TIED) and (Lootster_Rolls[Lootster_Self] == nil)) then
			Lootster_RollFrameRoll:Disable();
		elseif	((Lootster_NBG == LOOTSTER_NBG_NEED) and (Lootster_ClassRestricted == true) and ((Lootster_ClassRestrictions[Lootster_SelfClassType] == nil) or (Lootster_ClassRestrictions[Lootster_SelfClassType] == false))) then
			Lootster_RollFrameRoll:Disable();
		elseif	(Lootster_NBG == LOOTSTER_NBG_1001000) then
			-- 100/1000 rolling - only enable 100 roll if we are allowed to
			if ((Lootster_ClassRestricted == true) and ((Lootster_ClassRestrictions[Lootster_SelfClassType] == nil) or (Lootster_ClassRestrictions[Lootster_SelfClassType] == false))) then
				Lootster_RollFrameRoll100:Disable();
			else
				Lootster_RollFrameRoll100:Enable();
			end

			Lootster_RollFrameRoll1000:Enable();
		else
			Lootster_RollFrameRoll:Enable();
			Lootster_RollFrameRoll100:Enable();
			Lootster_RollFrameRoll1000:Enable();
		end
	end

	-- handle pass/reclaim button depending if they have rolled
	if		((Lootster_Options.Active == false) and (Lootster_Options.Passive == true)) then
		-- we are not the active looter in passive roll/pass mode, so enable pass/reclaim if we ourselves are not class restricted or its not a Need roll
		Lootster_RollFramePassReclaim:Enable();
		if ((Lootster_NBG == LOOTSTER_NBG_NEED) and (Lootster_ClassRestricted == true) and ((Lootster_ClassRestrictions[Lootster_SelfClassType] == nil) or (Lootster_ClassRestrictions[Lootster_SelfClassType] == false))) then
			Lootster_RollFramePassReclaim:Disable();
		else
			Lootster_RollFramePassReclaim:Enable();
		end
	elseif	(Lootster_NBG == nil) then
		-- nothing to roll on yet
		Lootster_RollFramePassReclaim:Disable();
	elseif	(Lootster_Rolls[Lootster_Self] ~= nil) then
		-- pass/reclaim if we haven't/have passed
		if		((Lootster_Rolls[Lootster_Self].Roll == nil) or (Lootster_Rolls[Lootster_Self].Roll ~= 0)) then
			-- they can pass/reclaim as the case may be
			Lootster_RollFramePassReclaim:Enable();
		elseif	((Lootster_Rolls[Lootster_Self].Roll ~= nil) and (Lootster_Rolls[Lootster_Self].Roll == 0)) then
			-- they can roll if they want
			Lootster_RollFramePassReclaim:Disable();
		end
	elseif	((Lootster_NBG == LOOTSTER_NBG_NEED) and (Lootster_ClassRestricted == true) and ((Lootster_ClassRestrictions[Lootster_SelfClassType] == nil) or (Lootster_ClassRestrictions[Lootster_SelfClassType] == false))) then
		Lootster_RollFramePassReclaim:Disable();
	else
		-- no roll yet, but they can pass
		Lootster_RollFramePassReclaim:Enable();
	end

	-- if we are in roll mode, disable item count, DKP use toggle and DKP caps
	if ((Lootster_NBG ~= nil) or (Lootster_Tied == true)) then
		-- disable and hide item count if not in DKP mode
		if (Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USENORM) then
			-- disable item count
			Lootster_RollFrameItems:Hide();

			Lootster_RollFrameItemsROFrame:Show();
		end

		-- do we have DKP handling?
		if (Lootster_HasDKP == true) then
			-- disable roll mode dropdown
			Lootster_OptionsFrameRollModeButton:Disable();
		end

		-- disable roll type dropdown
		Lootster_OptionsFrameRollTypeButton:Disable();

		-- disable DKP priority option
		Lootster_OptionsFrameDKPPriority:Disable();

		-- disable DKP cap options
		Lootster_OptionsFrameDKPCaps:Disable();
		Lootster_OptionsFrameDKPHi:Hide();
		Lootster_OptionsFrameDKPLo:Hide();

		Lootster_OptionsFrameDKPHiROFrame:Show();
		Lootster_OptionsFrameDKPLoROFrame:Show();
	else
		-- enable and show item count if not in DKP mode
		if (Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USENORM) then
			-- enable item count
			Lootster_RollFrameItems:Show();

			Lootster_RollFrameItemsROFrame:Hide();
		end

		-- do we have DKP handling?
		if (Lootster_HasDKP == true) then
			-- enable roll mode dropdown
			Lootster_OptionsFrameRollModeButton:Enable();
		end

		-- enable roll type dropdown
		Lootster_OptionsFrameRollTypeButton:Enable();

		-- enable DKP priority option
		Lootster_OptionsFrameDKPPriority:Enable();

		-- enable DKP cap options
		Lootster_OptionsFrameDKPCaps:Enable();
		Lootster_OptionsFrameDKPHi:Show();
		Lootster_OptionsFrameDKPLo:Show();

		Lootster_OptionsFrameDKPHiROFrame:Hide();
		Lootster_OptionsFrameDKPLoROFrame:Hide();
	end

	-- are these restrictions locked down?
	if ((Lootster_ClassRestrictedLock == true) or (Lootster_ClassRestrictionsMaskOrig ~= 0)) then
		-- disable the restrict roll button
		Lootster_RollFrameRestrictRoll:Disable();
	else
		-- enable the restrict roll button
		Lootster_RollFrameRestrictRoll:Enable();
	end

	-- update state of class restrict remember button
	if ((Lootster_ItemID ~= nil) and (Lootster_ClassRestrictedLock == false) and (Lootster_ClassRestrictionsMaskOrig ~= Lootster_ClassRestrictionsMaskCurr)) then
		-- enable remember button
		Lootster_ClassFrameRemember:Enable();
	else
		-- disable remember button
		Lootster_ClassFrameRemember:Disable();
	end

	-- update state of class restrict forget button
	if ((Lootster_ItemID ~= nil) and (Lootster_ClassRestrictedLock == false) and (Lootster_ClassRestrictionsMaskOrig ~= 0)) then
		-- enable remember button
		Lootster_ClassFrameForget:Enable();
	else
		-- disable remember button
		Lootster_ClassFrameForget:Disable();
	end
end

-- Update Roll Handling handler
function Lootster_UpdateRollHandling()
	-- reposition tabs and update UI
	Lootster_CheckModeUse();

	-- reformat our roll button text
	Lootster_UpdateRoll();

	-- update received roll status
	Lootster_UpdateUI();

	-- broadcast the roll handling message
	Lootster_SendBroadcast(Lootster_GetRollHandling());
end

-- Pass Roll handler
function Lootster_PassRoll(player)
	-- see if a roll is called
	if (Lootster_NBG == nil) then
		-- no need for us to bookkeep
		return;
	end

	-- if we are in a tied roll, only the tied players can pass/reclaim
	if ((Lootster_NBG == LOOTSTER_NBG_TIED) and (Lootster_Rolls[player] == nil)) then
		-- no processing
		return;
	end

	-- is this guy allowed to roll?
	if (Lootster_RosterRoll[player] == nil) then
		-- naughty naughty bad Zoot!
		Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_NOTPASSCLASS, Lootster_NBG_ClassIgnore));

		return;
	end

	-- bookkeep the roller
	Lootster_AddRoller(player);

	-- check if they have rolled before
	if		(Lootster_Rolls[player].Roll == nil) then
		-- simply set to zero to indicate no roll
		Lootster_Rolls[player].Roll = 0;

		-- bump roll count
		Lootster_RollCount = Lootster_RollCount + 1;

		-- ack the pass
		if (Lootster_ItemLink == nil) then
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKPASSNONE, Lootster_NBG));
		else
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKPASSNONE_LINK, Lootster_NBG, Lootster_ItemLink));
		end
	elseif	(Lootster_Rolls[player].Roll > 0) then
		local	nbg = Lootster_NBG;

		-- if we are in 100/1000 mode, they rolled one or the other.  Reflect that
		if (Lootster_NBG == LOOTSTER_NBG_1001000) then
			-- determine if they rolled need or greed
			if		(Lootster_Rolls[player].Priority == LOOTSTER_ENUM_NBG.NEED) then
				nbg = LOOTSTER_NBG_NEED;
			elseif	(Lootster_Rolls[player].Priority == LOOTSTER_ENUM_NBG.GREED) then
				nbg = LOOTSTER_NBG_GREED;
			end
		end

		-- simply set to the negative to indicate passed
		Lootster_Rolls[player].Roll = -Lootster_Rolls[player].Roll;

		-- ack the pass
		if (Lootster_ItemLink == nil) then
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKPASSROLL, -Lootster_Rolls[player].Roll, nbg));
		else
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKPASSROLL_LINK, -Lootster_Rolls[player].Roll, nbg, Lootster_ItemLink));
		end
	else
		-- already passed - ignore - ack the pass anyway
		if (Lootster_Rolls[player].Roll == 0) then
			if (Lootster_ItemLink == nil) then
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKPASSNONE, Lootster_NBG));
			else
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKPASSNONE_LINK, Lootster_NBG, Lootster_ItemLink));
			end
		else
			local	nbg = Lootster_NBG;

			-- if we are in 100/1000 mode, they rolled one or the other.  Reflect that
			if (Lootster_NBG == LOOTSTER_NBG_1001000) then
				-- determine if they rolled need or greed
				if		(Lootster_Rolls[player].Priority == LOOTSTER_ENUM_NBG.NEED) then
					nbg = LOOTSTER_NBG_NEED;
				elseif	(Lootster_Rolls[player].Priority == LOOTSTER_ENUM_NBG.GREED) then
					nbg = LOOTSTER_NBG_GREED;
				end
			end

			if (Lootster_ItemLink == nil) then
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKPASSROLL, -Lootster_Rolls[player].Roll, nbg));
			else
				Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKPASSROLL_LINK, -Lootster_Rolls[player].Roll, nbg, Lootster_ItemLink));
			end
		end

		return;
	end

	-- did this come from us?
	if (player == Lootster_Self) then
		-- update the text to indicate pass or reclaim
		if		((Lootster_Rolls[Lootster_Self] == nil) or (Lootster_Rolls[Lootster_Self].Roll == nil) or (Lootster_Rolls[Lootster_Self].Roll >= 0)) then
			-- set text for passing
			Lootster_RollFramePassReclaim:SetText(LOOTSTER_ROLL_PASS);
		elseif	((Lootster_Rolls[Lootster_Self] ~= nil) and (Lootster_Rolls[Lootster_Self].Roll ~= nil) and (Lootster_Rolls[Lootster_Self].Roll <= 0)) then
			-- set text for reclaiming
			Lootster_RollFramePassReclaim:SetText(LOOTSTER_ROLL_RECLAIM);
		else
			-- default is pass
			Lootster_RollFramePassReclaim:SetText(LOOTSTER_ROLL_PASS);
		end
	end

	-- sort the rolls
	Lootster_Roll_Sort();

	-- update received roll status
	Lootster_UpdateUI();	

	-- update the screen
	Lootster_Roll_Update();
end

-- Reclaim Roll handler
function Lootster_ReclaimRoll(player)
	-- see if a roll is called
	if (Lootster_NBG == nil) then
		-- no need for us to bookkeep
		return;
	end

	-- if we are in a tied roll, only the tied players can pass/reclaim
	if ((Lootster_NBG == LOOTSTER_NBG_TIED) and (Lootster_Rolls[player] == nil)) then
		-- no processing
		return;
	end

	-- is this guy allowed to roll?
	if (Lootster_RosterRoll[player] == nil) then
		-- naughty naughty bad Zoot!
		Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_NOTRECLAIMCLASS, Lootster_NBG_ClassIgnore));

		return;
	end

	-- bookkeep the roller
	Lootster_AddRoller(player);

	-- check if they have rolled before
	if		((Lootster_Rolls[player].Roll == nil) or (Lootster_Rolls[player].Roll == 0)) then
		-- let them know they have not rolled before
		if (Lootster_ItemLink == nil) then
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKRECLAIMNONE, Lootster_NBG));
		else
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKRECLAIMNONE_LINK, Lootster_NBG, Lootster_ItemLink));
		end

		-- and ask them nicely to roll
		Lootster_AskForRoll(player);

		return;
	elseif	(Lootster_Rolls[player].Roll < 0) then
		local	nbg = Lootster_NBG;

		-- if we are in 100/1000 mode, they rolled one or the other.  Reflect that
		if (Lootster_NBG == LOOTSTER_NBG_1001000) then
			-- determine if they rolled need or greed
			if		(Lootster_Rolls[player].Priority == LOOTSTER_ENUM_NBG.NEED) then
				nbg = LOOTSTER_NBG_NEED;
			elseif	(Lootster_Rolls[player].Priority == LOOTSTER_ENUM_NBG.GREED) then
				nbg = LOOTSTER_NBG_GREED;
			end
		end

		-- simply set to the re-negate to indicate reclaim
		Lootster_Rolls[player].Roll = -Lootster_Rolls[player].Roll;

		-- ack the reclaim
		if (Lootster_ItemLink == nil) then
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKRECLAIMROLL, Lootster_Rolls[player].Roll, nbg));
		else
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACKRECLAIMROLL_LINK, Lootster_Rolls[player].Roll, nbg, Lootster_ItemLink));
		end
	else
		local	nbg = Lootster_NBG;

		-- if we are in 100/1000 mode, they rolled one or the other.  Reflect that
		if (Lootster_NBG == LOOTSTER_NBG_1001000) then
			-- determine if they rolled need or greed
			if		(Lootster_Rolls[player].Priority == LOOTSTER_ENUM_NBG.NEED) then
				nbg = LOOTSTER_NBG_NEED;
			elseif	(Lootster_Rolls[player].Priority == LOOTSTER_ENUM_NBG.GREED) then
				nbg = LOOTSTER_NBG_GREED;
			end
		end

		-- roll is still active
		if (Lootster_ItemLink == nil) then
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACTIVEROLL, Lootster_Rolls[player].Roll, nbg));
		else
			Lootster_SendPrivate(player, string.format(LOOTSTER_MSG_ACTIVEROLL_LINK, Lootster_Rolls[player].Roll, nbg, Lootster_ItemLink));
		end

		return;
	end

	-- did this come from us?
	if (player == Lootster_Self) then
		-- update the text to indicate pass or reclaim
		if		((Lootster_Rolls[Lootster_Self] == nil) or (Lootster_Rolls[Lootster_Self].Roll == nil) or (Lootster_Rolls[Lootster_Self].Roll >= 0)) then
			-- set text for passing
			Lootster_RollFramePassReclaim:SetText(LOOTSTER_ROLL_PASS);
		elseif	((Lootster_Rolls[Lootster_Self] ~= nil) and (Lootster_Rolls[Lootster_Self].Roll ~= nil) and (Lootster_Rolls[Lootster_Self].Roll <= 0)) then
			-- set text for reclaiming
			Lootster_RollFramePassReclaim:SetText(LOOTSTER_ROLL_RECLAIM);
		else
			-- default is pass
			Lootster_RollFramePassReclaim:SetText(LOOTSTER_ROLL_PASS);
		end
	end

	-- sort the rolls
	Lootster_Roll_Sort();

	-- update received roll status
	Lootster_UpdateUI();	

	-- update the screen
	Lootster_Roll_Update();
end

-- Calculate DKP  handler
function Lootster_CalcDKP(dkp)
	-- round to whole DKP
	dkp = tonumber(string.format("%.0f", dkp));

	return dkp;
end

-- Calculate Tier handler
function Lootster_CalcTier(dkp)
	local   found	= false;
	local	tier	= LOOTSTER_TIER_UNKNOWN;

	-- hammer through tier table
	for ix, dkpRec in ipairs(Lootster_TierDKP) do
		-- see how to apply the range
		if		(dkpRec.Lo == nil) then
			found = (dkp < dkpRec.Hi);
		elseif  (dkpRec.Hi == nil) then
			found = (dkp >= dkpRec.Lo);
		else
			found = (dkp >= dkpRec.Lo) and (dkp < dkpRec.Hi);
		end

		if (found) then
			-- snarf tier if we found it
			tier = dkpRec.Tier;
			break;
		end
	end

	return tier;
end

-- Calculate Priority handler
function Lootster_CalcPriority(app, trial)
	local	prior = "";

	-- determine the priority flags to use
	if ((app == false) and (trial == false)) then
		-- Full member
		prior = LOOTSTER_DKP_PRIOR_FULL..prior;
	else
		-- applicant and/or trial flags
		if (trial == true) then
			-- Trial Member
			prior = LOOTSTER_DKP_PRIOR_TRIAL..prior;
		end

		if (app == true) then
			-- Applicant Member
			prior = LOOTSTER_DKP_PRIOR_APP..prior;
		end
	end

	return prior;
end


-- Retrieve Player DKP handler
function Lootster_GetPlayerDKP(player)
	local	main;
	local	dkp = 0.0;

	-- resolve the player into a main
	main = Lootster_GetALTMain(player);

	-- do we have DKP for this player?
	if (Lootster_DKP[main] ~= nil) then
		-- snarf DKP
		dkp = Lootster_DKP[main].DKP;
	end

	-- round to whole DKP
	dkp = Lootster_CalcDKP(dkp);

	-- do we apply caps
	if (Lootster_Options.DKPCaps) then
		-- yup, so apply hi/lo as appropriate
		if	  ((dkp < 0) and (math.abs(dkp) > Lootster_Options.DKPLo)) then
			-- set to low limit
			dkp = - Lootster_Options.DKPLo;
		elseif	((dkp > 0) and (dkp > Lootster_Options.DKPHi)) then
			-- set to high limit
			dkp = Lootster_Options.DKPHi;
		end
	end

	return dkp;
end

-- Retrieve Player Tier handler
function Lootster_GetPlayerTier(player)
	local	dkp;
	local	tier;

	-- get the player's capped DKP
	dkp = Lootster_GetPlayerDKP(player);

	-- and determine the capped tier
	tier = Lootster_CalcTier(dkp);

	return tier;
end

-- Retrieve Player Roll handler
function Lootster_GetPlayerRoll(player)
	local	roll;

	-- see what type of DKP we are using
	if		(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYDKP) then
		-- By DKP, so roll is 100
		roll = 100;
	elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
		-- By Tier, so roll is 100
		roll = 100;
	elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYMODIFIED) then
		-- By Modified Roll, so roll is DKP + 100
		roll = Lootster_GetPlayerDKP(player) + 100;
	else
		-- use 100 since we don't know any better
		roll = 100;
	end

	return roll;
end

-- Get Player Priority handler
function Lootster_GetPlayerPriority(player)
	local	prior = "";

	-- do we have membership in effect?
	if (Lootster_Options.DKPPrior == true) then
		-- calculate priority
		prior = Lootster_CalcPriority(Lootster_GetPlayerMembership(player));
	end

	return prior;
end

-- Retrieve Player Position handler
function Lootster_GetPlayerPosition(player)
	local	high = LOOTSTER_ECHO_NA;
	local	equal = LOOTSTER_ECHO_NA;

	-- do we have DKP for this player?
	if (Lootster_RosterRoll[player] ~= nil) then
		-- snarf app and trial membership
		high = Lootster_RosterRoll[player].High;
		equal = Lootster_RosterRoll[player].Equal;
	end

	return high, equal;
end

-- Retrieve Player Membership handler
function Lootster_GetPlayerMembership(player)
	local	main;
	local	app = false;
	local	trial = false;

	-- resolve the player into a main
	main = Lootster_GetALTMain(player);

	-- do we have DKP for this player?
	if (Lootster_DKP[main] ~= nil) then
		-- snarf app and trial membership
		app = Lootster_DKP[main].App;
		trial = Lootster_DKP[main].Trial;
	end

	return app, trial;
end

-- Retrieve Player Tell Toggle handler
function Lootster_TestPlayerTell(player, key)
	-- does this player have a tell override?
	if ((Lootster_Players[player] ~= nil) and (Lootster_Players[player][key] ~= nil)) then
		-- return player's preference
		return Lootster_Players[player][key];
	else
		-- return master preference
		return Lootster_Options[key];
	end
end

-- Get Alt Look-aside Table Main hander
function Lootster_GetALTMain(player)
	local	name = player;

	-- is this a player an alt?
	if (Lootster_ALTMain[player] ~= nil) then
		-- this is an alt - return main name for reference
		name = Lootster_ALTMain[player];
	end

	return name;
end

-- Get Main to Alt Look-aside Table hander
function Lootster_GetMainALT(player)
	local	name = player;

	-- is this a player a main?
	if (Lootster_MainALT[player] ~= nil) then
		-- this is main - return alt name for reference
		name = Lootster_MainALT[player];
	end

	return name;
end

-- Get Roll Handling handler
function Lootster_GetRollHandling()
	local	msg = "";

	-- send the roll handling message
	if		(Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP) then
		local	mode, prior, caps;

		-- determine the DKP type
		if		(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYDKP) then
			mode = LOOTSTER_MSG_TYPEDKP;
		elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
			mode = LOOTSTER_MSG_TYPETIER;
		elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYMODIFIED) then
			mode = LOOTSTER_MSG_TYPEMODIFIED;
		else
			-- unknown DKP type - hammer into tier type and recall
			Lootster_Options.DKPType = LOOTSTER_ENUM_DKP.BYTIER;

			return(Lootster_GetRollHandling());
		end

		-- determine membership priority
		if (Lootster_Options.DKPPrior == true) then
			prior = LOOTSTER_MSG_PRIORUSED;
		else
			prior = LOOTSTER_MSG_PRIORNONE;
		end

		-- determine if we have DKP caps in effect
		if (Lootster_Options.DKPCaps == true) then
			-- format caps
			caps = string.format(LOOTSTER_MSG_CAPSUSED, Lootster_Options.DKPHi, Lootster_Options.DKPLo);
		else
			-- no caps in effect
			caps = LOOTSTER_MSG_CAPSNONE;
		end

		-- format DKP mode message
		msg = string.format(LOOTSTER_MSG_DKPMODE, mode, prior, caps);
	elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USENORM) then
		local	mode, call;

		-- determine the normal type
		if		(Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000) then
			-- tell everyone that we are using 100/1000
			mode = LOOTSTER_MSG_TYPE1001000;

			-- see if roll calls are required
			if (Lootster_Options.CorKRoll == true) then
				call = LOOTSTER_MSG_OPTIONAL;
			else
				call = LOOTSTER_MSG_REQUIRED;
			end
		elseif	(Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BYNEEDGREED) then
			-- tell everyone that we are using Need then Greed
			mode = LOOTSTER_MSG_TYPENEEDGREED;

			-- roll calls always required
			call = LOOTSTER_MSG_REQUIRED;
		else
			-- unknown normal type - hammer into greed then need type and recall
			Lootster_Options.NormType = LOOTSTER_ENUM_NORM.BYNEEDGREED;

			return(Lootster_GetRollHandling());
		end

		-- format normal mode message
		msg = string.format(LOOTSTER_MSG_NORMMODE, mode, call);
	else
		-- unknown roll type - hammer into normal mode and recall
		Lootster_Options.RollMode = LOOTSTER_ENUM_MODE.USENORM;

		return(Lootster_GetRollHandling());
	end

	return msg;
end

-- Retrieve Item Details handler
function Lootster_GetItemDetails(itemLink)
	local	ix, field, item, text, singulars, singular, classes, class, flag;

	local	itemID = nil;
	local	itemText = "";

	local	restricted = false;
	local	restrictedLock = false;

	local	restrictions = {};
	local	restrictionsMask = 0;

	-- do we have an item?
	if (itemLink ~= nil) then
		-- extract the ID of the item
		for item in string.gfind(itemLink, LOOTSTER_ITEMLINK_PATTERN) do
			-- this is the invariant identifer for the item
			itemID = item;
		end

		-- extract the name of the item
		for text in string.gfind(itemLink, LOOTSTER_ITEMTEXT_PATTERN) do
			itemText = text;
		end

		-- extract the item link information
		for itemLink in string.gfind(itemLink, LOOTSTER_ITEMLINK_PATTERN) do
			-- set tooltip owner
			Lootster_Tooltip:SetOwner(UIParent, "ANCHOR_NONE");

			-- process the item for class restrictions by getting the game tooltip to parse prepare the data
			Lootster_Tooltip:SetHyperlink(itemLink);

			-- hammer through the tooltip text items looking for any class restrictions
			for ix=1, 30, 1 do
				-- get left text field (the prompt)
				field = getglobal("Lootster_TooltipTextLeft"..ix);

				if ((field ~= nil) and field:IsShown()) then
					text = field:GetText();

					-- if we have a line break, end processing to prevent processing the restrictions on the item
					-- that is produced by this item
					if (string.sub(text, 1, 1) == "\n") then
						text = nil;

						ix = 30;
					end
				else
					text = nil;
				end

				-- do we have text?
				if (text ~= nil) then
					-- see if it is a singluar class qualifiers
					_, _, singulars = string.find(text, LOOTSTER_CLASSES_PATTERN);

					if (singulars ~= nil) then
						-- hmm, dude is class restricted and locked
						restricted = true;
						restrictedLock = true;

						-- okay, snarf out the classes in singluar
						for singular in string.gfind(singulars, LOOTSTER_CLASS_PATTERN) do
							-- we have an invariant for this guy?
							if (Lootster_ClassSingular[singular] ~= nil) then
								-- map this singular to the invariant
								class = Lootster_ClassSingular[singular];

								-- class allowed
								restrictions[class] = true;

								-- add to mask
								restrictionsMask = bit.bor(restrictionsMask, LOOTSTER_CLASS[class].Mask);

								-- bump count
								table.setn(restrictions, table.getn(restrictions) + 1);
							end
						end
					end
				end
			end

			-- did we find class restrictions on the item?
			if (restricted == false) then
				-- no, so see if we have quest imposed class restrictions
				if		(LOOTSTER_CLASS_LOOT[itemText] ~= nil) then
					-- hmm, dude should be class restricted and locked
					restricted = true;
					restrictedLock = true;

					classes = LOOTSTER_CLASS_LOOT[itemText];
				elseif	((itemID ~= nil) and (Lootster_Restrict[itemID] ~= nil)) then
					-- hmm, dude should be class restricted but is not locked
					restricted = true;
					restrictedLock = false;

					classes = Lootster_Restrict[itemID].Classes;
				end

				-- did we find some class restrictions?
				if (restricted == true) then
					-- get each restriction.  Note that faction classes will be ignored when later processed
					for ix, class in ipairs(classes) do
						-- class allowed
						restrictions[class] = true;

						-- add to mask if on
						restrictionsMask = bit.bor(restrictionsMask, LOOTSTER_CLASS[class].Mask);
					end

					-- set count
					table.setn(restrictions, table.getn(classes));
				end
			end
		end
	end

	return itemID, itemText, restricted, restrictedLock, restrictions, restrictionsMask;
end

-- Echo Item DKP handler
function Lootster_EchoItemDKP(requestor, itemkey)
	-- do we have DKP for this item?
	if (Lootster_ItemDKP[itemkey] ~= nil) then
		-- snarf it
		dkp = Lootster_ItemDKP[itemkey].DKP;

		-- send to the requestor
		Lootster_SendPrivate(requestor, string.format(LOOTSTER_ECHO_ITEMDKP, Lootster_ItemDKP[itemkey].DKP, itemkey, Lootster_ItemDKP[itemkey].Mob));
	end
end

-- Echo Player Adjustments handler
function Lootster_EchoPlayerAdjusts(requestor, playerkey, notpartied)
	local	main, dkp, reason;

	-- resolve the player into a main
	main = Lootster_GetALTMain(playerkey);

	-- use sorted list of adjustments
	for ix, recIx in ipairs(Lootster_AdjustSort) do
		-- our player?
		if (main == Lootster_Adjust[recIx].Player) then
			-- if total record we are done
			if (Lootster_Adjust[recIx].DKPAct == nil) then
				break;
			end

			-- get dkp and reason
			dkp = Lootster_Adjust[recIx].DKPAct;
			reason = Lootster_Adjust[recIx].Reason;

			-- we have the ability to whisper to a non-roster player
			if ((Lootster_Roster[requestor] ~= nil) or ((notpartied ~= nil) and (notpartied == true))) then
				-- send to the requestor
				Lootster_SendPrivate(requestor, string.format(LOOTSTER_ECHO_ADJUSTDKP, dkp, playerkey, reason));
			end
		end
	end

	-- whisper DKP information as well
	Lootster_EchoPlayerDKP(requestor, playerkey, notpartied);
end

-- Calculate Player DKP Positions handler
function Lootster_CalculatePositions()
	local	playerO, rosRecO, tierName, playerI, rosRecI, dkp, tier, prior, app, trial;
	local	testOT, testIT, testOP, testIP, tiers;

	local	count, ix;

	-- reset current tier list
	Lootster_Tiers = {};

	-- reset tiers count
	table.setn(Lootster_Tiers, 0);

	-- reset the tier sorts
	Lootster_TiersSort = {};

	-- reset record count
	table.setn(Lootster_TiersSort, 0);

	-- reset the tiers prompt
	Lootster_TiersPrompt = "";

	-- reset the roll roster
	Lootster_RosterRoll = {};

	-- prime the effective dkp and tier roll roster
	for playerO, rosRecO in pairs(Lootster_Roster) do
		-- see if this guy is class restricted
		if (((Lootster_NBG ~= LOOTSTER_NBG_NEED) or (Lootster_ClassRestricted == false)) or 
			((Lootster_ClassRestrictions[rosRecO.ClassType] ~= nil) and (Lootster_ClassRestrictions[rosRecO.ClassType] == true))) then
			-- get this guys dkp, tier and priority flags
			dkp = Lootster_GetPlayerDKP(playerO);
			tier = Lootster_GetPlayerTier(playerO);
			prior = Lootster_GetPlayerPriority(playerO);
			app, trial = Lootster_GetPlayerMembership(playerO);

			-- and add to the roll roster, along with initialised high and equal counts
			Lootster_RosterRoll[playerO] = { DKP=dkp, Tier=tier, App=app, Trial=trial, Priority=prior, High=0, Equal=0 };
		end
	end

	-- hammer through the roll roster, calculating player positions
	for playerO, rosRecO in pairs(Lootster_RosterRoll) do
		-- are we using DKP by Tier?
		if (Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
			-- create tier name
			tierName = Lootster_RosterRoll[playerO].Priority..Lootster_RosterRoll[playerO].Tier;

			-- count this tier
			if (Lootster_Tiers[tierName] == nil) then
				-- initial tier count
				Lootster_Tiers[tierName] = { TierName=tierName, Tier=rosRecO.Tier, App=rosRecO.App, Trial=rosRecO.Trial, Count=1 };

				-- bump count of tiers
				table.setn(Lootster_Tiers, table.getn(Lootster_Tiers) + 1);
			else
				-- bump tier count
				Lootster_Tiers[tierName].Count = Lootster_Tiers[tierName].Count + 1;
			end
		end

		-- hammer through the rest of the roll roster, determining if they have a higher or equal ranking
		for playerI, rosRecI in pairs(Lootster_RosterRoll) do
			-- DKP type determines ranking
			if		(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYDKP) then
				-- use DKP
				testOT = rosRecO.DKP > rosRecI.DKP;
				testIT = rosRecI.DKP > rosRecO.DKP;
			elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
				-- use Tier
				testOT = rosRecO.Tier < rosRecI.Tier;
				testIT = rosRecI.Tier < rosRecO.Tier;
			else
				-- roll is only test
				testOT = false;
				testIT = false;
			end

			-- see if DKP type will determine the outcome
			if		(testIT == true) then
				-- this guy is outranked by DKP type
				Lootster_RosterRoll[playerO].High = Lootster_RosterRoll[playerO].High + 1;
			elseif	((testOT == false) and (testIT == false)) then
				-- determine the priority
				testOP = Lootster_PriorityTest(rosRecO.App, rosRecO.Trial, rosRecI.App, rosRecI.Trial);
				testIP = Lootster_PriorityTest(rosRecI.App, rosRecI.Trial, rosRecO.App, rosRecO.Trial);

				-- see where this guy sits
				if		(testIP == true) then
					-- this guy is outranked by priority
					Lootster_RosterRoll[playerO].High = Lootster_RosterRoll[playerO].High + 1;
				elseif	((testOP == false) and (testIP == false) and (playerO ~= playerI)) then
					-- both are false, this guy is an equal (and not us!)
					Lootster_RosterRoll[playerO].Equal = Lootster_RosterRoll[playerO].Equal + 1;
				end
			end
		end
	end

	-- are we are using DKP?
	if (Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP) then
		-- are we using tiers?
		if (Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
			-- sort the tiers
			Lootster_Tier_Sort();

			-- build list of tiers
			count = table.getn(Lootster_Tiers);

			for ix=1, count, 1 do
				-- add name
				Lootster_TiersPrompt = Lootster_TiersPrompt..string.format(LOOTSTER_ECHO_TIERCOUNT, Lootster_Tiers[Lootster_TiersSort[ix]].TierName, Lootster_Tiers[Lootster_TiersSort[ix]].Count);

				if		(ix < (count - 1)) then
					Lootster_TiersPrompt = Lootster_TiersPrompt..LOOTSTER_MSG_SEP;
				elseif (ix == (count - 1)) then
					Lootster_TiersPrompt = Lootster_TiersPrompt..LOOTSTER_MSG_AND;
				end
			end

			-- format the tier breakdown prompt
			Lootster_TiersPrompt = string.format(LOOTSTER_ECHO_TIERBREAKDOWN, Lootster_TiersPrompt);
		end
	end
end

-- Echo Player DKP handler
function Lootster_EchoPlayerDKP(requestor, playerkey, notpartied)
	local	main;
	local	adj = 0;
	local	dkpBase = 0;
	local	tierBase = LOOTSTER_TIER_UNKNOWN;
	local	priorBase = "";

	-- resolve the player into a main
	main = Lootster_GetALTMain(playerkey);

	-- do we have DKP for this player?
	if (Lootster_DKP[main] ~= nil) then
		-- snarf base data
		dkpBase = Lootster_DKP[main].DKP;
		tierBase = Lootster_DKP[main].Tier
		priorBase = Lootster_DKP[main].Priority
		
		-- snarf adjustment data
		adj = Lootster_DKP[main].DKPAdj;
	end

	-- we have the ability to whisper to a non-roster player
	if ((Lootster_Roster[requestor] ~= nil) or ((notpartied ~= nil) and (notpartied == true))) then
		-- are we applying caps?
		local	dkpEffect, tierEffect, priorEffect;

		-- snarf effective data
		dkpEffect = Lootster_GetPlayerDKP(playerkey);
		tierEffect = Lootster_GetPlayerTier(playerkey);
		priorEffect = Lootster_GetPlayerPriority(playerkey);

		-- send to the requestor base and effective information
		Lootster_SendPrivate(requestor, string.format(LOOTSTER_ECHO_PLAYERDKP, dkpBase, priorBase, tierBase, dkpEffect, priorEffect, tierEffect, adj, playerkey));
	end		
end

-- Echo Player Roll handler
function Lootster_EchoPlayerRoll(requestor, noPos)
	-- we do nothing if the requestor is not in the party/raid
	if (Lootster_Roster[requestor] ~= nil) then
		local	dkp, roll;

		-- calculate the DKP and roll 
		dkp = Lootster_GetPlayerDKP(requestor);
		roll = Lootster_GetPlayerRoll(requestor);

		-- see which DKP type we are using
		if		((Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYDKP) or (Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER)) then
			local	high;
			local	equal;

			-- get the position
			high, equal = Lootster_GetPlayerPosition(requestor);

			-- by DKP or tier?
			if		(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYDKP) then
				local	prior;

				-- get the tier name
				prior = Lootster_GetPlayerPriority(requestor);

				-- send DKP statement to the requestor with position as required
				if ((noPos ~= nil) and (noPos == true)) then
					Lootster_SendPrivate(requestor, string.format(LOOTSTER_ECHO_PLAYERROLLDKP, prior, dkp, roll));
				else
					Lootster_SendPrivate(requestor, string.format(LOOTSTER_ECHO_PLAYERROLLDKPPOS, prior, dkp, high, equal, roll));
				end
			elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
				local	tier, prior;

				-- get the tier
				tier = Lootster_GetPlayerTier(requestor);
				prior = Lootster_GetPlayerPriority(requestor);

				-- send DKP statement to the requestor with position as required
				if ((noPos ~= nil) and (noPos == true)) then
					Lootster_SendPrivate(requestor, string.format(LOOTSTER_ECHO_PLAYERROLLTIER, dkp, prior, tier, roll));
				else
					Lootster_SendPrivate(requestor, string.format(LOOTSTER_ECHO_PLAYERROLLTIERPOS, dkp, prior, tier, high, equal, roll));
				end
			end
		elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYMODIFIED) then
			-- send DKP statement to the requestor
			Lootster_SendPrivate(requestor, string.format(LOOTSTER_ECHO_PLAYERROLLMODIFIED, dkp, roll));
		end
	end
end

-- Sort Rolls handler
function Lootster_Roll_Sort()
	local	ix = 1;

	-- initialise the roll indirection table
	table.setn(Lootster_RollsSort, table.getn(Lootster_Rolls));

	for key, value in pairs(Lootster_Rolls) do
		Lootster_RollsSort[ix] = key;
		ix = ix + 1;
	end

	-- sort the roll data on the roll
	table.sort(Lootster_RollsSort, Lootster_RollTest);
end

-- Roll Test handler
function Lootster_RollTest(i1, i2)
	local	r1, r2;

	-- retrieve indirected roll data
	r1 = Lootster_Rolls[i1].Roll;
	r2 = Lootster_Rolls[i2].Roll;

	-- preprocess nil and passed rolls
	if		((r1 == nil) and (r2 == nil)) then
		-- both haven't rolled, which means that we will still sort them as usual, but by setting roll to 
		-- zero so highest priority yet to roll player will appear first
		r1 = 0;
		r2 = 0;
	elseif	(r1 == nil) then
		return false;
	elseif	(r2 == nil) then
		return true;
	elseif	((r1 <= 0) and (r2 <= 0)) then
		-- both passed, which means that we will still sort them as usual, but by negating rolls so highest
		-- priority/roll passed roller will appear first
		r1 = -r1;
		r2 = -r2;
	elseif	(r1 <= 0) then
		return false;
	elseif	(r2 <= 0) then
		return true;
	end

	-- handle sort based on roll mode, type and the rolls themselves 
	if		(Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USEDKP) then
		-- test using a DKP method
		if		(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYDKP) then
			local	d1, d2;
			local	pa1, pa2;
			local	pt1, pt2;

			-- DKP then priority then roll.  Retrieve DKP and priority data
			d1 = Lootster_Rolls[i1].DKP;
			d2 = Lootster_Rolls[i2].DKP;
			pa1 = Lootster_Rolls[i1].App;
			pa2 = Lootster_Rolls[i2].App;
			pt1 = Lootster_Rolls[i1].Trial;
			pt2 = Lootster_Rolls[i2].Trial;

			-- By DKP then priority
			if		(d1 ~= d2) then
				-- differing DKP so use it
				return d1 > d2;
			elseif (Lootster_PriorityTest(pa1, pt1, pa2, pt2) == false) then
				-- same priority, so use roll difference
				return r1 > r2;
			else
				-- priority must of made the difference
				return true;
			end
		elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYTIER) then
			local	t1, t2;
			local	pa1, pa2;
			local	pt1, pt2;

			-- By Tier then priority then roll.  Retrieve indirected tier and priority data
			t1 = Lootster_Rolls[i1].Tier;
			t2 = Lootster_Rolls[i2].Tier;
			pa1 = Lootster_Rolls[i1].App;
			pa2 = Lootster_Rolls[i2].App;
			pt1 = Lootster_Rolls[i1].Trial;
			pt2 = Lootster_Rolls[i2].Trial;

			-- do we have a tier difference?
			if		(t1 ~= t2) then
				-- lower tiers have higher priority
				return t1 < t2;
			elseif	(Lootster_PriorityTest(pa1, pt1, pa2, pt2) == false) then
				-- same priority, so use roll difference
				return r1 > r2;
			else
				-- tier and/or priority must of made the difference
				return true;
			end
		elseif	(Lootster_Options.DKPType == LOOTSTER_ENUM_DKP.BYMODIFIED) then
			local	pa1, pa2;
			local	pt1, pt2;

			-- By Modified Roll then priority
			pa1 = Lootster_Rolls[i1].App;
			pa2 = Lootster_Rolls[i2].App;
			pt1 = Lootster_Rolls[i1].Trial;
			pt2 = Lootster_Rolls[i2].Trial;

			-- if priority show no change, decide by roll
			if (Lootster_PriorityTest(pa1, pt1, pa2, pt2) == false) then
				-- same priority, so use roll difference
				return r1 > r2;
			else
				-- tier and/or priority must of made the difference
				return true;
			end
		else
			-- no idea what DKP type, so just use roll
			return r1 > r2;
		end
	elseif	(Lootster_Options.RollMode == LOOTSTER_ENUM_MODE.USENORM) then
		-- use Normal method
		if		(Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BY1001000) then
			local	p1, p2;

			-- Priority then roll.  Retrieve Priority data
			p1 = Lootster_Rolls[i1].Priority;
			p2 = Lootster_Rolls[i2].Priority;

			-- by priority, which is Need Before Greed
			if		(p1 ~= p2) then
				-- differing Priority so use it
				return p1 < p2;
			else
				-- same priority, so use roll difference
				return r1 > r2;
			end
		elseif	(Lootster_Options.NormType == LOOTSTER_ENUM_NORM.BYNEEDGREED) then
			-- just use roll difference
			return r1 > r2;
		else
			-- no idea what Normal type, so just use roll
			return r1 > r2;
		end
	else
		-- no idea what mode, so just use roll
		return r1 > r2;
	end
end

-- Roll Equal handler
function Lootster_RollEqual(i1, i2)
	-- they are equal if the roll test is the same with each switched
	return (not Lootster_RollTest(i1, i2)) and (not Lootster_RollTest(i2, i1));
end

-- Sort Tiers handler
function Lootster_Tier_Sort()
	local	ix = 1;

	-- initialise the tier indirection table
	table.setn(Lootster_TiersSort, table.getn(Lootster_Tiers));

	for key, value in pairs(Lootster_Tiers) do
		Lootster_TiersSort[ix] = key;
		ix = ix + 1;
	end

	-- sort the tier data on the tier and priority
	table.sort(Lootster_TiersSort, Lootster_TierTest);
end

-- Tier Test handler
function Lootster_TierTest(i1, i2)
	local	t1, t2;

	-- retrieve indirected tier data
	t1 = Lootster_Tiers[i1].Tier;
	t2 = Lootster_Tiers[i2].Tier;

	-- do the tiers differ?
	if		(t1 < t2) then
		-- first tier is higher
		return true;
	elseif	(t1 ~= t2) then
		-- first tier is lower
		return false;
	else
		-- tiers are equal - use priority test
		return Lootster_PriorityTest(Lootster_Tiers[i1].App, Lootster_Tiers[i1].Trial, Lootster_Tiers[i2].App, Lootster_Tiers[i2].Trial)
	end
end

-- Priority Test handler
function Lootster_PriorityTest(pa1, pt1, pa2, pt2)
	-- using Full/App/Trial priority and the rolls are the same.  Sort based on priority:
	--
	-- !A & !T Full
	--  A & !T Applicant Member
	--  A &  T Applicant and Trial Member
	-- !A &  T Trial Member
	--
	-- if priority not in use, there is no priority
	if		(Lootster_Options.DKPPrior == false) then
		-- no priority
		return false;
	elseif	((pa1 == pa2) and (pt1 == pt2)) then
		-- same priority, so no difference
		return false;
	elseif	(pa1 == pa2) then
		-- applicant flags equal - based on player 2's trial flag
		return pt2;
	elseif	(pt1 == pt2) then
		-- trial flags equal - based on player 2's applicant flag 
		return pa2;
	else
		-- all flags unequal - based on player 2's trial flag
		return pt2;
	end
end

-- Data DKP Test handler
function Lootster_DataDKPTest(i1, i2)
	local	d1, d2;

	-- retrieve indirected data
	d1 = Lootster_DKP[i1][Lootster_DKPSortCol];
	d2 = Lootster_DKP[i2][Lootster_DKPSortCol];

	-- are we sorting by player?
	if (Lootster_DKPSortCol == "Player") then
		-- indeed.  Get the alt if it is playing and sort on that
		d1 = Lootster_GetMainALT(d1);
		d2 = Lootster_GetMainALT(d2);
	end

	-- handle nil data first
	if		((d1 == nil) and (d2 == nil)) then
		return false;
	elseif	(d1 == nil) then
		return not Lootster_DKPSortOrd;
	elseif	(d2 == nil) then
		return Lootster_DKPSortOrd;
	elseif	(d1 == d2) then
		return false;
	else	
		return (d1 < d2) == Lootster_DKPSortOrd;
	end
end

-- Data Adjust Test handler
function Lootster_DataAdjustTest(i1, i2)
	local	p1, p2;
	local	d1, d2;
	local	e1, e2;

	-- retrieve adjustment player data
	p1 = Lootster_Adjust[i1].Player;
	p2 = Lootster_Adjust[i2].Player;

	-- if the players are different, just sort by name
	if (p1 ~= p2) then
		-- get the alt if it is playing and sort on that
		p1 = Lootster_GetMainALT(p1);
		p2 = Lootster_GetMainALT(p2);

		return p1 < p2;
	end

	-- retrieve adjustment DKP data
	d1 = Lootster_Adjust[i1].DKPAct;
	d2 = Lootster_Adjust[i2].DKPAct;

	-- handle nil data first
	if		((d1 == nil) and (d2 == nil)) then
		return false;
	elseif	(d1 == nil) then
		return false;
	elseif	(d2 == nil) then
		return true;
	else
		-- retrieve adjustment epochs
		e1 = Lootster_Adjust[i1].Epoch;
		e2 = Lootster_Adjust[i2].Epoch;

		-- we are not sorting the DKP adjustment, just which one was put in first
		return e1 < e2;
	end
end

-- Set Column Width handler
function Lootster_SetColWidth(width, frame)
	-- make sure we have a frame
	if (not frame) then
 		frame = this;
 	end

	-- force it's width
 	frame:SetWidth(width);

	-- and the text area
 	getglobal(frame:GetName().."Middle"):SetWidth(width - 9);
end

-- Set Hyperlink handler
function Lootster_SetHyperlink(link, slot)
	local	dkp, reason;

	-- process the item for class restrictions
	Lootster_ProcessRestrictions(link, slot);

	-- update the item prompt according to item count
	Lootster_UpdateItemPrompt();

	-- update the item text for the roll frame
	if (Lootster_ItemLink ~= nil) then
		Lootster_RollFrameItemText:SetText(Lootster_ItemLink);
	else
		Lootster_RollFrameItemText:SetText("");
	end

	-- update the item text for the roll frame if visible
	if (Lootster_RollFrameAssignLootFrame:IsVisible()) then
		-- retrieve default DKP and reason text
		dkp, reason = Lootster_ProcessAssignment();

		-- set default DKP value and reason
		Lootster_RollFrameAssignLootFrameDKP:SetNumber(dkp);
		Lootster_RollFrameAssignLootFrameReason:SetText(reason);
	end

	-- update the item text for the adjust DKP frame if visible
	if (Lootster_DataFrameAdjustDKPFrame:IsVisible()) then
		-- retrieve default DKP and reason text
		dkp, reason = Lootster_ProcessAssignment();

		-- set default DKP value and reason
		Lootster_DataFrameAdjustDKPFrameDKP:SetNumber(dkp);
		Lootster_DataFrameAdjustDKPFrameReason:SetText(reason);
	end
end

-- Update Item Prompt using Item Count
function Lootster_UpdateItemPrompt()
	-- how many items we rolling on?
	if (Lootster_ItemCount <= 1) then
		-- item prompt is item text
		Lootster_ItemPrompt = Lootster_ItemLink;
	else
		-- create item prompt using item count
		if (Lootster_ItemLink == nil) then
			-- create an item prompt
			Lootster_ItemPrompt = string.format(LOOTSTER_ECHO_ITEMS, Lootster_ItemCount);
		else
			-- create item text item prompt
			Lootster_ItemPrompt = string.format(LOOTSTER_ECHO_ITEMS_LINK, Lootster_ItemCount, Lootster_ItemLink);
		end
	end
end

-- Add Restriction to Table handler
function Lootster_AddRestriction(type, list, restriction)
	-- how we add this to the table depends on the NBG type
	if		(type == LOOTSTER_NBG_NEED) then
		local	class;

		-- get the invariant form of the class name
		class = Lootster_ClassPlural[restriction];

		-- is this class unknown or is duplicate?
		if ((class == nil) or (list[class] ~= nil)) then
			return true;
		end

		-- class in plural form - add invariant key
		list[class] = true;

		-- we need to take care of the entry count ourselves
		table.setn(list, table.getn(list) + 1);
	elseif	(type == LOOTSTER_NBG_TIED) then
		-- player in FIFO form
		table.insert(list, restriction);
	end

	return false;
end

-- Copy Record handler
function Lootster_CopyRecord(srcTable)
	local	desTable = {};
	local	ix, rec;

	-- hammer through table copying each record
	for ix, rec in srcTable do
		-- if this is an embedded table, recurse copying it
		if (type(rec) == "table") then
			-- copy the embedded table
			desTable[ix] = Lootster_CopyRecord(rec);
		else
			-- simply copy the value
			desTable[ix] = rec;
		end
	end

	-- set record count as appropriate
	table.setn(desTable, table.getn(srcTable));

	return desTable;
end

-- Append Trailing New Line/Carriage Return handler
function Lootster_AppendTrailingLineBreak(text)
	-- ensure that it has a trailing new line
	if (string.sub(text, -1, -1) ~= "\n") then
		text = text.."\n";
	end

	return text;
end

-- Remove Trailing New Line/Carriage Return handler
function Lootster_RemoveTrailingLineBreak(text)
	-- ensure that it has a trailing new line
	if (string.sub(text, -1) == "\n") then
		text = string.sub(text, 1, -2);
	end

	return text;
end
